#!/bin/sh
# Define which version of the sequencer to use \
  exec seqWish "$0"  ${1+"$@"}
#
#*************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: astoSubscribe.pan,v 1.1 2004/09/06 14:47:13 cguirao Exp $" 
#
# astoSubscribe.pan
#
# This file has been produced by the panel editor
#   version: panel.tcl,v 5.9
#   date   : Tue Nov 20 10:02:45 MET 2001
#
#      !!!!!!!!!!  DO NOT MANUALLY EDIT THIS FILE  !!!!!!!!! 
#
#--------------------------------------------------------------
#
global par gvar cv bcv actAreaHeight shArea panClassLib 
global geoCmdReply panClassLib panUsrProcs panUsrLib
global argv0 env panWidget panWidgetHlp panDbData cwp ckHeartBeat
global menu menuBar menuHelp ckMenuBar ckActBut ckShHelp ckCCS
# 
#  Get directory root of VLT, integration, current module. 
global VLTROOT INTROOT HOME

if {[catch {set VLTROOT $env(VLTROOT)}]} {set VLTROOT dummy}
if {[catch {set INTROOT $env(INTROOT)}]} {set INTROOT dummy}
if {[catch {set HOME    $env(HOME)}   ]} {set HOME    dummy}
# 
# Set auto_path 
# 

if { [file exist ../lib/libpanPublic.tcl] } { 
   lappend auto_path ../lib/libpanPublic.tcl
} elseif { [file exist $INTROOT/lib/libpanPublic.tcl ] } { 
   lappend auto_path $INTROOT/lib/libpanPublic.tcl
} elseif { [file exist $VLTROOT/lib/libpanPublic.tcl ] } { 
   lappend auto_path $VLTROOT/lib/libpanPublic.tcl 
} else {
   puts stderr "panel EXITS : Tcl library libpanPublic.tcl not found " 
   exit 1
}

set gvar(args) $argv

#
# Link panel to user libraries 
#
set panUsrLib   {}  
set panClassLib {}

panSetAutoPath  $panUsrLib $panClassLib 

if {[info exists EDITING]} { 
   set panRoot .astoSubscribe 
   set panUsrProcs {astoSubscribeInit astoSubscribeExit astoSubscribeInitData}
   set argc 0 ; set argv {}
} else {
   set par(MY_NAME) [file tail $argv0] 
   set EDITING 0
   set tk_strictMotif 0
   setPublicVar
   set panRoot . 
}

# User's Init Data : called just after panInit
# It contains data to be defined before widgets are created

proc astoSubscribeInitData {} {

 # Declare global variables

   global <var>

 # Statements to be executed when exiting
}



# User's Init Procedure : called in panMainStart
# It is executed after the widgets have been created

proc astoSubscribeInit {} {

 # Declare global variables

   global gvar

 # User Initialization
set gvar(remoteHost)  [lindex $gvar(hostlist) 0]
}



#
#-----------------------------------------------
#            Widget Definition  
#-----------------------------------------------
# 

set ckHeartBeat   0 ;# Enable Heart-beat
set ckShHelp      1 ;# Set Short Help
set ckActBut      0 ;# Set Action Button Area
set ckMenuBar     0 ;# Setup Menu Bar
set ckCCS         0 ;# Initialize CCS
set ckCmdReply    0 ;# Display Cmd. Reply
set cwp           "" ;# Set Current Working Point
set actAreaHeight 5; # Set height of action area 

panReadOption winter
panCreateFrame astoSubscribe ;# Create empty frame
panGetCvNames  astoSubscribe cv bcv ;# Get Canvas Names
panInit        $argc $argv astoSubscribe ;# Initialization



UifOptionButton    $cv.astoSubscribe-wdg1 -canvasAnchor nw  \
                  -itemList {FITS LOG OTH} -length 5  \
                  -selectMode label -variable gvar(fileCategory) 
UifOptionButton    $cv.astoSubscribe-wdg2 -canvasAnchor nw  \
                  -itemList $gvar(hostlist) -length 5 -selectMode label  \
                  -variable gvar(remoteHost) 
UifButton          $cv.astoSubscribe-wdg3 -canvasAnchor nw  \
                  -command {astoSubscribeAccept} -initialState normal  \
                  -label {Ok} -popup 0  \
                  -stateVar gvar(astoSubscribe-wdg6Var) -width 8 
UifButton          $cv.astoSubscribe-wdg4 -canvasAnchor nw  \
                  -command {astoSubscribeCancel} -initialState normal  \
                  -label {Cancel} -popup 0  \
                  -stateVar gvar(astoSubscribe-wdg7Var) -width 8 
UifEntry           $cv.dominoFromWdg -canvasAnchor nw -label {From}  \
                  -labelFont -Adobe-helvetica-medium-r-normal--14*  \
                  -labelWidth 0 -variable gvar(dominoFrom) -width 19 
UifEntry           $cv.dominoToWdg -canvasAnchor nw -label {To}  \
                  -labelFont -Adobe-helvetica-medium-r-normal--14*  \
                  -labelWidth 0 -variable gvar(dominoTo) -width 19 

#
#  Canvas Items
#

$cv create text 31 31 -tags "text astoSubscribe-item1" -anchor nw \
          -text "File Type" \
          -fill black -font -Adobe-helvetica-medium-r-normal--14* 

$cv create text 27 63 -tags "text astoSubscribe-item2" -anchor nw \
          -text "Hostname" \
          -fill black -font -Adobe-helvetica-medium-r-normal--14* 

$cv create text 3 0 -tags "text astoSubscribe-item3" -anchor nw \
          -text "---File Selection ------------" \
          -fill black -font -Adobe-helvetica-medium-r-normal--14* 

$cv create text 15 187 -tags "text astoSubscribe-item4" -anchor nw \
          -text "-----------------------" \
          -fill black -font -Adobe-helvetica-medium-r-normal--14* 

$cv create text 11 107 -tags "text astoSubscribe-item5" -anchor nw \
          -text "--- Date Selection----------" \
          -fill black -font -Adobe-helvetica-medium-r-normal--14* 


#
# Set Widget Configuration
#
set panWidget(astoSubscribe-wdg1)  {UifOptionButton 103 27 1 0 {} 0 0 fileCategory 0 {}}
set panWidget(astoSubscribe-wdg2)  {UifOptionButton 103 59 1 0 {} 0 0 remoteHost 0 {}}
set panWidget(astoSubscribe-wdg3)  {UifButton 35 207 1 0 0 0 0 astoSubscribe-wdg6Var 0 {}}
set panWidget(astoSubscribe-wdg4)  {UifButton 131 207 1 0 0 0 0 astoSubscribe-wdg7Var 0 {}}
set panWidget(dominoFromWdg)  {UifEntry 0 131 1 0 {} 0 0 dominoFrom 0 A {} {} 0 0 0 0}
set panWidget(dominoToWdg)  {UifEntry 15 155 1 0 {} 0 0 dominoTo 0 A {} {} 0 0 0 0}

#
# Set Database Configuration
#

#
# Set Short Help for each widget
#
set panWidgetHlp(astoSubscribe-wdg1)  {Select a file type}
set panWidgetHlp(astoSubscribe-wdg2)  {Connect to a specific host.}
set panWidgetHlp(dominoFromWdg)  {<YYYY-MM-DD>T<hh:mm:ss>}
set panWidgetHlp(dominoToWdg)  {<YYYY-MM-DD>T<hh:mm:ss>}

#
#-----------------------------------------------
#            Create the Panel  
#-----------------------------------------------
#

wm geometry  $panRoot 237x288
wm title     $panRoot "ASTO Subscribe"
set par(TITLE) "ASTO Subscribe" 

panMainStart  astoSubscribe $argc $argv

#--------------------    End of Main   --------------------



#####################################################
#           Definition of Local Procedures
#####################################################


proc astoSubscribeExit {} {

 # Declare global variables

   global <var>

 # Statements to be executed when exiting
}
