#!/bin/sh
# Define which version of the sequencer to use \
  exec seqWish "$0"  ${1+"$@"}
#
#*************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: dataSubscriber.pan,v 1.1 2004/09/06 14:47:13 cguirao Exp $" 
#
# dataSubscriber.pan
#
# This file has been produced by the panel editor
#   version: panel.tcl,v 5.2
#   date   : Mon Jul 24 15:16:40 METDST 2000
#
#      !!!!!!!!!!  DO NOT MANUALLY EDIT THIS FILE  !!!!!!!!! 
#
#--------------------------------------------------------------
#
global par gvar cv bcv actAreaHeight shArea panClassLib 
global geoCmdReply panClassLib panUsrProcs panUsrLib
global argv0 env panWidget panWidgetHlp panDbData cwp ckHeartBeat
global menu menuBar menuHelp ckMenuBar ckActBut ckShHelp ckCCS
# 
#  Get directory root of VLT, integration, current module. 
global VLTROOT INTROOT HOME

if {[catch {set VLTROOT $env(VLTROOT)}]} {set VLTROOT dummy}
if {[catch {set INTROOT $env(INTROOT)}]} {set INTROOT dummy}
if {[catch {set HOME    $env(HOME)}   ]} {set HOME    dummy}
# 
# Set auto_path 
# 

if { [file exist ../lib/libpanPublic.tcl] } { 
   lappend auto_path ../lib/libpanPublic.tcl
} elseif { [file exist $INTROOT/lib/libpanPublic.tcl ] } { 
   lappend auto_path $INTROOT/lib/libpanPublic.tcl
} elseif { [file exist $VLTROOT/lib/libpanPublic.tcl ] } { 
   lappend auto_path $VLTROOT/lib/libpanPublic.tcl 
} else {
   puts stderr "panel EXITS : Tcl library libpanPublic.tcl not found " 
   exit 1
}
set gvar(args) $argv
#
# Link panel to user libraries 
#
set panUsrLib   libhtLib  
set panClassLib {}

panSetAutoPath  $panUsrLib $panClassLib 

if {[info exists EDITING]} { 
   set panRoot .dataSubscriber 
   set panUsrProcs {dataSubscriberInit dataSubscriberExit dataSubscriberGlobalData dataSubscriberInitData}
   set argc 0 ; set argv {}
} else {
   set par(MY_NAME) [file tail $argv0] 
   set EDITING 0
   set tk_strictMotif 0
   setPublicVar
   set panRoot . 
}

# User's Global Data 
# It contains definitions of constant data

proc dataSubscriberGlobalData {} {

 # Declare any variable as global

   global gvar

 # Variable Initialization

 #Set here the color for the bitmaps
	
 set gvar(hotSpotCol) grey
}



# User's Init Data : called just after panInit
# It contains data to be defined before widgets are created

proc dataSubscriberInitData {} {

 # Declare global variables

   global gvar cv

#return
setOptions


 # Statements to be executed when exiting
}



# User's Init Procedure : called in panMainStart
# It is executed after the widgets have been created

proc dataSubscriberInit {} {

 # Declare global variables

   global gvar cv mainCV

set rawImage [image create photo -file [findVLTFile bitmaps/raw.gif] -palette 256]
set redImage [image create photo -file [findVLTFile bitmaps/reduced.gif] -palette 256]

$cv.dominoNttWdgRAW component uifBitmap configure -image  $rawImage
$cv.dominoNttWdgRED component uifBitmap configure -image  $redImage

 # User Initialization
#return
#setOptions
dominoInitX
}



#
#-----------------------------------------------
#            Widget Definition  
#-----------------------------------------------
# 

set ckHeartBeat   0 ;# Enable Heart-beat
set ckShHelp      0 ;# Set Short Help
set ckActBut      0 ;# Set Action Button Area
set ckMenuBar     1 ;# Setup Menu Bar
set ckCCS         0 ;# Initialize CCS
set ckCmdReply    0 ;# Display Cmd. Reply
set cwp           "" ;# Set Current Working Point
set actAreaHeight 5; # Set height of action area 

panReadOption winter
set par(PANELX) 619 ;# Panel X position
set par(PANELY) 145 ;# Panel Y position
panCreateFrame dataSubscriber ;# Create empty frame
panGetCvNames  dataSubscriber cv bcv ;# Get Canvas Names
panInit        $argc $argv dataSubscriber ;# Initialization



UifOutput          $cv.dataSubscriber-wdg1 -anchor e -canvasAnchor nw  \
                  -color Black -font -Adobe-courier-bold-r-normal--24*  \
                  -frame 0  \
                  -labelFont -Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*  \
                  -labelWidth 0 -variable gvar(filesQueuedRED) -width 5 
UifOutput          $cv.dataSubscriber-wdg2 -anchor e -canvasAnchor nw  \
                  -color Black -font -Adobe-courier-bold-r-normal--24*  \
                  -frame 0  \
                  -labelFont -Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*  \
                  -labelWidth 0 -variable gvar(filesArrivedRED) -width 5 
UifOutput          $cv.dataSubscriber-wdg3 -anchor e -canvasAnchor nw  \
                  -color Black -font -Adobe-courier-bold-r-normal--24*  \
                  -frame 0  \
                  -labelFont -Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*  \
                  -labelWidth 0 -variable gvar(filesQueuedRAW) -width 5 
UifOutput          $cv.dataSubscriber-wdg4 -anchor center  \
                  -canvasAnchor nw -color Black  \
                  -font -Adobe-courier-medium-r-normal--12* -frame 0  \
                  -labelFont -Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*  \
                  -labelWidth 0 -variable gvar(fromToLabelRAW) -width 24 
UifOutput          $cv.dataSubscriber-wdg5 -anchor center  \
                  -canvasAnchor nw -color Black  \
                  -font -Adobe-courier-medium-r-normal--12* -frame 0  \
                  -labelFont -Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*  \
                  -labelWidth 0 -variable gvar(fromToLabelRED) -width 24 
UifButton          $cv.dataSubscriber-wdg6 -canvasAnchor nw  \
                  -command {dominoClose} -initialState normal -label {Quit}  \
                  -popup 0 -stateVar gvar(dataSubscriber-wdg23Var)  \
                  -width 20 
UifOutput          $cv.dataSubscriber-wdg7 -anchor e -canvasAnchor nw  \
                  -color Black -font -Adobe-courier-bold-r-normal--24*  \
                  -frame 0  \
                  -labelFont -Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*  \
                  -labelWidth 0 -variable gvar(filesArrivedRAW) -width 5 
UifFrame           $cv.dataSubscriber-wdg8 -canvasAnchor nw -height 5  \
                  -width 415 
UifFrame           $cv.dataSubscriber-wdg9 -canvasAnchor nw -height 250  \
                  -width 5 
UifBarChart        $cv.dataSubscriberBarchartWdgRAW -axis 0  \
                  -canvasAnchor nw -length 180 -maxVal 100 -minVal 0  \
                  -orient h -ticks 1 -variable gvar(percRAW) 
UifBarChart        $cv.dataSubscriberBarchartWdgRED -axis 0  \
                  -canvasAnchor nw -length 180 -maxVal 100 -minVal 0  \
                  -orient h -ticks 1 -variable gvar(percRED) 
UifButton          $cv.dominoConfigWdg -canvasAnchor nw  \
                  -command {set gvar(fileType) RAW ; dominoEditPrefs RAW}  \
                  -initialState normal -label {Config} -popup 0  \
                  -stateVar gvar(dataSubscriber-wdg10Var) -width 20 
UifBitmap          $cv.dominoNttWdgRAW -canvasAnchor nw -frame ridge  \
                  -hotSpot 0 -hotSpotColor Red 
UifBitmap          $cv.dominoNttWdgRED -canvasAnchor nw -frame ridge  \
                  -hotSpot 0 -hotSpotColor Red 
UifButton          $cv.dominoShowLogWdgRAW -canvasAnchor nw  \
                  -command {showLog RAW} -initialState normal  \
                  -label {Show Log} -popup 0  \
                  -stateVar gvar(dataSubscriber-wdg11Var) -width 10 
UifButton          $cv.dominoShowLogWdgRED -canvasAnchor nw  \
                  -command {showLog RED} -initialState normal  \
                  -label {Show Log} -popup 0  \
                  -stateVar gvar(dataSubscriber-wdg11Var) -width 10 
UifButton          $cv.dominoStartWdgRAW -canvasAnchor nw  \
                  -command {Start RAW} -initialState normal  \
                  -label {Start RAW} -popup 0  \
                  -stateVar gvar(dataSubscriber-wdg2Var) -width 10 
UifButton          $cv.dominoStartWdgRED -canvasAnchor nw  \
                  -command {Start RED} -initialState normal  \
                  -label {Start RED} -popup 0  \
                  -stateVar gvar(dataSubscriber-wdg2Var) -width 10 
UifButton          $cv.dominoStopWdgRAW -canvasAnchor nw  \
                  -command {Stop RAW} -initialState normal -label {Stop}  \
                  -popup 0 -stateVar gvar(dataSubscriber-wdg3Var)  \
                  -width 10 
UifButton          $cv.dominoStopWdgRED -canvasAnchor nw  \
                  -command {Stop RED} -initialState normal -label {Stop}  \
                  -popup 0 -stateVar gvar(dataSubscriber-wdg3Var)  \
                  -width 10 
UifOutput          $cv.fromToRawWdg -anchor center -canvasAnchor nw  \
                  -color Black -font -Adobe-courier-medium-r-normal--12*  \
                  -frame 0  \
                  -labelFont -Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*  \
                  -labelWidth 0 -variable gvar(fromToLabelRED) -width 24 

#
#  Canvas Items
#

$cv create text 132 104 -tags "text dataSubscriber-item1" -anchor nw \
          -text "Delivered" \
          -fill black -font -Adobe-helvetica-medium-r-normal--12* 

$cv create text 48 104 -tags "text dataSubscriber-item2" -anchor nw \
          -text "Queued" \
          -fill black -font -Adobe-helvetica-medium-r-normal--12* 

$cv create text 260 104 -tags "text dataSubscriber-item3" -anchor nw \
          -text "Queued" \
          -fill black -font -Adobe-helvetica-medium-r-normal--12* 

$cv create text 340 104 -tags "text dataSubscriber-item4" -anchor nw \
          -text "Delivered" \
          -fill black -font -Adobe-helvetica-medium-r-normal--12* 


#
# Set Widget Configuration
#
set panWidget(dataSubscriber-wdg1)  {UifOutput 224 116 1 0 0 0 0 filesQueuedRED 0 {} {}}
set panWidget(dataSubscriber-wdg2)  {UifOutput 312 116 1 0 0 0 0 filesArrivedRED 0 {} {}}
set panWidget(dataSubscriber-wdg3)  {UifOutput 12 116 1 0 0 0 0 filesQueuedRAW 0 {} {}}
set panWidget(dataSubscriber-wdg4)  {UifOutput 12 214 1 0 0 0 0 fromToLabelRAW 0 {} {}}
set panWidget(dataSubscriber-wdg5)  {UifOutput 0 420 1 0 0 0 0 fromToLabelRED 0 {} {}}
set panWidget(dataSubscriber-wdg6)  {UifButton 19.999999999999996 267.99999999999994 1 0 0 0 0 {} 0 {}}
set panWidget(dataSubscriber-wdg7)  {UifOutput 104 116 1 0 0 0 0 filesArrivedRAW 0 {} {}}
set panWidget(dataSubscriber-wdg8)  {UifFrame 0.0 248.0 1 0 0 0 0 {} 0 0}
set panWidget(dataSubscriber-wdg9)  {UifFrame 204 0 1 0 0 0 0 {} 0 0}
set panWidget(dataSubscriberBarchartWdgRAW)  {UifBarChart 12 152 1 0 0 0 0 percRAW 0 0 0 100 0 0}
set panWidget(dataSubscriberBarchartWdgRED)  {UifBarChart 224 152 1 0 0 0 0 percRED 0 0 0 100 0 0}
set panWidget(dominoConfigWdg)  {UifButton 219.99999999999997 267.99999999999994 1 0 0 0 0 {} 0 {}}
set panWidget(dominoNttWdgRAW)  {UifBitmap 108.0 4.0 1 0 0 0 0 {} 0 raw.xbm}
set panWidget(dominoNttWdgRED)  {UifBitmap 216.0 4.0 1 0 0 0 0 {} 0 reduced.xbm}
set panWidget(dominoShowLogWdgRAW)  {UifButton 4.0 60.0 1 0 0 0 0 {} 0 {}}
set panWidget(dominoShowLogWdgRED)  {UifButton 320.0 60.0 1 0 0 0 0 {} 0 {}}
set panWidget(dominoStartWdgRAW)  {UifButton 4 4 1 0 0 0 0 {} 0 {}}
set panWidget(dominoStartWdgRED)  {UifButton 320 4 1 0 0 0 0 {} 0 {}}
set panWidget(dominoStopWdgRAW)  {UifButton 4 32 1 0 0 0 0 {} 0 {}}
set panWidget(dominoStopWdgRED)  {UifButton 320 32 1 0 0 0 0 {} 0 {}}
set panWidget(fromToRawWdg)  {UifOutput 224 212 1 0 0 0 0 fromToLabelRED 0 {} {}}

#
# Set Database Configuration
#

#
# Set Short Help for each widget
#

#
#-----------------------------------------------
#           Menu Bar Definition  
#-----------------------------------------------
# 

set menu(0) {File 1 file}


# Add MenuButton < File > 

set mb [addMenuButton $menuBar file " File " -1 left]

# Menu  

addMenuCmd $mb "New Program ID" 0 {wm withdraw . ; dominoImportPanel subInfo}
addMenuCmd $mb "View Filename Table" 0 {dsLookUpView}
addMenuCmd $mb "Quit" 0 {dominoClose}

#
#-----------------------------------------------
#           Menu Help Definition  
#-----------------------------------------------
# 

set menuHelp(.dataSubscriber.topMenu.menu.file.menu) { \
    {} {Change the Program ID} {} {} {}  \
} 


#
#-----------------------------------------------
#            Create the Panel  
#-----------------------------------------------
#

wm geometry  $panRoot 414x346
wm title     $panRoot "DataSubscriber"
set par(TITLE) "DataSubscriber" 

panMainStart  dataSubscriber $argc $argv

#--------------------    End of Main   --------------------



#####################################################
#           Definition of Local Procedures
#####################################################


proc dataSubscriberExit {} {

 # Declare global variables

   global <var>

 # Statements to be executed when exiting
}
