#!/bin/sh
# Define which version of the sequencer to use \
  exec seqWish "$0"  ${1+"$@"}
#
#*************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: dsLookup.pan,v 1.1 2004/09/06 14:47:13 cguirao Exp $" 
#
# dsLookup.pan
#
# This file has been produced by the panel editor
#   version: panel.tcl,v 4.10+
#   date   : Mon Nov 30 18:26:22 MET 1998
#
#      !!!!!!!!!!  DO NOT MANUALLY EDIT THIS FILE  !!!!!!!!! 
#
#--------------------------------------------------------------
#
global par gvar cv bcv actAreaHeight shArea panClassLib 
global geoCmdReply panClassLib panUsrProcs panUsrLib
global argv0 env panWidget panWidgetHlp panDbData cwp ckHeartBeat
global menu menuBar menuHelp ckMenuBar ckActBut ckShHelp ckCCS
# 
#  Get directory root of VLT, integration, current module. 
global VLTROOT INTROOT HOME

if {[catch {set VLTROOT $env(VLTROOT)}]} {set VLTROOT dummy}
if {[catch {set INTROOT $env(INTROOT)}]} {set INTROOT dummy}
if {[catch {set HOME    $env(HOME)}   ]} {set HOME    dummy}
# 
# Set auto_path 
# 

if { [file exist ../lib/libpanPublic.tcl] } { 
   lappend auto_path ../lib/libpanPublic.tcl
} elseif { [file exist $INTROOT/lib/libpanPublic.tcl ] } { 
   lappend auto_path $INTROOT/lib/libpanPublic.tcl
} elseif { [file exist $VLTROOT/lib/libpanPublic.tcl ] } { 
   lappend auto_path $VLTROOT/lib/libpanPublic.tcl 
} else {
   puts stderr "panel EXITS : Tcl library libpanPublic.tcl not found " 
   exit 1
}

#
# Link panel to user libraries 
#
set panUsrLib   libhtLib  
set panClassLib {}

panSetAutoPath  $panUsrLib $panClassLib 

if {[info exists EDITING]} { 
   set panRoot .dsLookup 
   set panUsrProcs {dsLookupInit dsLookupExit dsLookupInitData}
   set argc 0 ; set argv {}
} else {
   set par(MY_NAME) [file tail $argv0] 
   set EDITING 0
   set tk_strictMotif 0
   setPublicVar
   set panRoot . 
}

# User's Init Data : called just after panInit
# It contains data to be defined before widgets are created

proc dsLookupInitData {} {

 # Declare global variables

   global <var>

 # Statements to be executed when exiting
}



# User's Init Procedure : called in panMainStart
# It is executed after the widgets have been created

proc dsLookupInit {} {

 # Declare global variables

   global cv

 # User Initialization
[$cv.lookupTableWdg component uifFancyListBox] configure -font 9x15
dsLookupInitX
}



#
#-----------------------------------------------
#            Widget Definition  
#-----------------------------------------------
# 

set ckHeartBeat   0 ;# Enable Heart-beat
set ckShHelp      1 ;# Set Short Help
set ckActBut      0 ;# Set Action Button Area
set ckMenuBar     0 ;# Setup Menu Bar
set ckCCS         0 ;# Initialize CCS
set ckCmdReply    0 ;# Display Cmd. Reply
set cwp           "" ;# Set Current Working Point
set actAreaHeight 5; # Set height of action area 

panReadOption winter
panCreateFrame dsLookup ;# Create empty frame
panGetCvNames  dsLookup cv bcv ;# Get Canvas Names
panInit        $argc $argv dsLookup ;# Initialization



UifButton          $cv.dsLookup-wdg1 -canvasAnchor nw -command lookupUpdate \
                   -initialState normal -label Update -popup 0 \
                   -stateVar gvar(dsLookup-wdg5Var) -width 15
UifButton          $cv.dsLookup-wdg2 -canvasAnchor nw -command dsLookupClose \
                   -initialState normal -label Close -popup 0 \
                   -stateVar gvar(dsLookup-wdg6Var) -width 15
UifOutput          $cv.dsLookupHdrWdg -anchor w -canvasAnchor nw \
                   -color Black -font -Adobe-courier-medium-r-normal--14* \
                   -frame 0 -labelFont -Adobe-helvetica-medium-r-normal--14* \
                   -labelWidth 0 -variable gvar(dsLookupHdr) -width 62
UifFancyListBox    $cv.lookupTableWdg -activebackground Black \
                   -background Gray80 -borderwidth 2 \
                   -font -Adobe-helvetica-medium-r-normal--14* \
                   -geometry 68x5 -height 24 -initialState normal \
                   -relief sunken -scrollx 1 -scrolly 1 -selectmode single \
                   -wrap none

#
#  Canvas Items
#


#
# Set Widget Configuration
#
set panWidget(dsLookup-wdg1)  {UifButton 152.0 420.0 1 0 0 0 0 {} 0 {}}
set panWidget(dsLookup-wdg2)  {UifButton 368.0 420.0 1 0 0 0 0 {} 0 {}}
set panWidget(dsLookupHdrWdg)  {UifOutput 20 4 1 0 0 0 0 dsLookupHdr 0 {} {}}
set panWidget(lookupTableWdg)  {PubClass 12.0 28.0 1 0 libhtLib.tcl nw 0 {} 0}

#
# Set Database Configuration
#

#
# Set Short Help for each widget
#
set panWidgetHlp(dsLookup-wdg1)  {Read the Filename Table}
set panWidgetHlp(dsLookup-wdg2)  {Close the panel}
set panWidgetHlp(lookupTableWdg)  {Show corrispondence between DFS namede files and renamed files.}

#
#-----------------------------------------------
#            Create the Panel  
#-----------------------------------------------
#

wm geometry  $panRoot 651x506
wm title     $panRoot "DS LookUp table"
set par(TITLE) "DS LookUp table" 

panMainStart  dsLookup $argc $argv

#--------------------    End of Main   --------------------



#####################################################
#           Definition of Local Procedures
#####################################################


proc dsLookupExit {} {

 # Declare global variables

   global <var>

 # Statements to be executed when exiting
}
