package org.eso.ohs.phase2.apps.masktracker;

import org.apache.log4j.Logger;
import org.eso.ohs.core.dbb.client.DbbSelectionList;
import org.eso.ohs.core.dbb.sql.DbbSqlChunk;
import org.eso.ohs.core.dbb.sql.DbbSqlOperator;
import org.eso.ohs.dfs.Mask;
import org.eso.ohs.dfs.Queue;
import org.eso.ohs.phase2.apps.ot.dbb.BrowserConfig;



/**
 * The QueueItemsBView class is a DB search engine used for 
 * displaying queues of OBs according to a user-definable set of 
 * properties
 * @author G Passera
 * @author Tim Canavan 
 * @author cmavros Add call to unsubscribe execution action.
 * @author cmavros 1709/OT Call ExecutionSequenceAction 
 *               class to implement progress bar
 *
 * @version $Id: MaskInsertedQueueBrowser.java,v 1.23 2007/10/11 11:43:12 pnunes Exp $
 *
 * @author cmavros Add call to unsubscribe execution action.
 * @author cmavros 1709/OT Call ExecutionSequenceAction 
 *               class to implement progress bar
 *
 * @version $Id: MaskInsertedQueueBrowser.java,v 1.23 2007/10/11 11:43:12 pnunes Exp $
 *
 */

public class MaskInsertedQueueBrowser extends DefaultMaskBrowser  {

    private static Logger stdlog_ =
	Logger.getLogger(MaskInsertedQueueBrowser.class );
   
  

  /**
   * Default constructor
   *
   */
    public MaskInsertedQueueBrowser(Queue newQueue,
    		MaskExecSequence maskExecSequence,MaskQueueView mkView) {
	    super(newQueue,maskExecSequence,mkView);
	    appendRows();
	    
    }

     private void appendRows() {
        DbbSqlOperator op_in = null;
        try {
            op_in = new DbbSqlOperator("in");
        }
        catch( Exception e ) { 
            stdlog_.error( e ); 
        }
        String label_name = "Status";
        String column_name = "mask_status";
        DbbSqlChunk c = new DbbSqlChunk(BrowserConfig.masks_table, column_name, label_name, op_in, String.class);
        Object[] statusValues = {Mask.MASK_MANUFACTURED,Mask.PENDING_INSERTION,Mask.MASK_INSERTED};
        String[] statusDispValues = {Mask.getDisplayStatusValue(Mask.MASK_MANUFACTURED),
                                     Mask.getDisplayStatusValue(Mask.PENDING_INSERTION),
                                     Mask.getDisplayStatusValue(Mask.MASK_INSERTED)};
        DbbSelectionList status = new DbbSelectionList(label_name, c,statusValues, statusDispValues);
        rowPanel_.addWidget(status);
        status.set("(" + "'" + Mask.MASK_MANUFACTURED + "'" + ",'" + Mask.PENDING_INSERTION + ",'" + Mask.MASK_INSERTED + "'"+ ")");
        status.fireDbbWidgetAction();
        getDbbView().setWherePanel(rowPanel_, "North");
    }

 


    
}
