package org.eso.ohs.phase2.apps.masktracker;

// $Id: MaskQueueBrowser.java,v 1.13 2004/04/06 11:37:19 tcanavan Exp $

import org.eso.ohs.core.dbb.client.DbbTextField;
import org.eso.ohs.core.dbb.server.DbbSqlEngineImpl;
import org.eso.ohs.core.dbb.sql.DbbSqlChunk;
import org.eso.ohs.core.dbb.sql.DbbSqlOperator;
import org.eso.ohs.core.dbb.sql.DbbSqlTable;


/**
 * This Browser class only browses masks that are specific to 
 * a given Queue from within the OT
 */

public class MaskQueueBrowser extends MaskBrowser {

    /**
     *  Schedule Items table
     */

     protected DbbSqlTable schedItemTable;
     /**
      * OT schedule talbe 
      */
     protected DbbSqlTable otSchedTable;

     /**
      * Queue ID
      */

     protected DbbTextField queueIdText_;

     /** 
      * Queue id
      */
     private long queueId_;


     /**
      * Name of Queue
      */
     String name_;
   
    /**
     * Create an object setting all its internal variable. The
     * constructor, invoking the private method buildSqlEngine,
     * creates the associated sql engine (DbbLocalEngine implements
     * the DbbSqlEngine interface) connecting to the RMI server.
     */
    public MaskQueueBrowser() {
       
    }


    /**
     * Mask Queue Browser 
     * @param queueId Queue id for queue Business Object
     * @param name Name of queue
     */

    public MaskQueueBrowser(long queueId,String name) {       
        super();       
        queueIdText_.set(new Integer((int)queueId));
        queueIdText_.setEnabled(false);       
        setTitle("Masks for Queue " + name);
    }


    /**
     * Build rows
     */
  
    protected void buildRows() {
        super.buildRows();     
	// Define a default operator
	DbbSqlOperator op_equal = null;

	try {
	    op_equal = new DbbSqlOperator("=");
	}
	catch(Exception e) { 
	    e.printStackTrace(); 
	}
        String label_name = "Schedule ID";
        String column_name = "sch_id";

        DbbSqlChunk c = new DbbSqlChunk(schedItemTable,
			column_name,
			label_name,
			op_equal,
			Integer.class);
        queueIdText_ = new DbbTextField( label_name , c );      
        selPanel.addWidget(queueIdText_);       
    }


    /**
     * Build Tables
     */

    protected void buildTables() {
        super.buildTables();
	schedItemTable = new DbbSqlTable(dbNamePhase2,
				     dbOwner,
				     "schedule_items");
        otSchedTable = new DbbSqlTable(dbNamePhase2,
				     dbOwner,
				     "schedules");

    }


    /** 
     * Set SQL Defaults
     */
    protected void setSqlDefaults() throws Exception {
        super.setSqlDefaults();
        ((DbbSqlEngineImpl)engine_).addJoinCondition(schedItemTable,"ob_id",masksTable,"ob_id",schedItemTable,masksTable);
    }
}



