package org.eso.ohs.phase2.apps.masktracker.actions;

import java.awt.event.ActionEvent;
import java.sql.SQLException;

import javax.swing.JComponent;
import javax.swing.JOptionPane;

import org.eso.ohs.core.gui.baseaction.ActionSuperclass;
import org.eso.ohs.core.gui.widgets.ErrorMessages;
import org.eso.ohs.core.gui.widgets.TextDisplayWidget;
import org.eso.ohs.core.utilities.ObjUtils;
import org.eso.ohs.dfs.CalibrationBlock;
import org.eso.ohs.persistence.ObjectContainer;
import org.eso.ohs.phase2.apps.masktracker.MaskInsertion;
import org.eso.ohs.phase2.apps.masktracker.MaskInsertion.ICCabinetFullException;

/**
 * Action class to display the selected ObservationBlock in PAF form.
 * 
 * <p>
 * $Id: InsertionNumberAction.java,v 1.15 2007/10/11 11:43:19 pnunes Exp $
 * <br>
 * 
 * @author Bob Kemp
 * @author cmavros 1501/OT Change to allow user to select more than one OB.
 */

public class InsertionNumberAction extends ActionSuperclass {

    private ObjectContainer objectContainer_;
  /** Boolean to turn off the header after first OB is read */
    protected static TextDisplayWidget log_ = new TextDisplayWidget(); 
    private CalibrationBlock [] cbList_;
    
    private JComponent component;
  
    /**
	 * Constructs a ShowPAFDescrAction action.
	 */
    public InsertionNumberAction(ObjectContainer objectContainer, 
             JComponent component,String name) {
        super((JComponent)component, name);
        this.component = component;
        objectContainer_ = objectContainer;
    }

    /**
	 * Event handler for the ShowPAFDescrAction action.
	 * 
	 * @param ev
	 *            user-initiated ActionEvent to quit.
	 */
    public void actionPerformedImpl(ActionEvent evt) {
        Long [] idLongs = null;
        idLongs = objectContainer_.getAll();
        idLongs = (Long[])ObjUtils.uniqueOccurrences(idLongs);
        if(idLongs == null || idLongs.length <= 0) {
            JOptionPane.showMessageDialog(
                                          objectContainer_.getTopLevelAncestor(),
                                          new Object[] {
                                              "There are no selected business objects",
                                              " ",
                                              "You must first select business objects to report on."
                                          },
                                          "Nothing selected",
                                          JOptionPane.ERROR_MESSAGE
                                          );
            return;
        }
        generateReport(idLongs);
    }

    private void generateReport(Long [] idLongs) {
       log_.setVisible(false);
       log_.clearTextArea();
       try {
           StringBuffer buf = new StringBuffer();
           long [] ids = new long [idLongs.length];
           for(int i=0;i<ids.length;i++) {
               ids[i] = idLongs[i].longValue();
           }
           String report = MaskInsertion.getInstance().getMaskReport(ids);              
           log_.setTextArea(report);
           log_.setVisible(true);
       }
       catch(SQLException e) {
    	   ErrorMessages.sqlError(e,component);
       }
       catch(ICCabinetFullException e) {
           JOptionPane.showMessageDialog(
               null,
               e.getMessage(),
               "Too many masks Error",
               JOptionPane.WARNING_MESSAGE);
       }
       
       
    }   

 
   
}



 
