package org.eso.ohs.phase2.apps.masktracker.actions;

import java.awt.event.ActionEvent;
import java.sql.SQLException;

import javax.swing.JComponent;
import javax.swing.JOptionPane;

import org.eso.ohs.core.gui.baseaction.ActionSuperclass;
import org.eso.ohs.core.gui.widgets.ErrorMessages;
import org.eso.ohs.core.gui.widgets.TextDisplayWidget;
import org.eso.ohs.core.utilities.ObjUtils;
import org.eso.ohs.persistence.ObjectContainer;
import org.eso.ohs.phase2.apps.masktracker.MaskInsertion;
import org.eso.ohs.phase2.apps.masktracker.MaskInsertion.ICCabinetFullException;

/**
 * Action class to display the selected ObservationBlock in PAF form.
 *
 * <p>
 * $Id: InsertionReportAction.java,v 1.13 2006/12/19 00:51:49 tcanavan Exp $
 * <br>
 * @author Bob Kemp
 * @author cmavros 1501/OT Change to allow user to select more than
 *    one OB.
 */

public class InsertionReportAction extends ActionSuperclass {

    private ObjectContainer folderView_;
  /** Boolean to turn off the header after first OB is read */
    protected static TextDisplayWidget log_ = new TextDisplayWidget(); 

    
    private JComponent component;
    
    
    /**
     * Constructs a ShowPAFDescrAction action.
     */
    public InsertionReportAction(ObjectContainer folderView,JComponent component, 
             String name) {
        super(component, name);
        folderView_ = folderView;
        this.component = component;
    }

    /**
     * Event handler for the ShowPAFDescrAction action.
     * 
     * @param ev       user-initiated ActionEvent to quit.
     */
    public void actionPerformedImpl(ActionEvent evt) {
        Long [] idLongs = null;
        idLongs = folderView_.getAll();
        idLongs = (Long[])ObjUtils.uniqueOccurrences(idLongs);
        if(idLongs == null || idLongs.length <= 0) {
            JOptionPane.showMessageDialog(
                                          folderView_.getTopLevelAncestor(),
                                          new Object[] {
                                              "There are no selected business objects",
                                              " ",
                                              "You must first select business objects to report on."
                                          },
                                          "Nothing selected",
                                          JOptionPane.ERROR_MESSAGE
                                          );
            return;
        }
        generateReport(idLongs);
    }
    
    public void generateReport(Long [] idLongs) {
        log_.setVisible(false);
        log_.clearTextArea();        
        try {
            StringBuffer buf = new StringBuffer();
            long [] ids = new long[idLongs.length];                
            for(int i=0;i<ids.length;i++) {
                ids[i] = idLongs[i].longValue();
            }                
            String report = MaskInsertion.getInstance().getOrderText(ids);              
            log_.setTextArea(report);
            log_.setVisible(true);
        }
        catch(SQLException e) {
        	ErrorMessages.sqlError(e,component); 
        }
        catch(ICCabinetFullException e) {
               JOptionPane.showMessageDialog(
                null,
                e.getMessage(),
                "Too many masks Error",
                JOptionPane.WARNING_MESSAGE);
        }
    }   
}



 
