package org.eso.ohs.phase2.apps.masktracker.actions;

import java.awt.event.ActionEvent;

import javax.swing.JComponent;

import org.eso.ohs.core.dbb.client.DbbView;
import org.eso.ohs.core.gui.baseaction.ActionSuperclass;
import org.eso.ohs.core.gui.baseaction.IncrementalAction;
import org.eso.ohs.core.utilities.ObjUtils;
import org.eso.ohs.dfs.Mask;
import org.eso.ohs.persistence.ObjectManager;

/**
 * Action class to refresh Masks table in the database.
 * 
 * <p>
 * $Id: UpdateMaskTableAction.java,v 1.16 2007/10/11 11:43:19 pnunes Exp $
 * <p>
 * @author Bob Kemp
 */
public class UpdateMaskTableAction extends ActionSuperclass {

    /** Threshold for naming individual objects in messages to user */
    private final static int DELETION_THRESHOLD = 5;

    /** medium on which the business object is to be deleted */
  

    /** view of the folder in which the OB is to be deleted */
    DbbView dbbView_;


    /**
     * Constructs a delete BusinessObject action.
     * 
     * @param device      medium containing the parent directory.
     * @param folderView  GUI view of (summary information in) the folder.
     */
    public UpdateMaskTableAction(DbbView dbbView) {
	super((JComponent)dbbView, "Update Mask Data");       
	dbbView_ = dbbView;
    }

    /**
     * Event handler for the delete BusinessObject action.
     * 
     * @param ev       user-initiated ActionEvent to delete an OD.
     */
    public void actionPerformedImpl(ActionEvent ev) {  
        long ids [] = null;       
        //Updater.propagateMaskInfo();
    }


    /**
     * Utility class to delete a sequence of OBs, one at a time.
     * The user is also given the opportunity to stop the process using
     * a dialog box.
     */
    public class IncrementalUpdate implements IncrementalAction  {

        private Mask [] masks_  = {};

        ObjectManager objMgr = ObjectManager.getObjectManager();

	public IncrementalUpdate(Mask [] masks) {             
            masks_ = masks;            
	}

	public int getNumStepsRemaining(int counter) {
	  //return ids_.length;
	    return ObjUtils.howManyNotNull(masks_, counter);
	}

	public void startOfAction() { }

	public void endOfAction() {          
             dbbView_.sqlStartAction(null);
          
        }

	public void performStep(int counter) {
	    if (masks_[counter] != null) {	
		insertMaskData(masks_[counter]);
	    }
	}

	public void insertMaskData(Mask mask) {
	  //try {
	  //     objMgr.putBusObj(mask);
	  // }
	  // catch(ObjectIOException e) {
	  // }
	  // catch(ObjectNotFoundException e) {
	  // }
	}
    }

}


