package org.eso.ohs.phase2.apps.ot;

import java.awt.Component;

import org.apache.log4j.Logger;
import org.eso.ohs.persistence.AppConfig;
import org.eso.ohs.persistence.Config;
import org.eso.ohs.phase2.apps.ot.gui.ExecutionSequenceBView;
import org.eso.ohs.phase2.apps.ot.gui.OTViewManager;
import org.eso.ohs.phase2.icdVcs.IcdVcsCfg;


/**
 * Clearing house for low-level configuration information.
 * 
 * <p>
 * @author cmavros 2002/02/11, 1512/P2PP, add log4j
 * $Id: MyIcdVcsCfg.java,v 1.5.6.1 2007/10/05 11:18:50 pnunes Exp $
 */
public class MyIcdVcsCfg extends IcdVcsCfg {


    protected static Logger stdlog_ =
        Logger.getLogger( MyIcdVcsCfg.class );


    /**
     * Type of object with given id.
     * 
     * @return	Type of object to send to BOB
     */
    public Class getObjType(long id) {          
	long retid = Config.getCfg().uniqueToTableId(id);
        return ExecutionSequenceBView.getInstance().getView().getClassForId(retid);
    }

    public Class getObjectClassToSend() {
        throw new IllegalArgumentException("Illegal Argument Exception. This method should not be called in OT");
    }

    public boolean hasValidSelection() {
        stdlog_.debug("ot.MyIcdVcsCfg: Has valid selection ");
        return ExecutionSequenceBView.getInstance().isOBSelected();
    }


    public long[] getSelections(int maxNumOBs) {
	long [] returnList = ExecutionSequenceBView.getInstance().getOBsIdFromExecutionSequence(maxNumOBs);
	if (returnList != null) {
            stdlog_.debug("ot.MyIcdVcsCfg: ---->required from Bob " + maxNumOBs
				+ " Ob(s) and returned "  + returnList.length);
	}
	return returnList;
    }


    public long getSelection(Class objType) {
        OTViewManager manager = OTViewManager.getOTViewMgr();	
	return manager.getSelectedQueue().getId();
    }


    public Component getContainer() {
	return null;
    }
  

    public String getCCSServer() {
	return AppConfig.getAppConfig().getCCSServer();
    }

    public boolean isInVisitorMode() {
	return Config.getCfg().isInVisitorMode();
    }


    public boolean isInEngineeringMode() {
	return Config.getCfg().isInEngineeringMode();
    }

    public boolean isInCloneMode() {
	return Config.getCfg().isInCloneMode();
    }

    public int getAccountId() {
	return Config.getCfg().getAccountId();
    }

}


