package org.eso.ohs.phase2.apps.ot.actions;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.JFrame;

import org.eso.ohs.core.dbb.sql.DbbQueryTerminated;
import org.eso.ohs.core.dbb.sql.DbbQueryTerminatedListener;
import org.eso.ohs.phase2.apps.ot.gui.ExecutionSequenceBView;
import org.eso.ohs.phase2.apps.ot.gui.QueueItemsBView;

/**
 * Action class to generate the execution list
 * on the selected BusinessObjects.
 *
 * @author tcanavan
 * @author cmavros Add unsubscribe method.
 * @version $Id: ExecutionAction.java,v 1.5 2006/01/31 11:53:38 ddorigo Exp $
 */
public class ExecutionAction extends AbstractAction {

    private QueueItemsBView dbbQueueItemsView_;

    private ExecQueryTerminatedListener listener_;

    private JFrame frm_;

    public ExecutionAction(QueueItemsBView dbbView) {
        super("Execution");
        dbbQueueItemsView_ = dbbView;
        listener_ = new ExecQueryTerminatedListener(this);
        ExecutionSequenceBView.getInstance().getDbbView().addQueryTerminatedListener(listener_);
        frm_ = (JFrame)dbbQueueItemsView_.getView().getTopLevelAncestor();
    }

    public void actionPerformed(ActionEvent ev) {
        this.setEnabled(false);
        dbbQueueItemsView_.appendOBtoES();
        
    }

    public void unsubscribe() {
	 ExecutionSequenceBView.getInstance().getDbbView().removeQueryTerminatedListener(listener_);
    }


    private class ExecQueryTerminatedListener implements DbbQueryTerminatedListener {

        private ExecutionAction action_;
         
        public ExecQueryTerminatedListener(ExecutionAction action) {
            action_ = action;
        }

        public void queryTerminatedAction(DbbQueryTerminated ev) {
            action_.setEnabled(true);
        }
    }
}

