package org.eso.ohs.phase2.apps.ot.actions;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.JOptionPane;

import org.eso.ohs.core.utilities.ObjectIOException;
import org.eso.ohs.dfs.Queue;
import org.eso.ohs.dfs.QueueItem;
import org.eso.ohs.persistence.dbase.phase2.DbaseHandlerQueue;
import org.eso.ohs.persistence.dbase.phase2.QueueManager;
import org.eso.ohs.phase2.apps.ot.gui.QueueItemsBView;

public class ReloadQueueItemsAction extends AbstractAction {

    private QueueItemsBView queueItemView_;

    public ReloadQueueItemsAction(QueueItemsBView queueItemView) {
        super("Revert");
        queueItemView_ = queueItemView;

    }

    public void actionPerformed(ActionEvent ev) {
        try {
            Queue queue = queueItemView_.getQueue();
            QueueItem[] queueList = queue.getQueueSequenceList();
            long[] obList = new long[queueList.length];
            for (int i = 0; i < queueList.length; i++) {
                    obList[i] = queueList[i].getObId();
            }
                QueueManager.updateOBsSequences(
                        obList,
                        queueItemView_.getQueue().getId(),
                        DbaseHandlerQueue.TMP_SCHEDULE_ITEMS);
            queueItemView_.getView().sqlStartAction();
        } catch (ObjectIOException e) {
            String message = "Error: " + e.getMessage();
            JOptionPane.showMessageDialog(
                null,
                message,
                "ERROR",
                JOptionPane.ERROR_MESSAGE);
        }
    }

}

