package org.eso.ohs.phase2.apps.ot.gui;

import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import org.eso.ohs.core.gui.models.LimitedCharsModel;

/** The CommentDialog dailog is used to modify the following OB property
 *  observer comments , status , obs grade
 *
 *  @version $Revision: 1.3 $
 *  @author  G.Passera, DMD/ESO, <gpassera@eso.org>
 */
public class ReadmeNotesDialog extends JDialog {

    private JLabel readmeNotesLabel = new JLabel("Notes : ");
    private JTextArea notesTextArea =
        new JTextArea(new LimitedCharsModel(1200), "",10, 100);

    private JButton cancelButton_ = new JButton("Cancel");
    private JButton saveButton_ = new JButton("Save");

    private JPanel contentPanel = new JPanel();

    private int returnValue_ = JOptionPane.CANCEL_OPTION;

    /** Default constructor*/
    public ReadmeNotesDialog(JFrame frm) {
        super(frm, "Readme Notes", true);
        JPanel content = new JPanel();
        content.setLayout(new GridBagLayout());
        Container c = content;
        JScrollPane pane = new JScrollPane(notesTextArea);


        GridBagAdder.add(
            c,
            readmeNotesLabel,
            0,
            0,
            1,
            1,
            0,
            0,
            GridBagConstraints.HORIZONTAL,
            GridBagConstraints.NORTH);


        GridBagAdder.add(
            c,
            pane,
            1,
            0,
            3,
            10,
            1,
            1,
            GridBagConstraints.BOTH,
            GridBagConstraints.NORTH);

        GridBagAdder.add(
            c,
            saveButton_,
            6,
            0,
            1,
            1,
            0,
            0,
            GridBagConstraints.BOTH,
            GridBagConstraints.NORTH);

        GridBagAdder.add(
            c,
            cancelButton_,
            6,
            1,
            1,
            1,
            0,
            0,
            GridBagConstraints.BOTH,
            GridBagConstraints.NORTH);

        getContentPane().add(c);

        saveButton_.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                returnValue_ = JOptionPane.OK_OPTION;
                setVisible(false);
            }
        });
        cancelButton_.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                returnValue_ = JOptionPane.CANCEL_OPTION;
                setVisible(false);
            }
        });
        this.pack();
    }

    public int getUserChoice() {
        return returnValue_;
    }



    /**Retruns the observer comment*/
    public String getReadmeNotes() {
        if (notesTextArea.getText() != null)
            return notesTextArea.getText();
        else
            return "";
    }
    /**Retruns the observer comment*/
    public void setReadmeNotes(String comments) {
        notesTextArea.setText(comments);
    }

}
