package org.eso.ohs.phase2.apps.ot.gui;

import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.InputEvent;
import java.awt.event.ItemEvent;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.net.MalformedURLException;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.sql.SQLException;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPopupMenu;
import javax.swing.JTable;
import javax.swing.KeyStroke;
import javax.swing.ListSelectionModel;
import javax.swing.RepaintManager;

import org.apache.log4j.Logger;
import org.eso.ohs.core.dbb.client.DbaseDec;
import org.eso.ohs.core.dbb.client.DbaseRA;
import org.eso.ohs.core.dbb.client.DbbAirmassTextField;
import org.eso.ohs.core.dbb.client.DbbArrowButton;
import org.eso.ohs.core.dbb.client.DbbCheckBox;
import org.eso.ohs.core.dbb.client.DbbComboBox;
import org.eso.ohs.core.dbb.client.DbbCoordinateTextField;
import org.eso.ohs.core.dbb.client.DbbExecTimeTextField;
import org.eso.ohs.core.dbb.client.DbbExecutionTime;
import org.eso.ohs.core.dbb.client.DbbFliTextField;
import org.eso.ohs.core.dbb.client.DbbHHMMDateTime;
import org.eso.ohs.core.dbb.client.DbbISODateTime;
import org.eso.ohs.core.dbb.client.DbbIntegerTextField;
import org.eso.ohs.core.dbb.client.DbbMoonAngularTextField;
import org.eso.ohs.core.dbb.client.DbbPanel;
import org.eso.ohs.core.dbb.client.DbbSeeingTextField;
import org.eso.ohs.core.dbb.client.DbbSelectionList;
import org.eso.ohs.core.dbb.client.DbbSiderealTime;
import org.eso.ohs.core.dbb.client.DbbStrehlRatioTextField;
import org.eso.ohs.core.dbb.client.DbbTextField;
import org.eso.ohs.core.dbb.client.DbbTextFieldPattern;
import org.eso.ohs.core.dbb.client.DbbView;
import org.eso.ohs.core.dbb.client.DbbWidget;
import org.eso.ohs.core.dbb.client.DelConfigAction;
import org.eso.ohs.core.dbb.client.DismissAction;
import org.eso.ohs.core.dbb.client.MoonDistance;
import org.eso.ohs.core.dbb.client.SaveConfigAction;
import org.eso.ohs.core.dbb.server.DbbSqlEngine;
import org.eso.ohs.core.dbb.sql.BetweenChunkGroup;
import org.eso.ohs.core.dbb.sql.CyclingMaxMinChunk;
import org.eso.ohs.core.dbb.sql.DbbQueryTerminated;
import org.eso.ohs.core.dbb.sql.DbbQueryTerminatedListener;
import org.eso.ohs.core.dbb.sql.DbbSqlChunk;
import org.eso.ohs.core.dbb.sql.DbbSqlChunkGroupMember;
import org.eso.ohs.core.dbb.sql.DbbSqlOperator;
import org.eso.ohs.core.gui.baseaction.ActionSuperclass;
import org.eso.ohs.core.gui.utilities.MenuUtils;
import org.eso.ohs.core.gui.widgets.ErrorMessages;
import org.eso.ohs.core.gui.widgets.TextDisplayWidget;
import org.eso.ohs.core.utilities.AssocList;
import org.eso.ohs.core.utilities.GTreeNode;
import org.eso.ohs.core.utilities.NotASCIIException;
import org.eso.ohs.core.utilities.OHSConfig;
import org.eso.ohs.core.utilities.OHSKeys;
import org.eso.ohs.core.utilities.ObjectIOException;
import org.eso.ohs.core.utilities.Period;
import org.eso.ohs.dfs.CalibrationBlock;
import org.eso.ohs.dfs.CommentType;
import org.eso.ohs.dfs.ConstraintSet;
import org.eso.ohs.dfs.Mask;
import org.eso.ohs.dfs.MaskStatusType;
import org.eso.ohs.dfs.ObservationBlock;
import org.eso.ohs.dfs.ObservingRun;
import org.eso.ohs.dfs.Queue;
import org.eso.ohs.dfs.Readme;
import org.eso.ohs.instruments.InstrumentList;
import org.eso.ohs.instruments.Parameter;
import org.eso.ohs.persistence.AppConfig;
import org.eso.ohs.persistence.Config;
import org.eso.ohs.persistence.Media;
import org.eso.ohs.persistence.ObjectContainer;
import org.eso.ohs.persistence.ObjectManager;
import org.eso.ohs.persistence.ObjectNotFoundException;
import org.eso.ohs.persistence.dbase.phase2.ProcessExtraConstraints;
import org.eso.ohs.persistence.dbase.phase2.QueueManager;
import org.eso.ohs.phase2.actions.ExportBOAction;
import org.eso.ohs.phase2.actions.ShowFindingChartsAction;
import org.eso.ohs.phase2.apps.ot.actions.ExecutionSequenceAction;
import org.eso.ohs.phase2.apps.ot.actions.OBHistoryAction;
import org.eso.ohs.phase2.apps.ot.dbb.BrowserConfig;
import org.eso.ohs.phase2.apps.ot.dbb.OTDbbView;

/** TODO REMOVE THE DIPENDENCY WITH P2PP */

/**
 * The RepositoyBrowserView class is a DB search engine used for
 * building queues of OBs according to a user-definable set of selection
 * criteria.
 * <br>
 * @author Gorgio Passera DMD/ESO <gpassera@eso.org>
 * <br>ChangeLog: cmavros 2001/10/04 16:30:00
 *    Add Rank Class mutliple select sort, Change Sky transparency, Instruments
 *    and QC Grade to multiple select JList $
 * <br>ChangeLog: cmavros 2002/02/06
 *    598/OT Change ProgID, Templates, and OB Name to OHSDbbTextField.
 *    Change User Id and Queue Id to DbbIntegerTextField.
 *    Added log4j
 * <br>ChangeLog: cmavros 2002/11/02, 1602/OT
 * <br>ChangeLog: cmavros 2002/11/02, 1701/OT Change QC Grade list values
 * <br>ChangeLog: cmavros 2002/15/02, 1102/DBB Add Options Menu
 * <br>ChangeLog: cmavros 26/06/2002 ]Remove read OHSKeys.DefaultPeriodKey
 *     to  period value to utilities.getPeriod() to get the default period.
 * <br>ChangeLog: cmavros 04/07/2002 Read option folder keyword before creating
 *          option menu item.
 * @version $Revision: 1.69.2.2 $
 */
public class RepositoryBrowserView extends JFrame {

    public static final String cvsID_ = "$Id: RepositoryBrowserView.java,v 1.69.2.2 2007/10/23 08:09:12 pnunes Exp $";

    private static Logger stdlog_ =
        Logger.getLogger(RepositoryBrowserView.class);

    private JButton appendOBsButton;
    private JButton statusButton;
    private JButton readmeStatusButton;
    private JButton obHistroyBtn;              

    
    private JButton findingCharts = new JButton("Finding Chart(s)");

    private JButton executionButton;
    
    private ShowFindingChartsAction showFindingChartsAction_;
    
    private static RepositoryBrowserView repView_;

    // Phase2 tables
    //----------------------------------------

    /**
     * The action for applying the default
     * selections when the application starts.
     */
    ActionSuperclass actionMenuDefault_;

    /*
     <br>ChangeLog: amchavan, 24-Oct-2001: added
     <br>ChangeLog: amchavan, 21-Nov-2001: commented out again, see 0704
     DbbSqlTable run_states_;
    */

    private OTDbbView view_;
    private JTable table_;
  

    private TextDisplayWidget queueHoldingView =
        new TextDisplayWidget("Queues holding OBs", true, false, true);

    private int currentRow_ = 0;

    static DbbPanel colPanel_;
    static DbbPanel rowPanel_;
    static DbbPanel sortPanel_;
    static DbbPanel menuPanel_;

    protected String CONFIG_KEYWORD = "REPOSITORYBROWSER.CONFIG.CONFIGMENU";
    protected final String DEFAULT_REQUEST = "Save As Default";
    String userConfigFile_ = null;
    private WindowAdapter wl = null;

    private DbbSqlChunk obIDChunk;
    private DbbSqlChunk obIDMaskChunk;
    private DbbSqlChunk adpMaskChunk;
    private DbbSqlChunk maskStatusSortChunk;

    // private DbbCheckBox obIdChkBox;
    private DbbCheckBox maskStatusBox;
    private DbbCheckBox maskSlotNumBox;
    private DbbCheckBox maskChannelBox;

    private MenuCreator otMenu;

    /**
     * Default constructor
     * <br>ChangeLog: Gorgio Passera <DMD/ESO> <gpassera@eso.org>
     * @exception ObjectIOException Object I/O Exception
     */
    public RepositoryBrowserView() throws ObjectIOException {

        try {
            view_ = new OTDbbView();
            otMenu = new MenuCreator(this);
            buildDbbView();
            initFirst();
            buildMenus(view_.getJTable());
            addActions();
            packView();       
        } catch (RemoteException e) {
            throw new ObjectIOException(e);
        } catch (MalformedURLException e) {
            throw new ObjectIOException(e);
        } catch (NotBoundException e) {
            throw new ObjectIOException(e);
        } catch (SQLException e) {
            throw new ObjectIOException(e);
        }
    }

    /**
     *  void
     */
    private void packView() {
        pack();
        setVisible(true);
        setTitle("Repository Browser");
        table_ = view_.getJTable();
    }

    /**
     *  void
     */
    private void addActions() {
        statusButton.addMouseListener(new StatusPopupListener());
        readmeStatusButton.addMouseListener(new ReadmeStatusPopupListener());

        appendOBsButton.addMouseListener(new PopupListener());
        if (!AppConfig
            .getAppConfig()
            .getBoolean(OHSKeys.MaskTrackerEnabledKey)) {
            executionButton.addActionListener(
                new ExecutionSequenceAction(
                    view_,view_.getJTable(),
                    "Execution Sequence"
                    ));
        }
        view_.getDbbView().addQueryTerminatedListener(new QueryTerminatedListener());
        view_.getJTable().addMouseListener(
            new RightClickStatusPopupListener());

        getContentPane().add(view_.getDbbView());
        if (actionMenuDefault_ != null) {
            actionMenuDefault_.actionPerformedImpl(
                new ActionEvent(actionMenuDefault_, 0, ""));
        }

        setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
        wl = new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                stdlog_.warn("OT browser closing");
                dispose();
            }
        };
        addWindowListener(wl);
    }

    /**
     * @throws ObjectIOException void
     */
    private void buildMenus(JComponent comp) throws ObjectIOException {
        createFileMenu();
        createEditMenu();
        createReportsMenu(view_, comp);
        otMenu.createFCPrintMenu(view_,comp);
        if (!AppConfig
            .getAppConfig()
            .getBoolean(OHSKeys.MaskTrackerEnabledKey)) {
            otMenu.createEphFileMenu(view_,comp); 
            otMenu.createReadmeMenu(view_,comp);
        }  
        createOptionsMenu();
    }

    /**
     * @throws SQLException void
     */
    private void initFirst() throws SQLException {
        DbbSqlEngine engine = view_.getDbbView().getSqlEngine();
       
                           
      
        appendOBsButton = new JButton("Append");
        view_.getDbbView().addSummaryButton(appendOBsButton);
        statusButton = new JButton("Mark Status");
        view_.getDbbView().addSummaryButton(statusButton);
        readmeStatusButton = new JButton("Readme Status");
        if(AppConfig.getAppConfig().getBoolean(OHSKeys.USGEnabledKey)) {
            view_.getDbbView().addSummaryButton(readmeStatusButton);
        }
        JButton obHistroyBtn = new JButton("OB History");              
        OBHistoryAction obHistoryAction = new OBHistoryAction(view_);
        obHistroyBtn.addActionListener(obHistoryAction);
        view_.getDbbView().addSummaryButton(obHistroyBtn);            
        if (!AppConfig
            .getAppConfig()
            .getBoolean(OHSKeys.MaskTrackerEnabledKey)) {
            executionButton = new JButton("Execution Sequence");
            view_.getDbbView().addSummaryButton(executionButton);
        }            
        view_.getDbbView().addSummaryButton(findingCharts); 
        showFindingChartsAction_ = new ShowFindingChartsAction(Media.DBASE,view_,this,false);
        findingCharts.addActionListener(showFindingChartsAction_);
    }

    /**
     * @throws NotBoundException
     * @throws MalformedURLException
     * @throws SQLException
     * @throws RemoteException void
     */
    protected void buildDbbView() throws NotBoundException, MalformedURLException, SQLException, RemoteException {
        buildColumns();
        buildRows();
        buildSort();
    }

    public void addNotify() {
        super.addNotify();
        // if(AppConfig.getAppConfig().getBoolean(OHSKeys.MaskTrackerEnabledKey))
        // private MaskStatusDbbCheckBox maskStatusBox;
    }

    public void finalize() throws Throwable {
        // This cannot use stdlog_.debug() as it gives the closed appender
        // error message from log4j
        System.out.println("FINALIZE - - ot.gui.RepositoryBrowser - - FINALIZE");
        super.finalize();
    }

    public void createReportsMenu(ObjectContainer objectContainer,JComponent comp) {
        otMenu.createReportsMenu(objectContainer,comp);
        JMenu reportsMenu = MenuUtils.getMenu(this,"Reports");
        JMenuItem showMenuItem = new JMenuItem("Show Queues");
        reportsMenu.add(showMenuItem);
        showMenuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                viewQueuesHoldingOBs();
            }
        });
    }
    
    
    /**
     * Create and populate the "File" menu in the database browser view.
     * @exception ObjectIOException object IO Exception
     */
    public void createFileMenu() throws ObjectIOException {

        JMenu fileMenu = MenuUtils.getMenu(this,"File");
        JMenuItem mnItem = fileMenu.add(new DismissAction(this));
        mnItem.setAccelerator(
            KeyStroke.getKeyStroke(KeyEvent.VK_W, InputEvent.CTRL_MASK, false));
        JMenuBar mb = getJMenuBar();
        mb.add(fileMenu);

        JMenuItem deleteFromAllMenuItem =
            new JMenuItem("Delete OB(s) from all Queues");
        JMenuItem deleteMenuItem = new JMenuItem("Delete OB(s)");
        JMenuItem exportMenuItem = new JMenuItem("Export...");
        exportMenuItem.addActionListener(
            new ExportBOAction(Media.DBASE,view_.getJTable(), view_, "Export...", true));
        fileMenu.add(deleteFromAllMenuItem);
        fileMenu.add(deleteMenuItem);
        fileMenu.add(exportMenuItem);
        

        deleteMenuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                deleteOB();
            }
        });

        deleteFromAllMenuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                deleteQueuesReference();
            }
        });
    }

    /**
     * Create and populate the "File" menu in the database browser view.
     * @exception ObjectIOException object IO Exception
     */
    public void createEditMenu() throws ObjectIOException {

        JMenu fileMenu = MenuUtils.getMenu(this,"Edit");
        JMenuItem selectAllMenuItem = new JMenuItem("Select All");
        /* JMenuItem mnItem = */
        fileMenu.add(selectAllMenuItem);

        selectAllMenuItem.setAccelerator(
            KeyStroke.getKeyStroke(KeyEvent.VK_A, InputEvent.CTRL_MASK, false));

        selectAllMenuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent ev) {
                ListSelectionModel lsm =
                    view_.getJTable().getSelectionModel();
                lsm.addSelectionInterval(0, view_.getJTable().getRowCount() - 1);
            }
        });

        JMenuBar mb = getJMenuBar();
        mb.add(fileMenu);
    }

    /**
     * Read the config file and the neccessary keyword for creating the
     * "Options" menu in the database browser view.
     * @return true if no exceptions caught
     * @exception IOException object IO Exception
     * @exception NotASCIIException object IO Exception
     * @exception FileNotFoundException object IO Exception
     */
    protected boolean optionsSetup() {

        OHSConfig config = OHSConfig.getInstance();
        AppConfig appConfig = AppConfig.getAppConfig();
        if (AppConfig.getAppConfig().getBoolean(OHSKeys.MaskTrackerEnabledKey)) {
            CONFIG_KEYWORD = "MTREPOSITORYBROWSER.CONFIG.CONFIGMENU";
        }
        try {
            String optionDir = appConfig.getOptionDir();
            //stdlog_.info ("Options Dir: " + optionDir);
            if (optionDir != null && optionDir.length() > 0) {
                String fileName = config.getValue(CONFIG_KEYWORD);
                if (fileName != null && fileName.length() > 0) {
                    userConfigFile_ = optionDir + File.separator + fileName;
                    config.addParamfile(userConfigFile_);
                } else {
                    return false;
                }
            } else {
                return false;
            }
        } catch (Exception e) {
            stdlog_.info("File: " + userConfigFile_ + " does not exist.");
            try {
                PrintWriter out = new PrintWriter(new FileWriter(userConfigFile_));
                stdlog_.info("File: " + userConfigFile_ + " created.");
                out.println("");
                out.close();
                config.addParamfile(userConfigFile_);
            } catch (java.io.FileNotFoundException e1) {
                return false;
            } catch (org.eso.ohs.core.utilities.NotASCIIException e2) {
                return false;
            } catch (java.io.IOException e3) {
                return false;
            }
        }

        return true;
    }

    /**
     *
     * Create and populate the "Options" menu in the database browser view.
     * @exception ObjectIOException object IO Exception
     */
    public void createOptionsMenu() throws ObjectIOException {

        if (optionsSetup()) {
            JMenu optionsMenu = MenuUtils.getMenu(this,"Options");
            JMenuItem saveMenuItem = null;

            SaveConfigAction confAction =
                new SaveConfigAction(
                    this,
                    optionsMenu,
                    rowPanel_,
                    colPanel_,
                    sortPanel_,
                    CONFIG_KEYWORD,
                    userConfigFile_,
                    "Save settings",
                    true);
            JMenuItem mnItem = optionsMenu.add(confAction);

            confAction =
                new SaveConfigAction(
                    this,
                    optionsMenu,
                    rowPanel_,
                    colPanel_,
                    sortPanel_,
                    CONFIG_KEYWORD,
                    userConfigFile_,
                    DEFAULT_REQUEST,
                    true);
            optionsMenu.add(confAction);

            DelConfigAction delAction =
                new DelConfigAction(
                    this,
                    optionsMenu,
                    CONFIG_KEYWORD,
                    userConfigFile_,
                    "Delete Settings",
                    true);
            delAction.setMenuMap(confAction.getMenuMap());
            optionsMenu.add(delAction);

            optionsMenu.addSeparator();
            confAction.addMenus(CONFIG_KEYWORD);
            JMenuBar mb = getJMenuBar();
            mb.add(optionsMenu);
        }
    }

    /**
     * Get the selection widget values from configuration
     * and save them into an action
     * @return the action that applies the retrieved configuration
     */
    ActionSuperclass getMenuSetUpFromConfig(GTreeNode menu, String menuName) {

        GTreeNode colWidgets = menu.getChild("cols");
        GTreeNode rowWidgets = menu.getChild("rows");
        GTreeNode sortWidgets = menu.getChild("sort");

        ConfigValuesAction action =
            new ConfigValuesAction(
                this,
                menuName,
                colWidgets,
                rowWidgets,
                sortWidgets);
        return action;
    }

    /**
     * @return the DbbView
     */
    public DbbView getDbbView() {
        return view_.getDbbView();
    }

    //----------------------------------------
    // Private Methods
    //----------------------------------------

    /**
     * Build DB browser view: SELECT panel
     *
     * <br>ChangeLog: Gorgio Passera
     * @exception SQLException JDBC exception occurs
     * @exception RemoteException RMI exception occurs
     * @exception MalformedURLException malformed url i.e. servername//port
     * @exception NotBoundException client could not bind to server
     */
    private void buildColumns()
        throws NotBoundException, MalformedURLException, SQLException, RemoteException {

        colPanel_ = new DbbPanel("Selected Columns", 9);
        DbbSqlEngine engine = view_.getDbbView().getSqlEngine();
        DbbSqlChunk c;
        DbbCheckBox w;
        String label_name;
        String column_name;

        // OB id (default chunk)
        label_name = "OB ID";
        column_name = "ob_id";

        obIDChunk = new DbbSqlChunk(BrowserConfig.ob, column_name, label_name);
        obIDMaskChunk = new DbbSqlChunk(BrowserConfig.obsblk_masks_table, column_name, label_name);
        adpMaskChunk =
            new DbbSqlChunk(BrowserConfig.obsblk_masks_table, "adp_index", "Channel Number");

        obIDMaskChunk.setActive(false);
        adpMaskChunk.setActive(false);
        engine.addDefaultColumnsChunk(obIDChunk);

        //engine_.addDefaultColumnsChunk(obIDMaskChunk);

        //obIDChunk = new DbbSqlChunk(BrowserConfig.ob,column_name, label_name);
        // OB type
        

        
        column_name = "type";
        label_name = "Type";
        engine.addDefaultColumnsChunk(
            new DbbSqlChunk(BrowserConfig.ob, column_name, label_name));

        /**
         * OB Status
         * Now a default column as it is required in order to determine
         * if an OB may be placed in a queue or not.
         * <br>ChangeLog: Nick Kornweibel for ESO.
         *
         */
        column_name = "status";
        label_name = "Status";
        engine.addDefaultColumnsChunk(
            new DbbSqlChunk(BrowserConfig.ob, column_name, label_name));

        //engine_.addDefaultColumnsChunk(adpMaskChunk);

        //obIDMaskChunk = new DbbSqlChunk(BrowserConfig.obsblk_masks_table, "ob_id", "OB ID");
        //engine_.addDefaultColumnsChunk(obIDMaskChunk);
        //obIDMaskChunk.setActive(false);

        // OB type
        //column_name = "tel";
        //label_name = "Telescope ";
        //engine_.addDefaultColumnsChunk(
        //  new DbbSqlChunk(BrowserConfig.sr,column_name,label_name));

        // OB name widget
        column_name = "item_name";
        label_name = "OB Name";        
        c = new DbbSqlChunk(BrowserConfig.ob, column_name, label_name);
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);
        
        
        column_name = "userComments";
        label_name = "OB Comment";
        c = new DbbSqlChunk(BrowserConfig.ob, column_name, label_name,CommentType.class);
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);

        column_name = "inst_comments";
        label_name = "Inst Comment";
        c = new DbbSqlChunk(BrowserConfig.ob, column_name, label_name,CommentType.class);
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);

        
        // Programme ID widget
        label_name = "ProgID";
        column_name = "progid";
        c = new DbbSqlChunk(BrowserConfig.sr, column_name, label_name, String.class);
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);

        // User name widget
        label_name = "UserName";        
        column_name = "username";
        c = new DbbSqlChunk(BrowserConfig.accounts, column_name, label_name,"rtrim(@column@)");
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);

        // User ID widget
        label_name = "LastName";
        /** cmavros 2002/05/06, 1345/OT */
        column_name = "last_name";
        c = new DbbSqlChunk(BrowserConfig.profiles, column_name, label_name,"rtrim(@column@)");
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);

        // Target
        label_name = "Target";
        column_name = "item_name";
        c = new DbbSqlChunk(BrowserConfig.tp, column_name, label_name);
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);

        // RA widget
        label_name = "RA";
        column_name = "ra";
        c = new DbbSqlChunk(BrowserConfig.tp, column_name, label_name, DbaseRA.class);
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);

        // Dec widget
        label_name = "Dec";
        column_name = "dec";
        c = new DbbSqlChunk(BrowserConfig.tp, column_name, label_name, DbaseDec.class);
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);

        //OB type
        // amchavan, 13-Jun-2002: commented out.
        // this is already a default chunk
        // label_name  = "TYPE";
        // column_name = "type";
        // colPanel_.addWidget(new DbbCheckBox(label_name,
        // new DbbSqlChunk(BrowserConfig.ob,column_name, label_name)));

        //Filter
        // Optical elements widget
        label_name = "OptElem";
        column_name = "value";

        c = new DbbSqlChunk(BrowserConfig.pa, column_name, label_name);
        w = new DbbCheckBox(label_name, c);

        /////////// test ///////////
        DbbSqlOperator op = null;

        try {
            op = new DbbSqlOperator(">");
        } catch (Exception e) {
            stdlog_.error(e);
        }

        column_name = "subtype";
        c = new DbbSqlChunk(BrowserConfig.pa, column_name, op, Integer.class);
        c.setValue("0");
        w.addSqlChunk(c);
        /////////// test ///////////

        colPanel_.addWidget(w);

        // Instrument widget
        label_name = "Instrument";
        column_name = "instrument";

        c = new DbbSqlChunk(BrowserConfig.od, column_name, label_name);
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);

        // ipversion widget
        label_name = "IP Version";
        column_name = "ipversion";
        c = new DbbSqlChunk(BrowserConfig.od, column_name, label_name);
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);

        // User's priority
        label_name = "UsrP";
        column_name = "userPriority";

        c = new DbbSqlChunk(BrowserConfig.ob, column_name, label_name);
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);

        // Template widget
        label_name = "Templ";
        column_name = "item_name";
        c = new DbbSqlChunk(BrowserConfig.ts, column_name, label_name);
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);

        // OB Status widget
        /**
         * Now a default column as it is required in order to determine
         * if an OB may be placed in a queue or not.
         * <br>ChangeLog: Nick Kornweibel for ESO.
         *
         * label_name = "Status";
         * column_name = "status";
         * c = new DbbSqlChunk(BrowserConfig.ob,column_name,label_name);
         * w = new DbbCheckBox(label_name,c);
         * colPanel_.addWidget(w);
         */

        // CS Seeing widget
        label_name = "Seeing";
        column_name = "seeing";
        c = new DbbSqlChunk(BrowserConfig.cs, column_name, label_name);
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);

        // CS SkyTransparency widget
        label_name = "SkyTran";
        column_name = "sky_transparency";
        c = new DbbSqlChunk(BrowserConfig.cs, column_name, label_name);
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);

        // CS AirMass widget
        label_name = "Airmass";
        column_name = "airmass";
        c = new DbbSqlChunk(BrowserConfig.cs, column_name, label_name);
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);

        // CS FLIS widget
        label_name = "FLI";
        column_name = "fli";
        c = new DbbSqlChunk(BrowserConfig.cs, column_name, label_name);
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);

        // CS Moon Distance
        label_name = "MoonDis";
        column_name = "moon_distance";
        c = new DbbSqlChunk(BrowserConfig.cs, column_name, label_name, MoonDistance.class);
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);

        // CS Strehl Ratio widget
        label_name = "Strehl";
        column_name = "strehl_ratio";
        c = new DbbSqlChunk(BrowserConfig.cs, column_name, label_name);
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);

        // Rank class
        label_name = "RankClass";
        column_name = "rank_class";
        c = new DbbSqlChunk(BrowserConfig.sr, column_name, label_name);
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);

        //QCGrade
        label_name = "QC Grade";
        column_name = "obs_grade";

        colPanel_.addWidget(
            new DbbCheckBox(
                label_name,
                new DbbSqlChunk(BrowserConfig.ob, column_name, label_name)));

        //table = masksTable;

        // <br>ChangeLog: amchavan, 22-Oct-2001: commented out for V.2.2
        // panel.addWidget(w);
        /** cmavros 06/Nov/01
         * Only display option if Masktracker is Enabled.
         */
        //if (AppConfig.getAppConfig().getBoolean(OHSKeys.MaskTrackerEnabledKey))
        colPanel_.addWidget(w);

        label_name = "Queue Id";
        column_name = "sch_id";
        c = new DbbSqlChunk(BrowserConfig.sc, column_name, label_name, Integer.class);
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);
        
        
        label_name = "Finding Charts";
        column_name = "fc_name";
        c = new DbbSqlChunk(BrowserConfig.finds_view, column_name, label_name);
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);
        if (!AppConfig
            .getAppConfig()
            .getBoolean(OHSKeys.MaskTrackerEnabledKey)) { 
            label_name = "Ephemeris File";
            column_name = "file_name";
            c = new DbbSqlChunk(BrowserConfig.ephemeris_file, column_name, label_name,String.class);
            w = new DbbCheckBox(label_name, c);
            colPanel_.addWidget(w);
        }
        if(AppConfig.getAppConfig().getBoolean(OHSKeys.USGEnabledKey)) {
            label_name = "Readme Version";
            column_name = "version";
            c = new DbbSqlChunk(BrowserConfig.readme, column_name, label_name);
            w = new DbbCheckBox(label_name, c);
            colPanel_.addWidget(w);
            label_name = "Readme Status";
            column_name = "status";
            c = new DbbSqlChunk(BrowserConfig.readme, column_name, label_name);
            w = new DbbCheckBox(label_name, c);
            colPanel_.addWidget(w);
        }


        

        // Execution Time widget
        // cmavros added 10/Sept/2001
        label_name = "ExecTime";
        column_name = "execution_time";
        c =
            new DbbSqlChunk(
                BrowserConfig.ob,
                column_name,
                label_name,
                DbbExecutionTime.class);
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);
        
        
        label_name = "Sidereal Time Start";
        column_name = "start_interval";
        c =
            new DbbSqlChunk(
                BrowserConfig.sidereal_time_intervals_view,
                column_name,
                label_name,
                DbbHHMMDateTime.class);
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);
        
        
        label_name = "Sidereal Time End";
        column_name = "end_interval";
        c =
            new DbbSqlChunk(
                BrowserConfig.sidereal_time_intervals_view,
                column_name,
                label_name,
                DbbHHMMDateTime.class);
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);

        label_name = "Baseline";
        column_name = "baseline_name";
        c =
            new DbbSqlChunk(
                BrowserConfig.baselines,
                column_name,
                label_name
                );
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);

        

        column_name = "mask_status";
        label_name = "Mask Status";

        c =
            new DbbSqlChunk(
                    BrowserConfig.masks_table,
                column_name,
                label_name,
                MaskStatusType.class);
        maskStatusBox = new MaskInfoDbbCheckBox(label_name, c);

        colPanel_.addWidget(maskStatusBox);

        //maskStatusBox.addSqlChunk(obIDMaskChunk);

        //maskStatusBox.fireDbbWidgetAction();

        column_name = "mask_slot_num";
        label_name = "Mask Stot Num";

        c = new DbbSqlChunk(BrowserConfig.masks_table, column_name, label_name);
        maskSlotNumBox = new DbbCheckBox(label_name, c);
        //maskSlotNumBox.addSqlChunk(obIDMaskChunk);
        colPanel_.addWidget(maskSlotNumBox);

        column_name = "adp_index";
        label_name = "Channel";

        maskChannelBox = new DbbCheckBox(label_name, adpMaskChunk);
        //maskSlotNumBox.addSqlChunk(obIDMaskChunk);
        colPanel_.addWidget(maskChannelBox);
        maskChannelBox.setEnabled(true);
        

        column_name = "bar_code";
        label_name = "Barcode";


        c =
            new DbbSqlChunk(
                    BrowserConfig.masks_table,
                column_name,
                label_name,
                String.class);
                        

        new DbbCheckBox(label_name,c);
        //maskSlotNumBox.addSqlChunk(obIDMaskChunk);
        colPanel_.addWidget(new DbbCheckBox(label_name,c));

        //maskChannelBox.set("T");

        // Last Modification Date widget
        // <br>ChangeLog: tcanavan added
        label_name = "LastMod";
        column_name = "last_mod_date";
        c = new DbbSqlChunk(BrowserConfig.ob, column_name, label_name, DbbISODateTime.class);
        w = new DbbCheckBox(label_name, c);
        colPanel_.addWidget(w);

        // Run State widget
        // amchavan, 24-Oct-2001: added
        // amchavan, 21-Nov-2001: commented out again, see 0704
        /*
        label_name = "Run State";
        column_name = "run_state";
        c = new DbbSqlChunk( run_states_, column_name, label_name );
        w = new DbbCheckBox( label_name, c );
        colPanel_.addWidget( w );
        */

        view_.getDbbView().setColumnsPanel(colPanel_, "North");
    }

    /**
     * Build DB browser view: rows selection panel
     * <br>ChangeLog: amchavan, 24-Aug-2001: fixed bug 1489.
     */
    private void buildRows() {

        rowPanel_ = new DbbPanel("Selection Criteria", 5);
        DbbSqlChunk c;
        DbbTextField w;
        String label_name;
        String column_name;

        DbbSqlOperator op_equal = null;
        DbbSqlOperator op_min = null;
        DbbSqlOperator op_max = null;
        DbbSqlOperator op_like = null;
        DbbSqlOperator op_in = null;
        DbbSqlOperator op_between = null;
        try {
            op_equal = new DbbSqlOperator("=");
            op_min = new DbbSqlOperator("<=");
            op_max = new DbbSqlOperator(">=");
            op_like = new DbbSqlOperator("like");
            op_in = new DbbSqlOperator("in");
            op_between = new DbbSqlOperator("between");

        } catch (Exception e) {
            stdlog_.error(e);
        }

        // Period
        label_name = "Period";
        column_name = "period";
        c = new DbbSqlChunk(BrowserConfig.sr, column_name, label_name, op_in, Integer.class);
        final int lastPeriod_ = Period.getCurrentPeriod() + Period.ADDITIONAL;
        int numPeriods = lastPeriod_ - Period.STARTPERIOD + 1;
        Integer[] periodArr = new Integer[numPeriods];
        for (int i = 0; i < numPeriods; i++) {
            periodArr[i] = new Integer(i + Period.STARTPERIOD);
        }
        DbbSelectionList widget = new DbbSelectionList(label_name, c, periodArr);
        rowPanel_.addWidget(widget);

        // ProposalID
        label_name = "Program ID";
        column_name = "progid";
        c = new DbbSqlChunk(BrowserConfig.sr, column_name, label_name, op_like, String.class);
        w = new DbbTextFieldPattern(label_name, c);
        rowPanel_.addWidget(w);

        // User Name
        label_name = "UserName";
        column_name = "username";
        c =
            new DbbSqlChunk(
                BrowserConfig.accounts,
                column_name,
                label_name,
                op_like,
                String.class);
        w = new DbbTextFieldPattern(label_name, c);
        rowPanel_.addWidget(w);
        if (!Config.getCfg().isSuperUser()) {        	
            w.set(" " + Config.getCfg().getUsername()+ " "); //HACK
            w.setEnabled(false);
        }

        /** Status */
        label_name = " Status";
        column_name = "status";
        c = new DbbSqlChunk(BrowserConfig.ob, column_name, label_name, op_in, String.class);

        // Object[] statusValues = CalibrationBlock.getStatusValues().values();
        // String[] statusDispValues = CalibrationBlock.getStatusValues().keys();
        /* DbbSelectionList status = new DbbSelectionList(label_name,
             c, statusValues, statusDispValues);
        */
        DbbSelectionList status =
            new DbbSelectionList(
                label_name,
                c,
                CalibrationBlock.getStatusValues().valuesAsStrings(),
                CalibrationBlock.markLabels);
        rowPanel_.addWidget(status);

        /*gorgio
        //status
        label_name = "Status";
        column_name = "status";
        c = new DbbSqlChunk(BrowserConfig.ob, column_name, label_name,
          op_in, String.class);
        Object [] dbSValues = CalibrationBlock.getStatusValues().values();
        String [] displaySValues = CalibrationBlock.getStatusValues().keys();
        DbbSelectionList statusSL = new DbbSelectionList(label_name,c,
          dbSValues, displaySValues);
         //!!!! USE A MULTIPLE SELECTION
        rowPanel_.addWidget(statusSL);
        */

        /** Instruments
         *  cmavros 05/10/01 Change to a multi-select list
         */
        label_name = "Instrument";
        column_name = "instrument";
        c = new DbbSqlChunk(BrowserConfig.od, column_name, label_name, op_in, String.class);
        DbbSelectionList w1 =
            new DbbSelectionList(
                label_name,
                c,
                InstrumentList.getInstance().getInstrumentNames());
        rowPanel_.addWidget(w1, true);

        // Templates
        label_name = "Template";
        column_name = "item_name";
        c = new DbbSqlChunk(BrowserConfig.ts, column_name, label_name, op_like, String.class);
        w = new DbbTextFieldPattern(label_name, c);
        rowPanel_.addWidget(w);

        //Filters
        //Filter
        //optElem
        label_name = "OptElem";
        column_name = "subtype";

        // Object[] fltDisp = { "Filter", "Grism" };
        // Object[] fltDb = { new Integer(1), new Integer(2)};

        c = new DbbSqlChunk(BrowserConfig.pm, column_name, label_name, op_in, Integer.class);

        // Parameter.filters.printKeys();
        // Parameter.filters.printValues();
        //stdlog_.info("ot.gui.RepositoryBrowserView values = " +
        //   Parameter.filters.values());
        //stdlog_.info("ot.gui.RepositoryBrowserView keys  = " +
        //   Parameter.filters.keys());

        DbbSelectionList filter =
            new DbbSelectionList(
                label_name,
                c,
                Parameter.filters.valuesAsObjects(),
                Parameter.filters.keys());
        rowPanel_.addWidget(filter);

        // OB Name
        label_name = "OB Name";
        column_name = "item_name";
        c = new DbbSqlChunk(BrowserConfig.ob, column_name, label_name, op_like, String.class);
        w = new DbbTextFieldPattern(label_name, c);
        rowPanel_.addWidget(w);
        
        
        if(Config.getCfg().isInOperationsMode()) {
            // OB Id min
            label_name = "OB ID Min";
            column_name = "ob_id";
            DbbSqlChunkGroupMember minOBId =
                new DbbSqlChunkGroupMember(
                    BrowserConfig.ob,
                    column_name,
                    label_name,
                    op_max,
                    Integer.class);
            DbbSqlChunkGroupMember maxOBId =
                new DbbSqlChunkGroupMember(
                    BrowserConfig.ob,
                    column_name,
                    label_name,
                    op_min,
                    Integer.class);

            // group min and max together in a SqlChunkGroup
            // DbbSqlChunkGroup raGroup = new CyclingMaxMinChunk(min, max);



            rowPanel_.addWidget(
                new DbbIntegerTextField(label_name, minOBId),
                true);

            // OB ID  max
            label_name = "OB ID Max";
            column_name = "ob_id";
            rowPanel_.addWidget(new DbbIntegerTextField(label_name, maxOBId));
        }
                
        
        // RA min
        label_name = "RA min";
        column_name = "ra";

        DbbSqlChunkGroupMember min =
            new DbbSqlChunkGroupMember(
                BrowserConfig.tp,
                column_name,
                label_name,
                op_max,
                DbaseRA.class);
        DbbSqlChunkGroupMember max =
            new DbbSqlChunkGroupMember(
                BrowserConfig.tp,
                column_name,
                label_name,
                op_min,
                DbaseRA.class);

        // group min and max together in a SqlChunkGroup
        /* DbbSqlChunkGroup raGroup = */
        new CyclingMaxMinChunk(min, max);

        // <br>ChangeLog: amchavan, 24-Aug-2001: 1489
        //                  Coordinate.class);
        rowPanel_.addWidget(new DbbCoordinateTextField(label_name, min, true), true);

        // RA max
        label_name = "RA max";
        column_name = "ra";

        // <br>ChangeLog: amchavan, 24-Aug-2001: 1489
        //          Coordinate.class);
        rowPanel_.addWidget(new DbbCoordinateTextField(label_name, max, true));

        // Dec min
        label_name = "Dec min";
        column_name = "dec";

        c =
            new DbbSqlChunk(
                BrowserConfig.tp,
                column_name,
                label_name,
                op_max,
                DbaseDec.class);

        // <br>ChangeLog: amchavan, 24-Aug-2001: 1489
        //          Coordinate.class);
        rowPanel_.addWidget(new DbbCoordinateTextField(label_name, c, false));

        // Dec max
        label_name = "Dec max";
        column_name = "dec";

        c =
            new DbbSqlChunk(
                BrowserConfig.tp,
                column_name,
                label_name,
                op_min,
                DbaseDec.class);

        // <br>ChangeLog: amchavan, 24-Aug-2001: 1489
        //          Coordinate.class);

        rowPanel_.addWidget(new DbbCoordinateTextField(label_name, c, false));

        // Airmass min
        label_name = "Airmass min";
        column_name = "airmass";

        c = new DbbSqlChunk(BrowserConfig.cs, column_name, label_name, op_max, Double.class);
        DbbAirmassTextField airmassMin = new DbbAirmassTextField(label_name, c);
        airmassMin.setToolTipText("  Enter value within range: 1.0..5.0");
        rowPanel_.addWidget(airmassMin, true);

        // Airmass max
        label_name = "Airmass max";
        column_name = "airmass";

        c = new DbbSqlChunk(BrowserConfig.cs, column_name, label_name, op_min, Double.class);
        DbbAirmassTextField airmassMax = new DbbAirmassTextField(label_name, c);
        airmassMax.setToolTipText("  Enter value within range: 1.0..5.0");
        rowPanel_.addWidget(airmassMax);

        // Seeing min
        label_name = " Seeing min";
        column_name = "seeing";

        c = new DbbSqlChunk(BrowserConfig.cs, column_name, label_name, op_max, Double.class);
        DbbSeeingTextField seeingMin = new DbbSeeingTextField(label_name, c);
        seeingMin.setToolTipText("Enter value within range: 0.2..2.0");
        rowPanel_.addWidget(seeingMin);

        // Seeing max
        label_name = "Seeing max";
        column_name = "seeing";

        c = new DbbSqlChunk(BrowserConfig.cs, column_name, label_name, op_min, Double.class);
        DbbSeeingTextField seeingMax = new DbbSeeingTextField(label_name, c);
        seeingMax.setToolTipText("Enter value within range: 0.2..2.0");
        rowPanel_.addWidget(seeingMax);

        // MoonDis min
        label_name = "MoonDis min";
        column_name = "moon_distance";

        c = new DbbSqlChunk(BrowserConfig.cs, column_name, label_name, op_max, Double.class);

        DbbMoonAngularTextField moonMin = new DbbMoonAngularTextField(label_name, c);
        moonMin.setToolTipText("Enter value within range: 0..180");
        rowPanel_.addWidget(moonMin, true);

        // MoonDis max
        label_name = "MoonDis max";
        column_name = "moon_distance";

        c = new DbbSqlChunk(BrowserConfig.cs, column_name, label_name, op_min, Double.class);
        DbbMoonAngularTextField moonMax = new DbbMoonAngularTextField(label_name, c);
        moonMax.setToolTipText("Enter value within range: 0..180");
        rowPanel_.addWidget(moonMax);

        // FLI min
        label_name = "FLI min";
        column_name = "fli";

        c = new DbbSqlChunk(BrowserConfig.cs, column_name, label_name, op_max, Double.class);

        DbbFliTextField fliMin = new DbbFliTextField(label_name, c);
        fliMin.setToolTipText("Enter value within range: 0.0..1.0");
        rowPanel_.addWidget(fliMin);

        /** FLI max */
        label_name = "FLI max";
        column_name = "fli";
        c = new DbbSqlChunk(BrowserConfig.cs, column_name, label_name, op_min, Double.class);
        DbbFliTextField fliMax = new DbbFliTextField(label_name, c);
        fliMax.setToolTipText("Enter value within range: 0.0..1.0");
        rowPanel_.addWidget(fliMax);

        /** Exec Time Min
         * cmavros added 10/Sept/2001
         */
        label_name = " ExecTime min";
        column_name = "execution_time";
        c =
            new DbbSqlChunk(
                BrowserConfig.ob,
                column_name,
                label_name,
                op_max,
                DbbExecutionTime.class);
        DbbExecTimeTextField execTimeMin = new DbbExecTimeTextField(label_name, c);
        execTimeMin.setToolTipText("Enter value within range: 00:00:00..23:59:59");
        rowPanel_.addWidget(execTimeMin, true);

        /** Exec Time Max
         * cmavros added 10/Sept/2001
         */
        label_name = " ExecTime max";
        c =
            new DbbSqlChunk(
                BrowserConfig.ob,
                column_name,
                label_name,
                op_min,
                DbbExecutionTime.class);
        DbbExecTimeTextField execTimeMax = new DbbExecTimeTextField(label_name, c);
        execTimeMax.setToolTipText("Enter value within range: 00:00:00..23:59:59");
        rowPanel_.addWidget(execTimeMax);

        // Strehl Ratio min
        label_name = " Strehl min";
        column_name = "strehl_ratio";
        c = new DbbSqlChunk(BrowserConfig.cs, column_name, label_name, op_max, Double.class);
        DbbStrehlRatioTextField srMin = new DbbStrehlRatioTextField(label_name, c);
        srMin.setToolTipText("Enter value within range 0.0..99.99");
        rowPanel_.addWidget(srMin);

        // Strehl Ratio max
        label_name = " Strehl max";
        column_name = "strehl_ratio";
        c = new DbbSqlChunk(BrowserConfig.cs, column_name, label_name, op_min, Double.class);
        DbbStrehlRatioTextField srMax = new DbbStrehlRatioTextField(label_name, c);
        srMax.setToolTipText("Enter value within range 0.0..99.99");
        rowPanel_.addWidget(srMax);

        /** AbsStartTime
         * <br>ChangeLog: amchavan, 09-Oct-2001: [1533] added new chunk
         *                                type DbbISODateTime
         */
        label_name = "Abs StartTime";
        column_name = "start_interval";
        c =
            new DbbSqlChunk(
                BrowserConfig.ti,
                column_name,
                label_name,
                op_max,
                DbbISODateTime.class);
        DbbTextField absST = new DbbTextField(label_name, c);
        absST.setToolTipText("Enter ISO date+time string: yyyy-mm-ddThh:mm:ss");
        rowPanel_.addWidget(absST, true);

        /** AbsEndTime
         * <br>ChangeLog: amchavan, 09-Oct-2001: [1533] added new chunk
         *                                type DbbISODateTime
         */
        label_name = "Abs EndTime";
        column_name = "end_interval";
        c =
            new DbbSqlChunk(
                BrowserConfig.ti,
                column_name,
                label_name,
                op_min,
                DbbISODateTime.class);
        DbbTextField absET = new DbbTextField(label_name, c);
        absET.setToolTipText("Enter ISO date+time string: yyyy-mm-ddThh:mm:ss");
        rowPanel_.addWidget(absET);


        if(Config.getCfg().isInOperationsMode()) {
            label_name = "Sidereal Min";
            column_name = "start_interval";
            DbbSqlChunkGroupMember minSTTime =
                new DbbSqlChunkGroupMember(
                    BrowserConfig.sidereal_time_intervals_view,
                    column_name,
                    label_name,
                    op_between,
                    DbbSiderealTime.class);
            label_name = "Sidereal Max";
            column_name = "end_interval";                   
            DbbSqlChunkGroupMember maxSTTime =
                new DbbSqlChunkGroupMember(
                    BrowserConfig.sidereal_time_intervals_view,
                    column_name,
                    label_name,
                    op_between,
                    DbbSiderealTime.class);

            BetweenChunkGroup clorChunk = new BetweenChunkGroup(minSTTime,maxSTTime);
            
            minSTTime.setSqlChunkGroup(clorChunk);
            maxSTTime.setSqlChunkGroup(clorChunk);
            //rowPanel_.addWidget(clorChunk);
            label_name = "Sidereal Min";
            DbbTextField dbField = new DbbTextField(label_name, minSTTime);
            rowPanel_.addWidget(
                dbField,
                true);  
            dbField.setToolTipText(
                " Enter value between range : 00:00...23:59");

            label_name = "Sidereal Max";
            dbField = new DbbTextField(label_name, maxSTTime);
            dbField.setToolTipText(
                " Enter value between range : 00:00..23:59");            
            rowPanel_.addWidget(dbField);
            
        }



        /** OB Type*/
        label_name = "OB Type";
        column_name = "type";
        c =
            new DbbSqlChunk(
                BrowserConfig.ob,
                column_name,
                label_name,
                op_equal,
                String.class);
        Object[] dbValues = { "O", "C" };
        Object[] dispValues = { "Observation", "Calibration" };
        DbbComboBox type = new DbbComboBox(label_name, c, dispValues, dbValues, true);
        rowPanel_.addWidget(type);

        /** Sky tansparency
         *  cmavros 05/10/01 Change to a multi-select list
         */
        label_name = "SkyTran";
        column_name = "sky_transparency";
        c = new DbbSqlChunk(BrowserConfig.cs, column_name, label_name, op_in, String.class);
        DbbSelectionList sky_tra =
            new DbbSelectionList(
                label_name,
                c,
                ConstraintSet.getDbSkyTransparency(),
                ConstraintSet.getValidSkyTransparency());
        rowPanel_.addWidget(sky_tra);

        /** Mode */
        label_name = "Mode";
        column_name = "obs_mode";
        c =
            new DbbSqlChunk(
                BrowserConfig.sr,
                column_name,
                label_name,
                op_equal,
                String.class);
        Object[] dbModeValues = { "s", "v" };
        Object[] dispModeValues = { "Service", "Visitor" };
        DbbComboBox mode =
            new DbbComboBox(label_name, c, dispModeValues, dbModeValues, true);
        rowPanel_.addWidget(mode, true);


       

        /** QCGrade
         *  cmavros 05/10/01 Change to a multi-select list
         */
        label_name = "QC Grade";
        column_name = "obs_grade";
        c = new DbbSqlChunk(BrowserConfig.ob, column_name, label_name, op_in, String.class);
        DbbSelectionList QCGrade =
            new DbbSelectionList(label_name, c, CalibrationBlock.QC_GRADE_VALUES);
        rowPanel_.addWidget(QCGrade);

        /* Mask id */
        // table = masksTable;
        //     label_name = "Mask ID";
        //     column_name = "mask_id";
        //     c = new DbbSqlChunk(masks_table, column_name, label_name, op_equal, String.class);
        //     DbbTextField maskId = new DbbTextField(label_name, c);
        //     // <br>ChangeLog: amchavan, 13-Jun-2002: commented out for V.2.4
        //     rowPanel_.addWidget(maskId);

        /* Mask Status */
        //     column_name = "ob_status";
        //     label_name = " Mask Status";
        //     c = new DbbSqlChunk(masks_table, column_name, label_name, op_in, String.class);
        //     AssocList assList = Mask.getStatusValues();
        //     DbbSelectionList selList = new DbbSelectionList(label_name, c,
        //       assList.valuesAsStrings(),assList.keys());
        // <br>ChangeLog: amchavan, 22-Oct-2001: commented out for V.2.2
        // rowPanel_.addWidget(selList);

        /** Queue Id */
        label_name = "Queue Id";
        column_name = "sch_id";
        c =
            new DbbSqlChunk(
                BrowserConfig.sc,
                column_name,
                label_name,
                op_equal,
                Integer.class);
        DbbIntegerTextField queueId = new DbbIntegerTextField(label_name, c);
        rowPanel_.addWidget(queueId);

        /** Rank class
         *  cmavros 04/10/01 Add rank class
         */
        column_name = "rank_class";
        label_name = "Rank Class";
        c = new DbbSqlChunk(BrowserConfig.sr, column_name, label_name, op_in, String.class);
        Object[] rankClassValues = { "A", "B", "C" };
        DbbSelectionList RankClass =
            new DbbSelectionList(label_name, c, rankClassValues);
        rowPanel_.addWidget(RankClass);

        // User name widget
        label_name = "LastName";
        /** cmavros 2002/11/02, 1602/OT */
        column_name = "last_name";
        c = new DbbSqlChunk(BrowserConfig.profiles, column_name, label_name, op_like, String.class);
        w = new DbbTextFieldPattern(label_name, c);
        rowPanel_.addWidget(w, true);
        if (!Config.getCfg().isSuperUser())
            w.setEnabled(false);

        //      Mask status Status
        column_name = "mask_status";
        label_name = "Mask Status";

        c =
            new DbbSqlChunk(
                    BrowserConfig.masks_table,
                column_name,
                label_name,
                op_in,
                String.class);
        AssocList assList = Mask.getStatusValues();
        DbbSelectionList statusList =
            new DbbSelectionList(
                label_name,
                c,
                assList.valuesAsStrings(),
                assList.keys());
        rowPanel_.addWidget(statusList);
        
        
        label_name = "Baseline";
         column_name = "baseline_name";
         c = new DbbSqlChunk(BrowserConfig.baselines, column_name, label_name, op_in, String.class);
         try {
             w1 =
                 new DbbSelectionList(
                     label_name,
                     c,
             ProcessExtraConstraints.getBaseLines());
         } catch (SQLException e1) {
             // TODO Auto-generated catch block
             e1.printStackTrace();
         }            
         rowPanel_.addWidget(w1);      

        // Run State
        // <br>ChangeLog: amchavan, 24-Oct-2001: added
        // amchavan, 21-Nov-2001: commented out again, see 0704
        /*
        label_name = "Run State";
        column_name = "run_state";
        c = new DbbSqlChunk(run_states_, column_name, label_name, op_in, String.class);
        DbbSelectionList runState = new
        DbbSelectionList( label_name, c, BrowserConfig.run_state_values_ );
        rowPanel_.addWidget( runState );
        */

        view_.getDbbView().setWherePanel(rowPanel_, "North");
    }

    /** Build DB browser view: sort selection panel*/
    private void buildSort() {

        sortPanel_ = new DbbPanel("Sorting Criteria", 1);
        DbbSqlChunk c;
        DbbWidget w;
        String column_name;
        String label_name;

        //OB ID
        label_name = "OB ID";
        column_name = "ob_id";

        c = new DbbSqlChunk(BrowserConfig.ob, column_name, label_name);
        w = new DbbArrowButton(label_name, c);
        sortPanel_.addWidget(w);

        // OB NAME
        label_name = "OB Name";
        column_name = "item_name";
        c = new DbbSqlChunk(BrowserConfig.ob, column_name, label_name);
        w = new DbbArrowButton(label_name, c);
        sortPanel_.addWidget(w);

        //////////////////////////
        label_name = "ProgID";
        column_name = "progid";

        c = new DbbSqlChunk(BrowserConfig.sr, column_name, label_name);

        ///////// It was a bug /////////
        //     label_name = "ProgID";
        //     column_name = "proposalID";

        //     c = new DbbSqlChunk(op,
        //          column_name,
        //          label_name);

        w = new DbbArrowButton(label_name, c);
        sortPanel_.addWidget(w);

        //RA
        label_name = "RA";
        column_name = "ra";

        c = new DbbSqlChunk(BrowserConfig.tp, column_name, label_name);
        w = new DbbArrowButton(label_name, c);
        sortPanel_.addWidget(w);

        //DEC
        label_name = "Dec";
        column_name = "dec";

        c = new DbbSqlChunk(BrowserConfig.tp, column_name, label_name);
        w = new DbbArrowButton(label_name, c);
        sortPanel_.addWidget(w);

        //seeing
        label_name = "Seeing";
        column_name = "seeing";

        c = new DbbSqlChunk(BrowserConfig.cs, column_name, label_name);
        w = new DbbArrowButton(label_name, c);
        sortPanel_.addWidget(w);

        //Airmass
        label_name = "Airmass";
        column_name = "airmass";

        c = new DbbSqlChunk(BrowserConfig.cs, column_name, label_name);
        w = new DbbArrowButton(label_name, c);
        sortPanel_.addWidget(w);

        //FLI
        label_name = "FLI";
        column_name = "fli";

        c = new DbbSqlChunk(BrowserConfig.cs, column_name, label_name);
        w = new DbbArrowButton(label_name, c);
        sortPanel_.addWidget(w);

        //Moon Distance
        label_name = "MoonDis";
        column_name = "moon_distance";

        c = new DbbSqlChunk(BrowserConfig.cs, column_name, label_name);
        w = new DbbArrowButton(label_name, c);
        sortPanel_.addWidget(w);

        //Sky Trans
        label_name = "SkyTran";
        column_name = "sky_transparency";

        c = new DbbSqlChunk(BrowserConfig.cs, column_name, label_name);
        w = new DbbArrowButton(label_name, c);
        sortPanel_.addWidget(w);

        //Strehl Ratio
        label_name = "Strehl";
        column_name = "strehl_ratio";

        c = new DbbSqlChunk(BrowserConfig.cs, column_name, label_name);
        w = new DbbArrowButton(label_name, c);
        sortPanel_.addWidget(w);

        //RankClass
        label_name = "RankClass";
        column_name = "rank_class";
        c = new DbbSqlChunk(BrowserConfig.sr, column_name, label_name);
        w = new DbbArrowButton(label_name, c);
        sortPanel_.addWidget(w);

        // Execution Time
        // cmavros added 10/Sept/2001
        label_name = "ExecTime";
        column_name = "execution_time";
        c = new DbbSqlChunk(BrowserConfig.ob, column_name, label_name);
        w = new DbbArrowButton(label_name, c);
        sortPanel_.addWidget(w);
        
        
        label_name = "Finding Charts";
        column_name = "fc_name";
        c = new DbbSqlChunk(BrowserConfig.finds_view, column_name, label_name);
        w = new DbbArrowButton(label_name, c);
        sortPanel_.addWidget(w);
        
        
        label_name = "Sidereal Time Start";
        column_name = "start_interval";
        c =
            new DbbSqlChunk(
                BrowserConfig.sidereal_time_intervals_view,
                column_name,
                label_name
                );
        w = new DbbArrowButton(label_name, c);
        sortPanel_.addWidget(w);
        
        
        label_name = "Sidereal Time End";
        column_name = "end_interval";
        c =
            new DbbSqlChunk(
                BrowserConfig.sidereal_time_intervals_view,
                column_name,
                label_name
                );

        w = new DbbArrowButton(label_name, c);
        sortPanel_.addWidget(w);
        
        
        label_name = "Baseline";
        column_name = "baseline_name";
        c = new DbbSqlChunk(BrowserConfig.baselines, column_name, label_name);
        w = new DbbArrowButton(label_name, c);
        sortPanel_.addWidget(w);
        
        
        


        // Run State
        // <br>ChangeLog: amchavan, 24-Oct-2001: added
        // amchavan, 21-Nov-2001: commented out again, see 0704
        /*
        label_name = "Run State";
        column_name = "run_state";
        c = new DbbSqlChunk( run_states_, column_name, label_name );
        w = new DbbArrowButton( label_name, c );
        sortPanel_.addWidget(w);
        */

        label_name = "Mask Status";
        column_name = "mask_status";
        maskStatusSortChunk = new DbbSqlChunk(BrowserConfig.masks_table, column_name, label_name);
        maskStatusSortChunk.setActive(false);
        w = new DbbArrowButton(label_name, maskStatusSortChunk);
        sortPanel_.addWidget(w);

        label_name = "Mask Slot Num";
        column_name = "mask_slot_num";

        c = new DbbSqlChunk(BrowserConfig.masks_table, column_name, label_name);
        w = new DbbArrowButton(label_name, c);
        sortPanel_.addWidget(w);
        
        
        label_name = "Barcode";
        column_name = "bar_code";

        c = new DbbSqlChunk(BrowserConfig.masks_table, column_name, label_name);
        w = new DbbArrowButton(label_name, c);
        sortPanel_.addWidget(w);


        label_name = "Channel";
        column_name = "adp_index";
        c = new DbbSqlChunk(BrowserConfig.obsblk_masks_table, column_name, label_name);
        w = new DbbArrowButton(label_name, c);
        sortPanel_.addWidget(w);

        //view_.setSortPanel(sortPanel_, "North");
        view_.getDbbView().setSortPanel(sortPanel_, "West");

        //addEdit();
        //addFile();
        //addClose();
    }

    /**
     * Return the id of all selected OBs
     * An array of size 0 is returned if no OBs are selected
     * @return the id of all selected OB
     * @param statuses Vector - if non-null, will be filled with String values
     * of the status values of the selected OBs.
     */
    public long[] getSelectedOBsId() {
        return getSelectedOBsId(null);
    }

    /**
     * Return the id of all selected OBs
     * An array of size 0 is returned if no OBs are selected
     * @return the id of all selected OB
     */
    public long[] getSelectedOBsId(Vector<String> statuses) {

        int[] selectedRows = view_.getDbbView().getSelectedRows();
        long[] selectedOBsId = new long[selectedRows.length];
        for (int i = 0; i < selectedRows.length; i++) {
            Integer value = (Integer)view_.getDbbView().getValueAt(selectedRows[i], OTDbbView.OB_ID);
            String type = (String)view_.getDbbView().getValueAt(selectedRows[i], OTDbbView.TYPE);
            if (type.equals("O")) {
                selectedOBsId[i] =
                    Config.getCfg().tableToUniqueId(
                        value.longValue(),
                        ObservationBlock.class);
            } else {
                selectedOBsId[i] =
                    Config.getCfg().tableToUniqueId(
                        value.longValue(),
                        CalibrationBlock.class);
            }
            if (statuses != null) {
                // add the status value if the statuses Vector parameter was given.
                statuses.addElement((String)view_.getDbbView().getValueAt(selectedRows[i], OTDbbView.STATUS));
            }
        }

        return selectedOBsId;
    }

    /**
     * Tests if an OB is displayed into the view
     * @param obId specifies the id of an OB to be checked
     * @return true if the speficied OB is displayed into the view
     */
    protected boolean containOB(long obId) {
        long dbObId = Config.getCfg().uniqueToTableId(obId);
        for (int i = 0; i < view_.getDbbView().getRows(); i++) {
            Integer value = (Integer)view_.getDbbView().getValueAt(i, OTDbbView.OB_ID);
            String type = (String)view_.getDbbView().getValueAt(i, OTDbbView.TYPE);
            long tmpObId = -1;
            if (type.equals("0"))
                tmpObId = value.longValue();
            else
                tmpObId = value.longValue();
            if (tmpObId == dbObId)
                return true;
        }
        return false;
    }

    /**
     * This class is uesd to bring up a popup menu PopupMenu should be
     * displayed when the rigth mouse button is pressed. In this case we
     * determine the coordinates of the click to see if its occurs or not
     * on a tree node or leaf
     */
    private class PopupListener extends MouseAdapter {

        JPopupMenu popup;

        public void mousePressed(MouseEvent e) {
            if (e.getID() == MouseEvent.MOUSE_PRESSED) {
                createPopupMenu();
                popup.show(e.getComponent(), e.getX(), e.getY());
            }
        }

        private void createPopupMenu() {
            popup = new JPopupMenu();

            Vector queueViewMgrVector = OTViewManager.getOTViewMgr().getQueueViews();
            for (int i = 0; i < queueViewMgrVector.size(); i++) {
                QueueView mgr = (QueueView)queueViewMgrVector.elementAt(i);
                JMenuItem crrItem = new JMenuItem(mgr.getQueue().getName());
                popup.add(crrItem);
                crrItem.addActionListener(new QueueOBsAction(mgr));
            }
        }
    }

    /**
     * Action class to append selected OBs to the specified Queue.
     */
    private class QueueOBsAction implements ActionListener {

        /**
         * The QueueViewManager object into which the selected OBs are
         * to be queued.
         */
        private QueueView mgr_;

        protected QueueOBsAction(QueueView m) {
            mgr_ = m;
        }

        public void actionPerformed(ActionEvent e) {
            // ensure only OBs with allowed statuses are queued.
            Vector<String> statuses = new Vector<String>();
            long[] ids = getSelectedOBsId(statuses);
            Vector<Long> idVector = new Vector<Long>();
            int unqueueableOBCount = 0;
            for (int x = 0; x < statuses.size(); x++) {
                if (QueueView.isNotQueueableStatus(statuses.elementAt(x))) {
                    unqueueableOBCount++;
                } else {
                    idVector.addElement(new Long(ids[x]));
                }
            }
            // prompt the user before continuing if there are some
            // OBs that are not queue-able.
            if (unqueueableOBCount == 0
                || JOptionPane.showConfirmDialog(
                    table_.getTopLevelAncestor(),
                    ""
                        + unqueueableOBCount
                        + " of the selected OBs have a status of"
                        + "\n'D' or '-' and will not be queued."
                        + "\nDo you wish to continue?",
                    "Queueing OBs",
                    JOptionPane.OK_CANCEL_OPTION,
                    JOptionPane.QUESTION_MESSAGE,
                    null)
                    == JOptionPane.YES_OPTION) {
                if (unqueueableOBCount > 0) {
                    // create a new ids array containing only queue-able OBs
                    ids = new long[idVector.size()];
                    for (int i = 0; i < ids.length; i++) {
                        ids[i] = idVector.elementAt(i).longValue();
                    }
                }
                mgr_.appendOB(ids);
            }
        }
    }

    private class StatusPopupListener extends MouseAdapter {

        public void mousePressed(MouseEvent e) {
            if (e.getID() == MouseEvent.MOUSE_PRESSED) {
                JPopupMenu popup = createPopupMenu();
                popup.show(e.getComponent(), e.getX(), e.getY());
            }
        }
    }

    private class RightClickStatusPopupListener extends MouseAdapter {
        public void mousePressed(MouseEvent e) {
            if (e.getID() == MouseEvent.MOUSE_PRESSED
                && (e.getModifiers() & MouseEvent.BUTTON3_MASK) != 0) {
                JPopupMenu popup = createPopupMenu();
                popup.show(e.getComponent(), e.getX(), e.getY());
            }
        }
    }

    private JPopupMenu createPopupMenu() {
        JPopupMenu popup = new JPopupMenu();
        for (int i = 0; i < CalibrationBlock.markLabels.length; i++) {
            final int j = i;
            JMenuItem crrItem = new JMenuItem(CalibrationBlock.markLabels[i]);
            popup.add(crrItem);
            crrItem.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    // JOptionPane.showMessageDialog(null, "NOT IMPLEMENTED", "WARNING", JOptionPane.WARNING_MESSAGE);
                    markStatus(j);
                }
            });
        }
        popup.pack();
        return popup;
    }

    /**
     * Marks the  status of an Observation Block
     */
    private void markStatus(int i) {

        long[] OBIDs = getSelectedOBsId();
        // ObjectManager objMgr = ObjectManager.getObjectManager();
        boolean obDequeueRequired = QueueView.isNotQueueableStatus(i);
        // If this status to be set requirs dequeuing the selected OB,
        // inform the user that this status requires all selected OBs to
        // be removed from Queues prior to setting the status - continue y/n?
        if (!obDequeueRequired
            || JOptionPane.showConfirmDialog(
                table_.getTopLevelAncestor(),
                "Setting OBs to status '"
                    + CalibrationBlock.markLabels[i]
                    + "'\nwill remove them from all queues."
                    + "\nDo you wish to continue?",
                "Setting Status",
                JOptionPane.OK_CANCEL_OPTION,
                JOptionPane.QUESTION_MESSAGE,
                null)
                == JOptionPane.YES_OPTION) {
            try {
                QueueView.markStatus(OBIDs, i);
            } catch (ObjectNotFoundException e) {
                stdlog_.error(e);
                ErrorMessages.announceNoObject(table_, e);
            } catch (ObjectIOException e) {
                ErrorMessages.announceIOError(table_, e);
                stdlog_.error(e);
            }
            currentRow_ = view_.getDbbView().getSelectedRow();
            getDbbView().sqlStartAction(null);
        }
    }
    
    
    
    private class ReadmeStatusPopupListener extends MouseAdapter {
        public void mousePressed(MouseEvent e) {
            if (e.getID() == MouseEvent.MOUSE_PRESSED) {
                JPopupMenu popup = createReadmePopupMenu();
                popup.show(e.getComponent(), e.getX(), e.getY());
            }
        }
    }

    private JPopupMenu createReadmePopupMenu() {
        JPopupMenu popup = new JPopupMenu();
        String[] items = Readme.statusValues_.keys();
        for (int i = 0; i < items.length; i++) {
            final int j = i;
            JMenuItem crrItem = new JMenuItem(items[i]);
            popup.add(crrItem);
            crrItem.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    markReadmeStatus(j);
                }
            });
        }
        popup.pack();
        return popup;
    }

    /**
     * Marks the  status of an Observation Block
     */
    private void markReadmeStatus(int i) {
        ObjectManager objMgr = ObjectManager.getObjectManager();
        long[] obIDs = getSelectedOBsId();
        CalibrationBlock cb;
        if(obIDs.length  == 0)
            return;
        try {
            cb =
                (CalibrationBlock) objMgr.getBusObj(
                    Media.DBASE,
                    obIDs[0],
                    Config.getCfg().getClassFromId(obIDs[0]));
            ObservingRun obsRun = cb.getObsRun();
            QueueView.markReadmeStatus(
                obsRun,
                i);                            
        } catch (ObjectNotFoundException e1) {
            ErrorMessages.announceNoObject(getParent(),e1);
        } catch (ObjectIOException e1) {
            ErrorMessages.announceIOError(getParent(),e1);
        } catch (IOException e1) {
            ErrorMessages.announceIOError(getParent(),e1);
        }
        currentRow_ = view_.getDbbView().getSelectedRow();
        getDbbView().sqlStartAction(null);
    }

    
    

    private void deleteOB() {
        try {
            String text =
                "Are you sure you want to " + "delete the following OB(s)?\n";
            long[] selectedOBsId = getSelectedOBsId();
            if (verifyDelete(text) == JOptionPane.YES_OPTION) {
                //QueueManagerImpl queMgr = new QueueManagerImpl();
                QueueManager.removeOBs(selectedOBsId);
                Vector queueViewMgrVector =
                    OTViewManager.getOTViewMgr().getQueueViews();
                for (int i = 0; i < queueViewMgrVector.size(); i++) {
                    QueueView mgr = (QueueView)queueViewMgrVector.elementAt(i);
                    Queue queue = mgr.getQueue();
                    boolean update = queue.isUpdate();
                    mgr.getQueueItemsView().removeOBs(selectedOBsId);
                    queue.setUpdateAndFire(update);
                }
                currentRow_ = view_.getDbbView().getSelectedRow();
                getDbbView().sqlStartAction(null);
            }
        } catch (ObjectIOException e) {
            JOptionPane.showMessageDialog(
                table_.getTopLevelAncestor(),
                e.getMessage(),
                "SQL Error",
                JOptionPane.ERROR_MESSAGE);
            stdlog_.error(e); // XXX Show bett
        }
    }

    /**
     * Verify that user wants selected items deleted.
     * <br>
     * @param text Explanatory text
     * @return dialog JOptionPane (YES, NO, CANCEL)
     * <br>ChangeLog: amchavan, 21-Nov-2001: added param text
     */
    private int verifyDelete(String text) {

        long[] selectedOBsId = getSelectedOBsId();
        if (selectedOBsId.length == 0) {
            JOptionPane.showMessageDialog(
                table_.getTopLevelAncestor(),
                new Object[] {
                    "There are no selected objects of this type.",
                    "Which objects should be deleted?",
                    },
                "Nothing selected",
                JOptionPane.ERROR_MESSAGE);
            return (JOptionPane.CANCEL_OPTION);
        }

        StringBuffer sb = new StringBuffer(text);
        for (int j = 0; j < selectedOBsId.length; j++) {
            sb.append("     ");
            sb.append(Config.getCfg().uniqueToTableId(selectedOBsId[j]));
            sb.append("     ");
            //Align output in columns
            if (j % 3 == 1)
                sb.append("\n");
        }

        return (
            JOptionPane.showConfirmDialog(
                table_.getTopLevelAncestor(),
                sb.toString(),
                "Delete",
                JOptionPane.OK_CANCEL_OPTION,
                JOptionPane.QUESTION_MESSAGE,
                null));
    }

    private void deleteQueuesReference() {
        deleteQueuesReference(true);
    }

    private void deleteQueuesReference(boolean promptUser) {
        String text =
            "Are you sure you want to "
                + "delete the following OB(s)\n"
                + "from all queues?\n";
        long[] selectedOBsId = getSelectedOBsId();
        if (!promptUser || verifyDelete(text) == JOptionPane.YES_OPTION) {
            try {
                QueueView.deleteQueuesReference(selectedOBsId);
            } catch (ObjectIOException ex) {
                stdlog_.warn("ot.gui.RepositoryBrowerView " + ex.getMessage());
                ex.printStackTrace();
            }
        }
    }

    private void viewQueuesHoldingOBs() {
        try {
            long[] selectedOBsId = getSelectedOBsId();
            String text = QueueManager.reportReferencingQueues(selectedOBsId);
            queueHoldingView.setVisible(false);
            queueHoldingView.setVisible(true);
            queueHoldingView.clearTextArea();
            queueHoldingView.setTextArea(text);
        } catch (ObjectIOException ex) {
            // String message = ex.getMessage();
            JOptionPane.showMessageDialog(
                table_.getTopLevelAncestor(),
                ex.getMessage(),
                "ERROR",
                JOptionPane.ERROR_MESSAGE);
            ex.printStackTrace();
        }
    }

    private class QueryTerminatedListener implements DbbQueryTerminatedListener {
        public void queryTerminatedAction(DbbQueryTerminated ev) {
            // int row = view_.getSelectedRow();
            if (currentRow_ < view_.getJTable().getRowCount()) {
                view_.getDbbView().setSelectedRow(currentRow_);
                JTable table = view_.getJTable();
                Rectangle r = table.getCellRect(currentRow_, 1, true);
                table.scrollRectToVisible(r);
                currentRow_ = 0;
            }
        }
    }

    /**
     * All removeMenuItems calls and a call to this classes close method
     * are needed because of a known memory problem in JFrame.
     */
    public void disposeNoSave() {
        close();
        super.dispose();
    }

    /**
     * This close metod is required to fix the known memory probem in JFrame
     */
    public void close() {
        Dimension d = getSize();
        RepaintManager.currentManager(this).getOffscreenBuffer(
            this,
            d.width,
            d.height);
    }

    public static RepositoryBrowserView getDbaseWindow() throws ObjectIOException {
        if (repView_ == null) {
            synchronized (RepositoryBrowserView.class) {
                if (repView_ == null) {
                    repView_ = new RepositoryBrowserView();
                }
            }
        }
        return repView_;
    }

    private class MaskInfoDbbCheckBox extends DbbCheckBox {

        public MaskInfoDbbCheckBox(String label, DbbSqlChunk c) {
            super(label, c);
            //((JCheckBox)widget_).getModel().addItemListener(this);
        }

        public void itemStateChanged(ItemEvent ev) {
            //if(ev.isAdjusting())
            //   return;
            if (ev.getStateChange() == ItemEvent.SELECTED
                && !maskStatusBox.isEmpty()
                || !maskSlotNumBox.isEmpty()) {
                maskChannelBox.set("T");
            } else {
                maskChannelBox.set("F");
            }
        }
    }

    /**
     * The action that applies the values to the widgets
     * to the panels of the dbbbrowser
     */
    public class ConfigValuesAction extends ActionSuperclass {

        GTreeNode colNames_;
        GTreeNode rowNames_;
        GTreeNode sortNames_;

        public ConfigValuesAction(
            JFrame repBrowserView,
            String name,
            GTreeNode colNames,
            GTreeNode rowNames,
            GTreeNode sortNames) {
            super(repBrowserView, name);
            colNames_ = colNames;
            rowNames_ = rowNames;
            sortNames_ = sortNames;
        }

        public final void actionPerformedImpl(final ActionEvent ev) {
            colPanel_.setValueWidgets(colNames_);
            rowPanel_.setValueWidgets(rowNames_);
            sortPanel_.setValueWidgets(sortNames_);
        }
    }
}


