package org.eso.ohs.phase2.apps.ot.wizard;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.eso.ohs.core.utilities.MsgManager;
import org.eso.ohs.phase2.orang.OrangModel;
import org.eso.ohs.phase2.orang.OrangScriptException;
import org.eso.ohs.phase2.orang.OrangWidgetsData;

public class AlgorithmChooserPanel extends JPanel {
    
    
    private JLabel labelAlgorithm = new JLabel();
    private JComboBox comboBoxAlgorithm = new JComboBox();
	private String valString;    
    

    

    public AlgorithmChooserPanel() {
		createPanel();
	}


	public JPanel createPanel()
    {
       
       
       GridBagLayout layout = new GridBagLayout();
       setLayout(layout);
       
       GridBagConstraints gridBagConstraints ;       


       labelAlgorithm = new JLabel();
       labelAlgorithm.setName("labelAlgorithm");
       labelAlgorithm.setText("Algorithm");
       
       gridBagConstraints = OrangGUICommon.getGridBagConstraints(0, 1, GridBagConstraints.WEST,1,5,0,0);
       add(labelAlgorithm,gridBagConstraints);

       
       comboBoxAlgorithm = new JComboBox();
       gridBagConstraints = OrangGUICommon.getGridBagConstraints(1, 1, GridBagConstraints.WEST,1,5,0,0);
       comboBoxAlgorithm.setName("comboBoxAlgorithm");
       add(comboBoxAlgorithm,gridBagConstraints);
              
       return this;
    }


    protected boolean isReady() { 
        if ( comboBoxAlgorithm.getSelectedIndex()< 0) {
           	valString = "\nNo algorithm selected.";
           	return(false);
           	
        } else {
        	return(true);
        }
    }

	public JComboBox getComboBoxAlgorithm() {
		return comboBoxAlgorithm;
	}


	/**
	 *  void removes the items and reload them
	 */
	public  void initData(OrangWidgetsData dataWidgets) {
	    String[] algoritmList = new String[0];
	    try {
	        algoritmList = dataWidgets.getAlgorithmList();
	    } catch (OrangScriptException e) {
	       MsgManager.errDialog(e);            
	    }
	    if (getComboBoxAlgorithm().getItemCount() > 0){
	    	getComboBoxAlgorithm().removeAllItems();
	    }
	    for (int i = 0; i < algoritmList.length; i++) {
	    	getComboBoxAlgorithm().addItem(algoritmList[i]);
	    }
	}


	public void updateModel(OrangModel model) {
		
		String algorithm = (String)comboBoxAlgorithm.getSelectedItem();
		model.setRankingAlgorithm(algorithm);
	}
	
	public String getValidationString() {
		if ( valString != null ) 
			return valString;
		else
			return "";
			
	}



}
