package org.eso.ohs.phase2.apps.ot.wizard;

import java.awt.BorderLayout;

import org.eso.ohs.core.gui.widgets.OHSWizard;
import org.eso.ohs.core.gui.widgets.OHSWizardPage;
import org.eso.ohs.phase2.orang.OrangModel;
import org.eso.ohs.phase2.orang.OrangWidgetsData;



/**
 *  The ORANG wizard page that allows the user to select the OBs he wants to consider
 *  Contains a WizardTitle panel and an OBSelectPanel
 * 
 * @author pnunes 20.12.2005
 *
 */
public class OBSelectPage extends OHSWizardPage {

    private static final String OB_SELECT_TITLE = "Step 1: select the OBs you want to consider";
    private OBSelectPanel obSelectPanel;
        
    
    /**
     * Default constructor
     */
    public OBSelectPage(OHSWizard controller, OrangWidgetsData data) {
        super(controller);
        obSelectPanel = new OBSelectPanel(data);        
        initialize();
    }

   

    /**
     * Initializer
     */
    protected void initialize() {
    	BorderLayout layout  = new BorderLayout();
	    setLayout(layout);	
	    
    	add(OrangGUICommon.getWizardTitlePanel(OB_SELECT_TITLE),BorderLayout.NORTH);    	    	
    	add(obSelectPanel.create(), BorderLayout.SOUTH);

    	
    	
    	
        listenTo(obSelectPanel.getListBoxQueues());
        listenTo(obSelectPanel.getComboBoxInstrument());
        listenTo(obSelectPanel.getComboBoxTelescope());
        listenTo(obSelectPanel.getRadioButtonQueues());
        listenTo(obSelectPanel.getRadioButtonTelescope());
        listenTo(obSelectPanel.getRadioButtonInstrument());
        listenTo(obSelectPanel.getStepComboBox());
        listenTo(obSelectPanel.getStartTimeTextField());
        listenTo(obSelectPanel.getDurationComboBox());
        
        obSelectPanel.initData();
        
        obSelectPanel.getRadioButtonQueues().setSelected(true);
        obSelectPanel.getRadioButtonQueues().doClick();
    }



	public void updateModel(OrangModel model) {
		this.obSelectPanel.updateModel(model);
	}



	protected boolean isReady() {
		return(obSelectPanel.isReady());
	}
      
    
    
}
