package org.eso.ohs.phase2.apps.ot.wizard;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.text.ParseException;
import java.util.Date;

import javax.swing.AbstractAction;
import javax.swing.DefaultButtonModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextField;

import org.eso.ohs.core.gui.utilities.Utilities;
import org.eso.ohs.core.gui.widgets.OHSButtonGroup;
import org.eso.ohs.core.utilities.Convert;
import org.eso.ohs.phase2.orang.OrangModel;
import org.eso.ohs.phase2.orang.OrangWidgetsData;



/**
 * This panel allows the user too choose the OBs he wants to consider in ORANG
 * 
 * @author pnunes 20.12.2005
 *
 */
public class OBSelectPanel extends JPanel {

	private static final long serialVersionUID = 1L;
	private JComboBox comboBoxInstrument = new JComboBox();
	private JComboBox comboBoxTelescope = new JComboBox();
	private OrangWidgetsData dataWidgets = null;
	private JComboBox durationComboBox = new JComboBox();
	private JLabel durationLabel = new JLabel();	
	
	private JList listBoxQueues = new JList();
	private JButton nowButton = new JButton();
	private OHSButtonGroup obSelectionGroup = new OHSButtonGroup("obSelectionGroup");
	private JRadioButton radioButtonInstrument = new JRadioButton();
	private JRadioButton radioButtonQueues = new JRadioButton();
	private JRadioButton radioButtonTelescope = new JRadioButton();
	private JLabel startTimeLabel = new JLabel();
	private JTextField startTimeTextField = new JTextField();
	private JComboBox stepComboBox = new JComboBox();
	private JLabel stepIntervalLabel = new JLabel();
	private String valString;

		
	
	public OBSelectPanel(OrangWidgetsData dataWidgets) {
		this.dataWidgets = dataWidgets;
		create();
		initialize();
	}


	public JPanel create() {
	    setName("jPanel");
	    
	    GridBagLayout gridBagLayout = new GridBagLayout();
	    setLayout(gridBagLayout);
	    	    
	    radioButtonTelescope.setActionCommand("Telescope today queues");
	    radioButtonTelescope.setName("radioButtonTelescope");
	    radioButtonTelescope.setText("Telescope today queues");
	    radioButtonTelescope
	            .setToolTipText("Select all today queues from a telescope");
	    radioButtonTelescope.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
            	radioButtonTelescopeActionPerformed(evt);
            }			
        });
	    
	    
	    obSelectionGroup.add(radioButtonTelescope);        
	    GridBagConstraints gridBagConstraints = OrangGUICommon.getGridBagConstraints(0, 1, GridBagConstraints.WEST,1,5,0,0);             
	    add(radioButtonTelescope, gridBagConstraints);
	    
	    comboBoxTelescope.setName("comboBoxTelescope");
	    gridBagConstraints = OrangGUICommon.getGridBagConstraints(1, 1, GridBagConstraints.WEST,1,5,0,0);
	    add(comboBoxTelescope, gridBagConstraints);
	    
	
	    radioButtonInstrument.setActionCommand("Instrument today queues");
	    radioButtonInstrument.setName("radioButtonInstrument");
	    radioButtonInstrument.setText("Instrument today queues");
	    radioButtonInstrument
	            .setToolTipText("Select all today queues from an instrument");
	    radioButtonInstrument.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
            	radioButtonInstrumentActionPerformed(evt);
            }			
        });
	    obSelectionGroup.add(radioButtonInstrument);
	    gridBagConstraints = OrangGUICommon.getGridBagConstraints(0, 2, GridBagConstraints.WEST,1,5,0,0);
	    add(radioButtonInstrument, gridBagConstraints);
	    
	    comboBoxInstrument.setName("comboBoxInstrument");
	    gridBagConstraints = OrangGUICommon.getGridBagConstraints(1, 2, GridBagConstraints.WEST,1,5,0,0);
	    add(comboBoxInstrument, gridBagConstraints);
	    
	    
	    radioButtonQueues.setActionCommand("Queues");
	    radioButtonQueues.setName("radioButtonQueues");
	    radioButtonQueues.setText("Queues");
	    radioButtonQueues.setToolTipText("Select one ore more queues");
	    radioButtonQueues.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
            	radioButtonQueuesActionPerformed(evt);
            }			
        });
	    
	    obSelectionGroup.add(radioButtonQueues);
	    gridBagConstraints = OrangGUICommon.getGridBagConstraints(0, 3, GridBagConstraints.NORTHWEST,1,5,0,0);
	    add(radioButtonQueues, gridBagConstraints);
	
	    listBoxQueues.setName("listBoxQueues");
	    listBoxQueues.setVisibleRowCount(5);
	    JScrollPane jscrollpane1 = new JScrollPane();
	    jscrollpane1.setViewportView(listBoxQueues);
	    jscrollpane1
	            .setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
	    jscrollpane1
	            .setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
	    gridBagConstraints = OrangGUICommon.getGridBagConstraints(1, 3, GridBagConstraints.WEST,1,5,0,0);
	    add(jscrollpane1, gridBagConstraints);        
	    
	            
	    
	    startTimeLabel.setName("startTimeLabel");
	    startTimeLabel.setText("UT Start Time:");
	    startTimeLabel.setToolTipText("UT time.");
	    gridBagConstraints = OrangGUICommon.getGridBagConstraints(0, 4, GridBagConstraints.WEST,1,5,0,0);
	    add(startTimeLabel, gridBagConstraints);
	    
	    startTimeTextField.setName("startTimeTextField");
        nowButton.setActionCommand("Now");
        nowButton.setName("nowButton");
        nowButton.setText("Now");
        
        JPanel startTimePanel = new JPanel();       
        startTimePanel.add(startTimeTextField);     
        startTimePanel.add(nowButton);
	    gridBagConstraints = OrangGUICommon.getGridBagConstraints(1, 4, GridBagConstraints.WEST,1,5,0,0);
	    add(startTimePanel, gridBagConstraints);
	    
	  
	  //  gridBagConstraints = OrangGUICommon.getGridBagConstraints(2, 4, GridBagConstraints.WEST,1,5,0,0);
	  //  add(nowButton, gridBagConstraints);
	    
	
	    durationLabel.setName("durationLabel");
	    durationLabel.setText("Duration(hours):");        
	    gridBagConstraints = OrangGUICommon.getGridBagConstraints(0, 5, GridBagConstraints.WEST,1,5,0,0);
	    add(durationLabel, gridBagConstraints);
	    
	    durationComboBox.setName("durationComboBox");
	    gridBagConstraints = OrangGUICommon.getGridBagConstraints(1, 5, GridBagConstraints.WEST,1,5,0,0);
	    add(durationComboBox, gridBagConstraints);
	    
	
	    stepIntervalLabel.setName("stepIntervalLabel");
	    stepIntervalLabel.setText("Step  interval(minutes):");
	    gridBagConstraints = OrangGUICommon.getGridBagConstraints(0, 6, GridBagConstraints.WEST,1,5,0,0);
	    add(stepIntervalLabel, gridBagConstraints);
	
	    
	    stepComboBox.setName("stepComboBox");
	    gridBagConstraints = OrangGUICommon.getGridBagConstraints(1, 6, GridBagConstraints.WEST,1,5,0,0);
	    add(stepComboBox, gridBagConstraints);
	    
	
	    getRadioButtonQueues().setSelected(true);
	    return this;
	}
	
	
	protected void initialize() {
        
        
        
        // sets the start time to the current time. The name of the action is 
        // the one displayed
        getNowButton().setAction(new AbstractAction("Now") {
            private static final long serialVersionUID = 1L;

            public void actionPerformed(ActionEvent e) {
            	getStartTimeTextField().setText(dataWidgets.getStartISODate());
            }
        });

        // the completion happens when the pointer exits from the widget
        startTimeTextField.addFocusListener(new FocusListener() {

            public void focusGained(FocusEvent e) {
            }

            public void focusLost(FocusEvent e) {
                String currentISODate = startTimeTextField.getText();
                try {
                    String newDate = Convert
                            .completeISODateString(currentISODate);
                    startTimeTextField.setText(newDate);
                } catch (ParseException e1) {
                    // don't do anything.
                }

            }

        });
        
        

    }

  
	public void initData() {
		Utilities.addItems(getComboBoxTelescope(), dataWidgets.getTelescopes());
        Utilities.addItems(getComboBoxInstrument(), dataWidgets.getInstruments());
        Utilities.addItems(getStepComboBox(), dataWidgets.getStepRangeList());
        Utilities.addItems(getDurationComboBox(), dataWidgets.getDurationRangeList());
        
        //      retrieve the default data from the model.
        String[] queueList = dataWidgets.getQueues();
        getListBoxQueues().setListData(queueList);        
        getStartTimeTextField().setText(dataWidgets.getStartISODate());
	}
	

    /**
     * Validates the panel input data
     * 
     * @return
     */
    protected boolean isReady() {
    	valString = new String();
    	boolean result = true;
    	
    	DefaultButtonModel selectedButton = (DefaultButtonModel) obSelectionGroup.getSelection();
    	
    	if (! isISODate(startTimeTextField.getText() ) ) {
    		valString = "Start time invalid.";
    		result = false;
    	}
    	
    	if (selectedButton == null) {        	 
    		valString = valString + "\n Invalid queue selection.";
    		result = false;
    		
    	} else {
    		
    		if (radioButtonQueues.isSelected()&&
    				listBoxQueues.getSelectedIndex()< 0) {
    			valString = valString + "\n Please select at least one queue";
    			result = false;
    		}   else {        		         		 
    			if (radioButtonInstrument.isSelected()) {
    				String instrument = (String)comboBoxInstrument.getSelectedItem();
    				
    				if (instrument == null ) {
    					valString = valString + "\n Invalid instrument selection";
    				} else {
    					if (instrument.equals("")) {
    						valString = valString + "\n Invalid instrument selection";
    					}    					
    				}     				
    			} else {        		         		 
    				if (radioButtonTelescope.isSelected()) {
    					String instrument = (String)comboBoxTelescope.getSelectedItem();
    					
    					if (instrument == null ) {
    						valString = valString + "\n Invalid telescope selection";
    					} else {
    						if (instrument.equals("")) {
    							valString = valString + "\n Invalid telescope selection";
    						}
    						
    					}
    					
    				}
    				
    			}
    		}
    		
    	}
    	
    	String step = (String)stepComboBox.getSelectedItem(); 
    	
    	
    	if (step == null)
    		valString = valString + "\n Invalid step interval";
    	else
    		if ( step.equals(""))
    			valString = valString + "\n Invalid step interval";
    	
    	
    	String duration = (String)durationComboBox.getSelectedItem(); 
    	
    	
    	if (duration == null)
    		valString = valString + "\n Invalid duration";
    	else
    		if ( duration.equals(""))
    			valString = valString + "\n Invalid duration";
        
    	
        
        return result;
    }

	

	private boolean isISODate(String text) {
	    boolean result = true;
	    try {
	        Convert.ISOdateToLong(text);
	    } catch (ParseException e) {
	        result = false;
	    }
	    return result;
	}

	public static long getSerialVersionUID() {
		return serialVersionUID;
	}

	public JComboBox getComboBoxInstrument() {
		return comboBoxInstrument;
	}

	public JComboBox getComboBoxTelescope() {
		return comboBoxTelescope;
	}

	public OrangWidgetsData getDataWidgets() {
		return dataWidgets;
	}

	public JComboBox getDurationComboBox() {
		return durationComboBox;
	}


	public JList getListBoxQueues() {
		return listBoxQueues;
	}

	public JButton getNowButton() {
		return nowButton;
	}

	public JRadioButton getRadioButtonInstrument() {
		return radioButtonInstrument;
	}

	public JRadioButton getRadioButtonQueues() {
		return radioButtonQueues;
	}

	public JRadioButton getRadioButtonTelescope() {
		return radioButtonTelescope;
	}

	public JTextField getStartTimeTextField() {
		return startTimeTextField;
	}

	public JComboBox getStepComboBox() {
		return stepComboBox;
	}


	/**
	 * Assigns the current gui state to the model properties 
	 * 
	 * @param model
	 */
	public void updateModel(OrangModel model) {
		
		int selectionType = getSelectionType();
		model.setObSelectionType(selectionType);
		
		String telescope = (String) this.comboBoxTelescope.getSelectedItem();
		model.setSelectedTelescope(telescope);
		
		String instrument = (String) this.comboBoxInstrument.getSelectedItem();
		model.setSelectedInstrument(instrument);
				
		String [] queues = getSelectedQueues();
		model.setSelectedQueues(queues);
		
		Date startDate = getStartDate();
		model.setStartDate(startDate);
		
		Date endDate = getEndDate();
		model.setEndDate(endDate);
				
		int interval = getStepInterval();
		model.setStepInterval(interval);
		
	}
	
	public int getStepInterval() {
		String intervalStr = (String)stepComboBox.getSelectedItem();
		return(new Integer(intervalStr).intValue());
	}
	
	public Date getStartDate() {    	
        String isoDate = startTimeTextField.getText();
        Date startDate = OrangWidgetsData.convertGUIisoDate(isoDate);        
        return (startDate);
    }

	public Date getEndDate() {
        String duration = (String)durationComboBox.getSelectedItem();        
        String endDateStr = OrangWidgetsData.getISOEndDate(duration,getStartDate());
        Date endDate = OrangWidgetsData.convertGUIisoDate(endDateStr);
        return (endDate);
    }
	


	private int getSelectionType() {
		int selectionType;
		if ( radioButtonInstrument.isSelected() )
			selectionType = OrangModel.OB_SELECTION_INSTRUMENT;
		else
			if ( radioButtonTelescope.isSelected() )
				selectionType = OrangModel.OB_SELECTION_TELESCOPE;
			else
				if ( radioButtonQueues.isSelected() )
					selectionType = OrangModel.OB_SELECTION_QUEUES;
				else 
					selectionType = OrangModel.OB_SELECTION_WRONG;
		
		return(selectionType);
	}


	private String []  getSelectedQueues() {
		int numItems = listBoxQueues.getSelectedValues().length;    	
		String [] queues = new String[numItems];
    	int [] indices = listBoxQueues.getSelectedIndices();
    	for (int i = 0; i < numItems; i++) {
    		queues[i] = (String)listBoxQueues.getModel().getElementAt(indices[i]);
		}
    	
    	return(queues);
	}
	
	private void radioButtonTelescopeActionPerformed(ActionEvent evt) {
		this.comboBoxTelescope.requestFocus();
		
	}
	
	private void radioButtonInstrumentActionPerformed(ActionEvent evt) {
		this.comboBoxInstrument.requestFocus();
		
	}
	
	private void radioButtonQueuesActionPerformed(ActionEvent evt) {
		this.listBoxQueues.requestFocus();
		
	}


	public String getValidationString() {
		if ( valString != null ) 
			return valString;
		else
			return "";
			
	}
	

}
