package org.eso.ohs.phase2.apps.ot.wizard;

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JPanel;

import org.eso.ohs.core.gui.widgets.OHSWizard;
import org.eso.ohs.core.gui.widgets.OHSWizardPage;
import org.eso.ohs.phase2.orang.OrangModel;
import org.eso.ohs.phase2.orang.OrangWidgetsData;

/**
 * Class ObservingConditionFilterView
 * 
 * The wizard page for the observing condition
 * 
 * @version $Revision: 1.8 $
 * @author ddorigo, Nov 3, 2005
 */

// $Id: ObservingConditionFilterView.java,v 1.6 2005/11/03 09:15:04 ddorigo Exp
// $
public class OBWeatherPage extends OHSWizardPage {

    private static final String OB_WEATHER_TITLE = "Step 2: specify current observing conditions";

	private static final long serialVersionUID = 1L;

    private OrangWidgetsData defData;
    
    private OBWeatherPanel weatherPanel;
    
    private StatusPanel infoPanel;

    /**
     * Default constructor
     * 
     * @param defaultData
     */
    public OBWeatherPage(OHSWizard controller,
            OrangWidgetsData defaultData) {
        super(controller);
        defData = defaultData;
        initializePanel(defaultData);
    }


    
    /**
	 * Initializer
	 */
	protected void initializePanel(OrangWidgetsData defaultData) {
		
		weatherPanel = new OBWeatherPanel();
		

				
	    setLayout(new BorderLayout());	    
	    	           	
	    // title panel
    	add(OrangGUICommon.getWizardTitlePanel(OB_WEATHER_TITLE),BorderLayout.NORTH);    	    	
    	
    	// weather panel
    	JPanel dummyPanel = new JPanel();
    	dummyPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
    	
    	weatherPanel = new OBWeatherPanel();
    	dummyPanel.add(weatherPanel);
    	
    	add(dummyPanel,BorderLayout.CENTER);
    	
    	// info panel
		infoPanel = new StatusPanel();	      	    
    	add(infoPanel,BorderLayout.SOUTH);	    
	    
    	
    	// other initializations
	    
    	weatherPanel.initData(defaultData);
           listenTo(weatherPanel.getTextFieldSeeing());
           listenTo(weatherPanel.getTextFieldWind());
            listenTo(weatherPanel.getComboFieldSkyTransparency());
	
            listenTo(weatherPanel.getRadioButtonInactiveSeeing());
            listenTo(weatherPanel.getRadioButtonInactiveWind());
            listenTo(weatherPanel.getRadioButtonInactiveSky());
	
            listenTo(weatherPanel.getRadioButtonActiveSeeing());
            listenTo(weatherPanel.getRadioButtonActiveWind());
	    listenTo(weatherPanel.getRadioButtonActiveSky());
	
	    
	
        weatherPanel.getRadioButtonActiveSeeing().doClick();
        weatherPanel.getRadioButtonActiveWind().doClick();
            weatherPanel.getRadioButtonActiveSky().doClick();
	}



	public void updateModel(OrangModel model) {
		weatherPanel.updateModel(model);
	}



	public void setInfo(String loadedInfo) {
		infoPanel.setInfo(loadedInfo);
		
	}



	protected boolean isReady() {
		return(weatherPanel.isReady());
	}
		

}
