package org.eso.ohs.phase2.apps.ot.wizard;

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JPanel;

import org.eso.ohs.core.gui.widgets.OHSWizard;
import org.eso.ohs.core.gui.widgets.OHSWizardPage;
import org.eso.ohs.phase2.orang.OrangModel;
import org.eso.ohs.phase2.orang.OrangWidgetsData;

/**
 * This wizard page allows the user to compute and show a timeline
 * based on the current list of visible OBs
 * 
 * @version $Revision: 1.7 $
 * @author amchavan & pnunes, Oct 17, 2005
 */

// $Id: TimelinePage.java,v 1.7 2006/03/03 12:21:40 pnunes Exp $

public class TimelinePage extends OHSWizardPage {


    private static final String TIMELINE_ALGORITHM_TITLE = "Step 5: choose timeline algorithm";
	private OrangWidgetsData dataWidgets;
    private TimelinePanel timelinePanel;
    private StatusPanel statusPanel;

    /**
     * Default constructor
     * @param defaultData 
     */
    public TimelinePage( OHSWizard controller, OrangWidgetsData defaultData ) {
        super( controller );
        dataWidgets = defaultData;
        initializePage();
    }

    

   

    protected void initializePage() {
    	
    	BorderLayout layout  = new BorderLayout();
	    setLayout(layout);		    

	    // title panel
	    add(OrangGUICommon.getWizardTitlePanel(TIMELINE_ALGORITHM_TITLE),BorderLayout.NORTH);    	
    	    	
    	// weather panel
    	JPanel dummyPanel = new JPanel();
    	dummyPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
    	
    	timelinePanel = new TimelinePanel();
    	JPanel chooserP = timelinePanel.createPanel();
    	dummyPanel.add(chooserP);
    	
    	add(dummyPanel,BorderLayout.CENTER);
    	
    	
    	statusPanel = new StatusPanel();
    	add(statusPanel, BorderLayout.SOUTH);
    	

    	timelinePanel.initData();
        listenTo( timelinePanel.getCbTimelineAlgorithm() );
    }

    public void updateModel(OrangModel model) {
    	timelinePanel.updateModel(model);
	}
    

    protected boolean isReady() { 
        return true;
    }
    
    public void setInfo(String info) {
    	statusPanel.setInfo(info);
    }
}
