package org.eso.ohs.phase2.apps.p2pp;

import java.awt.Component;

import org.eso.ohs.dfs.CalibrationBlock;
import org.eso.ohs.dfs.ObservationBlock;
import org.eso.ohs.persistence.AppConfig;
import org.eso.ohs.persistence.Config;
import org.eso.ohs.phase2.icdVcs.IcdVcsCfg;

/**
 * Clearing house for low-level configuration information.
 * 
 * <p>
 * @author cmavros 2002/02/11, 1512/P2PP
 * $Id: MyIcdVcsCfg.java,v 1.4 2005/02/11 11:00:27 tcanavan Exp $
 */
public class MyIcdVcsCfg extends IcdVcsCfg {

    public Class getObjectClassToSend() {
	    FolderGridView folderView = getFolderGridView();

		    // What kind of object are we displaying?
	    Class objType = folderView.getDisplayedObjectClass();
	    if ( ! objType.equals(CalibrationBlock.class) ) {
		objType = ObservationBlock.class;
		folderView.setDisplayedObjectClass(objType);
	    }

		    // XXX HACK: deselect all except the first OB
	    Long[] selection = folderView.getAllSelected();
	    for (int j=1; j < selection.length; j++) {
		folderView.deselectObject(objType, selection[j].longValue());
	    }
		    // XXX HACK: END

	    return objType;
    }

    public boolean hasValidSelection() {
	FolderGridView folderView = getFolderGridView();
	Class objType = getObjectClassToSend();

	return folderView != null &&
		folderView.getSelected() != null;
    }

    public long getSelection(Class objType) {
	FolderGridView folderView = getFolderGridView();
	Long idLong = folderView.getSelected();

	return idLong == null ? 0 : idLong.longValue();
    }


    public long[] getSelections(int maxNumOBs) {
	return new long[] { getSelection(getObjectClassToSend()) };
    }


    /**
     * Type of object that is currently displayed.
     * 
     * @return	Type of object to send to BOB
     */
    public Class getObjType(long id) {
	return getObjectClassToSend();
    }

    private FolderGridView getFolderGridView() {
	MainWindow mainWin = MainWindow.getPrincipalWindow();

	return mainWin != null
		    ? mainWin.getFolderView()
		    : null;
    }

    public Component getContainer() {
	return getFolderGridView();
    }


    public String getCCSServer() {
	return AppConfig.getAppConfig().getCCSServer();
    }

    public boolean isInVisitorMode() {
	return Config.getCfg().isInVisitorMode();
    }

    public boolean isInEngineeringMode() {
	return Config.getCfg().isInEngineeringMode();
    }

    public boolean isInCloneMode() {
	return Config.getCfg().isInCloneMode();
    }

}


