package org.eso.ohs.phase2.apps.p2pp.actions;

import java.awt.event.ActionEvent;

import javax.swing.JComponent;
import javax.swing.JFrame;

import org.eso.ohs.core.utilities.ObjUtils;
import org.eso.ohs.persistence.ObjectContainer;
import org.eso.ohs.phase2.actions.ExpTimeReportAction;


/**
 * Action class to display the detailed contents of a BusinessObject.
 *
 * <p>
 * $Id: P2PPExpTimeReportAction.java,v 1.7 2006/03/21 14:56:15 tcanavan Exp $
 * <br>
 * @author Bob Kemp
 * 
 * <br>ChangeLog: cmavros 11/Sept/01 Moved ConvertToHoursMinsSecs(int) to utilities class
 * 
 */

public class P2PPExpTimeReportAction extends ExpTimeReportAction {

    /**
     * Constructs a ShowDetailsAction action.
     */



    public P2PPExpTimeReportAction(ObjectContainer folderView,JComponent component,boolean folder,String name) {
	super(folderView,component,folder,name);     	
    }
    
    public P2PPExpTimeReportAction(ObjectContainer folderView,boolean folder,String name) {
    	super(folderView,folder,name);     	
    }

    /**
     * Event handler for the ShowDetailsAction action.
     * 
     * @param ev       user-initiated ActionEvent to quit.
     */
    public void actionPerformedImpl(ActionEvent evt) {
        Long [] idLongs = null;
	if ( !folder_ ) {
	    idLongs = folderView_.getAllSelected();
	}
	else {
	    idLongs = folderView_.getAll();
	}
	idLongs = (Long[])ObjUtils.uniqueOccurrences(idLongs);     
        new P2PPIncrementalActionAutomaton(
			new IncrementalReport(
			    idLongs
			),
			(JFrame)folderView_.getTopLevelAncestor(),
			"Reports..."
       );        
    }
}


