package org.eso.ohs.phase2.apps.p2pp.views;

import javax.swing.DefaultListModel;

import org.eso.ohs.instruments.TemplateSignatureSummary;


/**
 * Data model for the list of templates
 * <p>
 * $Id: TemplateListModel.java,v 1.4 2006/04/27 13:25:00 pnunes Exp $
 * @author Tim Canavan
 */


public class TemplateListModel extends DefaultListModel {
  

  /**
   * Return a reference to the template name in the list
   * @param index index
   */

    public Object getElementAt(int index) {
        TemplateSignatureSummary summ = (TemplateSignatureSummary)super.getElementAt(index);  
        return summ.getTemplateName();      
    }

    /**
     * Return the template description for a given element in the 
     * list at a particular index
     * @param index index
     */

    public String getToolTipText(int index) {
        TemplateSignatureSummary summ = (TemplateSignatureSummary)super.getElementAt(index);  
        return summ.getTemplateDesc();      
    }
}



