#******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: dominoProc.tcl,v 1.2 2005/05/24 12:59:39 cguirao Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# fsogni  26/01/98  created
#
#************************************************************************
#   NAME dataSubscriber Release 1.0
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

#Initialize variables and flags.
proc dominoInitX {} {
    global gvar env cv sybmsg popflag

    #Check the existance of system variables
    if {![info exists env(DHS_LOG)]} { htInfo "DHS_LOG variable not set"
		exit }
    if {![info exists env(DHS_HOST)]} { htInfo "DHS_HOST variable not set"
		exit }
    if {![info exists env(BAD_DIR)]} { htInfo "BAD_DIR variable not set"
		exit }
    if {![info exists env(HOME)]}    { htInfo "HOME variable not set"
		exit }
    if {![info exists env(VLTROOT)]} { htInfo "VLTROOT variable not set"
		exit }
    if {![info exists env(INS_ROOT)]} { htInfo "INS_ROOT variable not set"
		exit }
    if {![info exists env(DFS_GUI_CONFIG)]} \
		{ htInfo "DFS_GUI_CONFIG variable not set"; exit }
    if {![info exists env(DSQUERY)]} { htInfo "DSQUERY variable not set"
		exit }
    if {![info exists env(OlasWS)]} { htInfo "OlasWS variable not set"
		exit }
    if {![info exists env(QcWS)]} { htInfo "QcWS variable not set"
		exit }
    
    
    if {![file isdir $env(DHS_LOG)]} {htInfo "$env(DHS_LOG) doesn't exist.\nDHS_LOG not set properly"; exit }
    #From now on DHS_DATA is managed by dhsSubscribeControl.
    #   if {![file isdir $env(DHS_DATA)]} {htInfo "$env(DHS_DATA) doesn't exists.\nDHS_DATA not set properly"; exit }
    if {![file isdir $env(BAD_DIR)]} {htInfo "$env(BAD_DIR) doesn't exist.\nBAD_DIR not set properly"; exit }
    if {![file isdir $env(HOME)]} {htInfo "$env(HOME) doesn't exist.\nHOME not set properly"; exit }
    if {![file isdir $env(VLTROOT)]} {htInfo "$env(VLTROOT) doesn't exist.\nVLTROOT not set properly"; exit }
    if {![file isdir $env(INS_ROOT)]} {htInfo "$env(INS_ROOT) doesn't exist.\nINS_ROOT not set properly"; exit }
    if {![file isdir $env(DFS_GUI_CONFIG)]} {htInfo "$env(DFS_GUI_CONFIG) doesn't exist.\nDFS_GUI_CONFIG not set properly"; exit }
    if {[catch {package require Sybtcl}]} {htInfo "I cannot load Sybtcl.\nPlease check the library path or call the operator."; exit }
    if {[catch {package require SeqOslx}]} {htInfo "Error loading SeqOslx package.\nPlease check the library path or call the operator." ; exit }  
    
    set gvar(revision) {$Id: dominoProc.tcl,v 1.2 2005/05/24 12:59:39 cguirao Exp $}
    set gvar(revisionName) {$Name: gui-1_6_5 $}
    
    # Set some important flags and variables
    set gvar(initFlag)               1
    set gvar(modifyFlag)             0
    set gvar(fileSaved)              0
    set gvar(clearFlag)              1
    set gvar(useSeqOslxCmd)          1
    set gvar(useCCS)                 0
    set gvar(logErrorsOnStderr)      0
    set gvar(filesArrivedRAW)        0
    set gvar(filesQueuedRAW)         0
    set gvar(expected-RAW)           0
    set gvar(filesArrivedRED)        0
    set gvar(filesQueuedRED)         0
    set gvar(expected-RED)           0
    set gvar(dominoHtFlag)           0
    set gvar(cancelLoop-RAW)         0
    set gvar(cancelLoop-RED)         0
    set gvar(cancelDeathLoop-RAW)    0
    set gvar(cancelDeathLoop-RED)    0
    set gvar(cancelLifeLoop-RAW)     0
    set gvar(cancelLifeLoop-RED)     0
    set gvar(loopLifeTime)           10000
    set gvar(loopLifeTime-RAW)       $gvar(loopLifeTime)
    set gvar(loopLifeTime-RED)       $gvar(loopLifeTime)
    set gvar(autoMakeCD)             0
    set gvar(alreadyRunning-RAW)     0
    set gvar(alreadyRunning-RED)     0
    set gvar(fhtProcNum)             0
    set gvar(missingInfo)            0
    #set gvar(ID)                     "DOMINO"
    set gvar(tmpFileType)            ""
    set gvar(db_server)              $env(DSQUERY)
    set gvar(database)               asto
    set gvar(mainCV)                 .dataSubscriber.top.wdg.can
    set gvar(prefsCV)                .dominoPrefs.top.wdg.can
    set gvar(htCV)                   .ht.top.wdg.can
    set gvar(lookupCV)               .dsLookup.top.wdg.can
    
    # Capture the window manager delete window action and override the
    # window manager's default action.
    set _top_level [winfo toplevel $gvar(mainCV)]
    wm protocol $_top_level WM_DELETE_WINDOW "bell"
    wm title $_top_level  $gvar(revision)
    
    
    #Trap signals
    signal trap {INT QUIT TERM} {htInfo "Please use Quit\Cancel to exit from the application."}
    signal trap {CONT} "wm deiconify ."

    
    if {[catch {set sybaseLogin [exec dbrcGet $gvar(db_server) $gvar(database)]} var]} {htInfo "I cannot get the database password.\nCall the operator."
		exit }
    set gvar(sybaseUsername) [lindex $sybaseLogin 0]
    set gvar(sybasePassword) [lindex $sybaseLogin 1]

    if {[info exists gvar(debugMode)]} {
		close stderr
    }
    
    #SOG. Uncomment this when tests are over !!!
    if {[file exists $env(DFS_GUI_CONFIG)/ambientTable.ht]} {
	set gvar(ambientTable)    $env(DFS_GUI_CONFIG)/ambientTable.ht 
    }
    
    #read config file
    dominoDefaults
    
    #Check connection with the database.
    if {[catch {set sybHandle [sybconnect $gvar(sybaseUsername) $gvar(sybasePassword) $gvar(db_server)]} handle]} {
		htDebug "I Cannot connect to server, reason: $sybmsg(dberrstr)" 1
		htInfo "I cannot connect to database.\nPlease check"
    } else { sybclose $sybHandle } 
    
    # Set the icon to be used    
    set myTop [winfo toplevel $gvar(mainCV)]
    wm iconbitmap $myTop "@[findVLTFile bitmaps/get-file1.xbm]"
    
    #Bindings
    bind $gvar(mainCV).dominoNttWdgRAW.frame.uifBitmap  <Button-1>  {setNormal RAW}
    bind $gvar(mainCV).dominoNttWdgRED.frame.uifBitmap  <Button-1>  {setNormal RED}

    
    #Load the dictionaries
    #set gvar(dic) $env(INS_ROOT)/ALL
    #dominoSetDictionary $gvar(dic)
    if {[file exists $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(ID-RED).pid]} { 
		htDebug "RED dhsSubscribe is already running" 2
		set type RED
		dominoGetInfo $type
		set gvar(alreadyRunning-$type) 1
		set gvar(goFlag-$type) 0
		set gvar(countPid-$type) 0
		set gvar(lifeCount-$type) 0
		dominoLoop 1000 "checkPid $type" $type
    } else {
		htDebug "$env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(ID-RED).pid doesn't exist, RED not running" 2
		stopState RED
		$gvar(mainCV).dominoStartWdgRED disable
    }
    
    if {[file exists $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(ID-RAW).pid]} { 
		htDebug "RAW dhsSubscribe is already running" 2
		set type RAW
		dominoGetInfo $type
		set gvar(alreadyRunning-$type) 1
		set gvar(goFlag-$type) 0
		set gvar(countPid-$type) 0
		set gvar(lifeCount-$type) 0
		if {$gvar(alreadyRunning-RAW) == 1 && $gvar(alreadyRunning-RED)==0 } {$gvar(mainCV).dominoStartWdgRED enable}
		dominoLoop 1000 "checkPid $type" $type
    } else {
		htDebug "$env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(ID-RAW).pid doesn't exist, RAW not running" 2
		stopState RAW
		$gvar(mainCV).dominoStartWdgRAW disable
    }

    #Let's see if there is a log file...
    selectLog RAW
    selectLog RED
    
    wm withdraw .
    dominoImportPanel subInfo 
}

proc dominoGetInfo {type} {
    global gvar env 
	
    if {[file exists $env(DHS_LOG)/DhsSubscribeInfo-$gvar(ID-$type)]} {
		ScanConfigFile  $env(DHS_LOG)/DhsSubscribeInfo-$gvar(ID-$type) gvar
    } else {
		htInfo "I cannot open  $env(DHS_LOG)/DhsSubscribeInfo-$gvar(ID-$type)"
		set gvar(missingInfo) 1
		return }
    
    if {$gvar(dominoTo) != ""} {
		set gvar(fromToLabel$type) "$gvar(dominoFrom) to $gvar(dominoTo)"
    } else {set gvar(fromToLabel$type) "From $gvar(dominoFrom)"}
    
    $gvar(mainCV).dataSubscriberBarchartWdg$type configure -label "$type files from $env(DHS_HOST)"
    
    htDebug "dominoFrom: $gvar(dominoFrom)" 1  
    htDebug "dominoTo: $gvar(dominoTo)"      1
    htDebug "dominoRename: $gvar(dominoRename)" 1   
    htDebug "dominoRenameTo: $gvar(dominoRenameTo)" 1  
    htDebug "dominoBrowseKeyword: $gvar(dominoBrowseKeyword)" 1
    htDebug "dominoTrans: $gvar(dominoTrans)" 1
    htDebug "optTable: $gvar(optTable)" 1
    htDebug "postCommand: $gvar(postCommand)" 1
    htDebug "postCommandLine: $gvar(postCommandLine)" 1
    
    foreach type { RAW RED} {
		set gvar(dominoFrom-$type)     $gvar(dominoFrom)  
		set gvar(dominoTo-$type)       $gvar(dominoTo)
		set gvar(dominoRename-$type)   $gvar(dominoRename)   
		set gvar(dominoRenameTo-$type) $gvar(dominoRenameTo)
		set gvar(dominoBrowseKeyword-$type) $gvar(dominoBrowseKeyword)
		set gvar(dominoTrans-$type)     $gvar(dominoTrans)
		set gvar(optTable-$type)        $gvar(optTable) 
		set gvar(postCommand-$type)     $gvar(postCommand)
		set gvar(postCommandLine-$type) $gvar(postCommandLine)
		set gvar(expected-$type)        $gvar(expected)
    }
    
    if {[catch {set file [open $env(DHS_LOG)/.expected-$gvar(ID-$type).tmp w]}]} { return 
    } else { puts $file $gvar(expected-$type); close $file}
}

proc writeSchemaInfo {type} {
    global gvar env

    if {[catch {set infofile [open $env(DHS_LOG)/DhsSubscribeInfo-$gvar(ID-$type) w]}]} { htInfo "I cannot open Info file." ; return 1}

    puts $infofile "dominoFrom: $gvar(dominoFrom)"      
    puts $infofile "dominoTo: $gvar(dominoTo)"      
    puts $infofile "dominoRename: $gvar(dominoRename)"    
    puts $infofile "dominoRenameTo: $gvar(dominoRenameTo)"  
    puts $infofile "dominoBrowseKeyword: $gvar(dominoBrowseKeyword)" 
    puts $infofile "dominoTrans: $gvar(dominoTrans)"
    puts $infofile "optTable: $gvar(optTable)"
    puts $infofile "postCommand: $gvar(postCommand)"
    puts $infofile "postCommandLine: $gvar(postCommandLine)"
    if {[info exists gvar(expected-$type)]} {
		puts $infofile "expected: $gvar(expected-$type)"
    } else {puts $infofile "expected: "}
    
    close $infofile
    return 0
}


#Reset the counter.
proc htReset {type} {
    global gvar env
    
    #For the moment I don't clean subdirectories.
    #catch {file delete [glob $env(BAD_DIR)/*]}
    #catch {file delete [glob $env(DHS_LOG)/backlog/*]}
    
    #Reset the file counter
    set count [open $env(DHS_LOG)/.counter-$gvar(ID-$type).tmp w]
    puts $count "0"
    close $count
    exec chmod 660 $env(DHS_LOG)/.counter-$gvar(ID-$type).tmp
}

#Start procedure, executed after configuring all the parameters.
proc Start {type} {
    global gvar env 
    
    set env(DHS_HOST)   $gvar(DHS_HOST-$type)
    set env(DHS_CONFIG) $gvar(DHS_CONFIG-$type)
    #set env(DHS_DATA)   $gvar(DHS_DATA-$type)
    
    if {[file exists $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(ID-$type).pid]} {
		htInfo "There is another dhs process running.\n Wait few seconds, until it dies..."
		return }
    
    $gvar(mainCV).dominoConfigWdg disable
    panDisableMenuEntry File "New Program ID"
    
    if {$type == "RED" && $gvar(alreadyRunning-RAW) == 0} {
		htInfo "WARNING!\nRAW data delivery is not running.\nYou are receiving only Reduced data."
    }
    
    
    #Reset counter of the arrived files
    htReset $type
	set gvar(lifeCount-$type) 0
    set gvar(filesArrived$type) 0
    if {$gvar(serviceFlag) == 0} { set serviceMode "-where \"OBS.PROG.ID='$gvar(programID)'|DPR.CATG='CALIB'\""
    } else { set serviceMode "" }
    
    
    #If the flag postCommandLog is enabled, introduce comments
    #in the post command.
    
    if {[info exists gvar(postCommandLog)]} { 
		set comment1 "echo \"input file = \$1\" >> \$DHS_LOG/report-$type.\$date\n"
		set comment2 "echo \"output file = \$fname\" -- num = \$num >> \$DHS_LOG/report-$type.\$date\n"
		set comment3 "echo \"output file = \$fname\" >> \$DHS_LOG/report-$type.\$date\n"
		set comment4 "echo \"fitsTranslate exit code = \$stat\" >> \$DHS_LOG/report-$type.\$date\n"
		set comment5 "echo \"FTU ERROR! Check $env(DHS_LOG)/fitsTranslatelog.\$date\" >> \$DHS_LOG/report-$type.\$date\n"
		set comment6 "echo \"FTU went fine.\" >> \$DHS_LOG/report-$type.\$date\n"
		set comment7 "echo \"fitsTranslate returned null as output file\" >> \$DHS_LOG/report-$type.\$date\n"
    } else {
		set comment1 "\n"
		set comment2 "\n"
		set comment3 "\n"
		set comment4 "\n"
		set comment5 "\n"
		set comment6 "\n"
		set comment7 "echo \"Null\" >> /dev/null\n" 
    } 
    
    
    
	#############################################################################
	#######Create the command that executes dhsSubscribe - FITS files only !!!!##
	#############################################################################

    set Command "$gvar(StartScript-$type) -id $gvar(ID-$type) -filetype FITS $serviceMode"
    append Command " -run \"$env(DHS_LOG)/dominoPostcmd-$gvar(ID-$type).sh\ %s \""
    #We rename RAW files only, Reduced files maintain DFS names.
    if {$type == "RAW"} {
		append Command " -lookuptab $gvar(programID)-lookuptable.txt"
		if {$gvar(dominoRename-$type) == 1} {append Command " -rename 1 -renamestring \"$gvar(dominoRenameTo-$type)\""
		} elseif {$gvar(dominoRename-$type) == 2} { append Command " -rename 2 -renamestring \"$gvar(dominoBrowseKeyword-$type)\""}
    } else { append Command " -rename 0" }
    
    #Here I create  the dhs-command line 
    
    if {$gvar(dominoFrom-$type) != ""} {append Command " -backsince $gvar(dominoFrom-$type)"
		set gvar(fromToLabel$type) "From $gvar(dominoFrom-$type)"
		$gvar(mainCV).dataSubscriberBarchartWdg$type config -barColor grey
		set gvar(perc$type) 100
		
		if {[writeSchemaInfo $type]} { return }
    }


    #Is the date open ? (To: is empty) 
    if {$gvar(dominoTo-$type) != ""} {append Command " -backto $gvar(dominoTo-$type)"
		set gvar(fromToLabel$type) "$gvar(dominoFrom-$type) to $gvar(dominoTo-$type)"
		$gvar(mainCV).dataSubscriberBarchartWdg$type config -barColor blue
		set gvar(perc$type) 0
		
    }

############################################################################



############################################################################
########################Build here the post command#########################
############################################################################
    
    #I create and execute a postcommand anyway, this is
    #the only way I have to count the files arrived/processed
    set postScript "\#!/bin/sh\n\n \
    date=`gawk 'BEGIN { t=systime(); t=t-12*60*60; print strftime(\"%Y-%m-%d\",t) }'`\n \
    $comment1\n"

    set secondLine "\nfname=\$1\n $comment2\nchmod u+w \$1\n"
	


############################################################################
###############Build here the fitsTranslate command#########################
############################################################################

    
    #Use fitsTranslate only if a rename schema or a translation 
    #table was selected.
    
    if {$gvar(dominoTrans-$type) != 0} {
	if {[info exists gvar(ambientTable)]} {
	    #Two lines to decide to merge the ambient and user made tables.
	    exec cat $gvar(ambientTable) > $env(DHS_LOG)/fitsTranslateTable-$type.ht
	    exec  cat $gvar(optTable-$type) >> $env(DHS_LOG)/fitsTranslateTable-$type.ht 
	} else {
	    exec  cat $gvar(optTable-$type) > $env(DHS_LOG)/fitsTranslateTable-$type.ht 
    }
	
	
#########################################################################
#Build a postCommand that translate the header 
#In this version we execute always corrfits, in order to
#include the ambient data, in every file 
#########################################################################
	set corrCom "fitsTranslate -force -noStat -tolerant -overwrite -logLevel 2 -logFile $env(DHS_LOG)/fitsTranslatelog.\$date"
	append corrCom " -ftt $env(DHS_LOG)/fitsTranslateTable-$type.ht"
	append corrCom " -targetDir \$d/  \$1 2>/tmp/ftuLog.\$date"

#############################################################################    
append secondLine "d=`dirname \$1`\n \
rrcfits=`echo \$fname |grep -c \"\\.fits\"`\n \
if \[ \$rrcfits = 1 \] \n \
then\n \
   $corrCom\n
   stat=\$?\n \
   $comment4 \
   if \[ !  \$stat -eq 0 \] ; then \n  \
      $comment5
      cat /tmp/ftuLog.\$date >&2 \n  \
      rm -f /tmp/ftuLog.\$date \n \
      exit 1 \n \
   else\n  \
       $comment6
       rm -f /tmp/ftuLog.\$date \n  \
   fi\n
fi\n
"


#    append secondLine "\
d=`dirname \$1`\n \
file=`basename \$1`\n \
if \[ ! -d \$d/translated \] ;  then\n \
mkdir -p \$d/translated\n \
fi\n \
$corrCom\n \
stat=\$?\n \
$comment4 \
if \[ \$stat -eq 0 \] ; then \n  \
$comment5 \
mv -f \$d/translated/\$fname \$d\n  \
  else\n  \
    $comment6 \
      rm -f \$d/translated/\$fname\n  \
fi\n \
$comment7"
}

    #Add a user-defined command to the postCommand
    if {$gvar(postCommand)} {
	regsub -all "%s" $gvar(postCommandLine-$type) "\$d/\$fname" userCmd 
	append secondLine "\necho \"executing $userCmd\" >> \$DHS_LOG/report-$type.\$date\n \
$userCmd\n"
    }


    #Pack everything and save to the postcommand file.
    
    append postScript $secondLine
    append postScript "num=`cat \$DHS_LOG/.counter-$gvar(ID-$type).tmp`\n \
num=`expr \$num + 1`\n \ 
echo \$num > \$DHS_LOG/.counter-$gvar(ID-$type).tmp\n"
    htDebug "------------Start Post Command-------------------" 1
    htDebug "Post Command = $postScript" 1
    htDebug "------------End of Post Command------------------" 1
    set script [open $env(DHS_LOG)/dominoPostcmd-$gvar(ID-$type).sh w]
    puts $script $postScript
    close $script
    exec chmod 750 $env(DHS_LOG)/dominoPostcmd-$gvar(ID-$type).sh
    
        
    #Insert the progID and the rename scheme in the database, but only
    #once (for the RAW data).
    set tblindex [lsearch -exact $gvar(tableItemValue) $gvar(optTable)]
    if {$gvar(dominoTrans) == 0 || $tblindex == -1} {set template_tab "Ambient"
    } else { set template_tab [lindex $gvar(tableItemList) $tblindex] }
    
    if {$gvar(dominoRename) == 1} {set rename_string $gvar(dominoRenameTo)
    } elseif {$gvar(dominoRename) == 2} {set rename_string $gvar(dominoBrowseKeyword)} else { set rename_string ""}

    if {$gvar(dominoTo) == ""} {set to_night $gvar(currentDate)
    } else { set to_night $gvar(dominoTo) }
    
    if {$gvar(programID) != "service" } {
		#Create a list with the fields to insert in the database, the update.
		lappend gvar(dbTable) "\"$gvar(programID)\" $gvar(dominoFrom) $to_night \"$template_tab\" $gvar(dominoRename) \"$rename_string\" \"$gvar(obsName)\""
		
		
		if {![catch {set file [open $env(DHS_LOG)/$gvar(programID)-renameschema.txt w]}]} {
			set formatLine "%-15s %-10s %-10s %-15s %-1s %-23s %-20s"
			puts $file "[eval format [concat \"$formatLine\" ProgramID \"From Date\" \"To Date\"  \"Trans. Table\" F \"Rename string\" \"Obs Name\"]]"
			foreach entry $gvar(dbTable) {
				puts $file "[eval format [concat \"$formatLine\" $entry]]"
			}
			close $file
		}
		updateDB $type
    }
    
    Busy $gvar(mainCV) {
		htDebug  "Execute: $Command" 1
		eval exec $Command &
		
		$gvar(mainCV).dataSubscriberBarchartWdg$type configure -label "dhsSubscribe is starting."
		$gvar(mainCV).dominoStartWdg$type disable
		
		#I used these commands to wait dhsSubscribe to come up.
		set gvar(goFlag-$type) 0
		set gvar(countPid-$type) 0
		dominoLoop 1000 "checkPid $type" $type
		vwait gvar(goFlag-$type)
    }
}

proc updateDB {type} {
    global gvar sybmsg

    if {$type == "RAW"} {
		if {[catch {set sybHandle [sybconnect $gvar(sybaseUsername) $gvar(sybasePassword) $gvar(db_server)]} handle]} {
			htDebug "Cannot connect to server for update, reason: $sybmsg(dberrstr) Retry in 1 minute ..." 1
			after 60000 updateDB $type
			return
		} else { sybclose $sybHandle }
		
		foreach dbEntry $gvar(dbTable) {
			set programID     [lindex $dbEntry 0]
			set from_night    [lindex $dbEntry 1]
			set to_night      [lindex $dbEntry 2]
			set template_tab  [lindex $dbEntry 3]
			set rename_schema [lindex $dbEntry 4]
			set rename_string [lindex $dbEntry 5]
			set info          [lindex $dbEntry 6]
			
			htDebug "The Renaming schema is: $gvar(dbTable)" 3
			htDebug "I insert in the database:" 3
			htDebug " programID     [lindex $dbEntry 0]" 3
			htDebug " from_night    [lindex $dbEntry 1]" 3
			htDebug " to_night      [lindex $dbEntry 2]" 3
			htDebug " template_tab  [lindex $dbEntry 3]" 3
			htDebug " rename_schema [lindex $dbEntry 4]" 3
			htDebug " rename_string [lindex $dbEntry 5]" 3
			htDebug " info          [lindex $dbEntry 6]" 3


			
			if {[Sybsql "select * from pi_subscribers
            where prog_id = '$programID' and from_night ='$from_night' and to_night = '$to_night'"] == "REG_ROW"} { 
				
				if {[Sybsql "update pi_subscribers
                set template_tab = '$template_tab',
                rename_schema = $rename_schema,
                rename_string = '$rename_string',
                info = '$info'
                where prog_id = '$programID' and from_night ='$from_night' and to_night = '$to_night'
                "] == "error" } {
					htDebug "I cannot update the database table.\nTry again in 1 min. ..." 1
					after 60000 updateDB $type
					return }
				htDebug "update pi_subscribers
                set template_tab = '$template_tab',
                rename_schema = $rename_schema,
                rename_string = '$rename_string',
                info = '$info'
                where prog_id = '$programID' and from_night ='$from_night' and to_night = '$to_night'" 1
			} else {
				if {[Sybsql " 
                insert into 
                pi_subscribers (prog_id, from_night, to_night, template_tab, rename_schema, rename_string, info)
                values ('$programID', '$from_night','$to_night', '$template_tab', $rename_schema, '$rename_string', '$info')"] == "error" } {
					htDebug "I cannot insert in the database table.\nTry again in 1 min. ..." 1
					after 60000 updateDB $type
					return }	
				htDebug "insert into 
                pi_subscribers (prog_id, from_night, to_night, template_tab, rename_schema, rename_string, info)
                values ('$programID', '$from_night','$to_night', '$template_tab', $rename_schema, '$rename_string', '$info')" 1
			}
		}
    }
    htDebug "Database updated succesfully !" 3
    set gvar(dbTable) ""
}



#Wait for the DhsSubscribe to be created.
proc checkPid {type} {
    global gvar env 


    htDebug "Waiting for $type to come up" 3
    htDebug "countPid $gvar(countPid-$type)" 3
    if {$gvar(countPid-$type) == 30} {
		
		set gvar(cancelLoop-$type) 1
		stopState $type
		set gvar(goFlag-$type) 1
		htInfo "dhsSubscribe $type doesn't come up"
		$gvar(mainCV).dataSubscriberBarchartWdg$type configure -label "Start dhsSubscribe failed"
		$gvar(mainCV).dominoConfigWdg enable
		panEnableMenuEntry File "New Program ID"
    } else {
		if {[file exists $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(ID-$type).pid]} {
			htDebug "Pid file exists" 3
			if {[catch {exec ps -p  [exec cat $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(ID-$type).pid]} result]} { 
                htDebug "We will try to delete the .pid file" 3
				catch {file delete $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(ID-$type).pid}
				set gvar(cancelLoop-$type) 1
				stopState $type
                htDebug "we are in the bad loop" 3
				set gvar(goFlag-$type) 1
				htInfo "dhsSubscribe $type doesn't come up.\nPid created, but not valid."
				$gvar(mainCV).dataSubscriberBarchartWdg$type configure -label "Start dhsSubscribe failed"
				$gvar(mainCV).dominoConfigWdg enable
				panEnableMenuEntry File "New Program ID"
				return 1
			}
			set gvar(cancelLoop-$type) 1
			startState $type
			set gvar(alreadyRunning-$type) 1
			set gvar(goFlag-$type) 1
			after 5000 "dominoLoop 1000 \"checkArrivals $type\" $type" 
			after 5000 "dominoLifeLoop  \"checkLifeLoop $type\" $type"
		} else { incr gvar(countPid-$type) +1 }
    }
}

#Loop to check if the processes are running.
proc checkLifeLoop {type} {
	global gvar env

	case $gvar(lifeState-$type) {
		"alive"     {checkLife $type}
		"dhsDied"   {after 3000 checkWatchdog $type}
		"reviving"  {checkRevive $type}
		"dead"      { return }
		*           {puts "Error condition in lifeloop: $gvar(lifeState-$type)"}
	} 
}

#Check if the dhsSubscribe process is alive.
proc checkLife {type} {
	global gvar env
	
	if {[catch {exec ps -p  [exec cat $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(ID-$type).pid]} result]} { 
		#dhsSubscribe died
		htDebug "dhsSubscribe $type died" 1
		$gvar(mainCV).dominoNttWdg$type.frame.uifBitmap configure -background red
		$gvar(mainCV).dataSubscriberBarchartWdg$type configure -label "Process died.Wait..."
		set gvar(lifeState-$type) "dhsDied"
		set gvar(loopLifeTime-$type) 3000
	} 		
}

#Check if the watchdog process is alive.
proc checkWatchdog {type} {
	global gvar env


	if {$gvar(lifeState-$type) == "dead" } { return }
	
	if {[catch {exec ps -p  [exec cat $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(ID-$type)-watchdog.pid]} result] } { 
		#also watchdog died. Stop everything and remove .pid files.
		htDebug "watchdog $type died: $result" 1
		$gvar(mainCV).dominoNttWdg$type.frame.uifBitmap configure -background red
		$gvar(mainCV).dataSubscriberBarchartWdg$type configure -label "Processes died !"
		Stop $type
		set gvar(lifeCount-$type) 0
		catch {file delete $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(ID-$type).pid}
		catch {file delete $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(ID-$type)-watchdog.pid}
		catch {file delete $env(DHS_LOG)/DhsSubscribeInfo-$gvar(ID-$type)}
	} else { 
		set gvar(lifeState-$type) "reviving"
	}
}

#Wait for the new dhsSubscribe to come up.
proc checkRevive {type} {
	global gvar env
	
	if { $gvar(lifeCount-$type) == 100 } { 
		#Processes don't come up.
		htDebug "Processes don't come up." 1
		Stop $type
		set gvar(lifeCount-$type) 0
		$gvar(mainCV).dominoNttWdg$type.frame.uifBitmap configure -background red
		$gvar(mainCV).dataSubscriberBarchartWdg$type configure -label "Processes died !"	
	} elseif {[catch {exec ps -p  [exec cat $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(ID-$type).pid]} result]} {
		incr gvar(lifeCount-$type) 
		htDebug "Waiting for new dhsSubscribe to revive: $result" 3
		htDebug "lifeCount = $gvar(lifeCount-$type)" 3
	} else {
		htDebug "dhsSubscribe $type revived !" 1
		#dhsSubscribe is revived
		$gvar(mainCV).dominoNttWdg$type.frame.uifBitmap configure -background green
		$gvar(mainCV).dataSubscriberBarchartWdg$type configure -label "$type files from $env(DHS_HOST)"
		set gvar(loopLifeTime-$type) $gvar(loopLifeTime)
		set gvar(lifeState-$type) "alive"
		set gvar(lifeCount-$type) 0
	}
}


proc checkDeath {type} {
    global gvar env 

    htDebug "Waiting for $type to die" 3
    htDebug "countPid $gvar(countPid-$type)" 3
    if {$gvar(countPid-$type) == 30} {
		startState $type
		
		set gvar(cancelDeathLoop-$type) 1
		set gvar(countPid-$type)   0
		set gvar(goFlag-$type)     1
		
		#$gvar(mainCV).dataSubscriberBarchartWdg$type configure -label "Stop dhsSubscribe failed"
		$gvar(mainCV).dominoConfigWdg disable
		$gvar(mainCV).dominoStopWdg$type enable
		panDisableMenuEntry File "New Program ID"
		htInfo "Stop of dhsSubscribe $type failed."
		after 1000 "dominoLoop 10000 \"checkArrivals $type\" $type"
    } else {
		htDebug "Pid file exists" 3
		if {[catch {exec ps -p  [exec cat $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(ID-$type).pid]} result]} { 
			
			file delete $env(DHS_LOG)/DhsSubscribeInfo-$gvar(ID-$type)
			set gvar(cancelDeathLoop-$type) 1
			set gvar(goFlag-$type)     1
			stopState $type
			htDebug "dataSubscriber $type stopped" 3
			
		} else { 
			incr gvar(countPid-$type) +1 
		}
    }
}



#Procedure not used, I keep it here just as a reminder.
proc Reader { pipe } {
    if {[eof $pipe]} {
		catch {close $pipe}
		return
    }
    gets $pipe line
	if {$line == "dhsSubscribe running"} {
        #if you decide to use this procedure, remember to give the
		#right arguments to the following 2 lines
		#startState
		#dominoLoop 1000 checkArrivals
    }
}

#dataSubscriber is running, set all the flags and buttons.
proc startState {type} {
    global gvar  env

    $gvar(mainCV).dominoStartWdg$type disable
    $gvar(mainCV).dominoStopWdg$type enable
    $gvar(mainCV).dominoConfigWdg disable
    panDisableMenuEntry File "New Program ID"
    $gvar(mainCV).dominoNttWdg$type.frame.uifBitmap configure -background green
    $gvar(mainCV).dataSubscriberBarchartWdg$type configure -label "$type files from $env(DHS_HOST)"
    set gvar(lifeState-$type) "alive"
	set gvar(loopLifeTime-$type) $gvar(loopLifeTime)
	after 6000 selectLog $type
    after 7000 set gvar(startFlag-$type) 1
    htDebug "dataSubscriber $type started" 3 
}

#Stop dataSubscriber
proc Stop {type} {
    global gvar env

    Busy $gvar(mainCV) {
		#Cancel the checkArrivals loop
		set gvar(cancelLoop-$type) 1
		set gvar(cancelLifeLoop-$type) 1
		set gvar(lifeState-$type) "dead"
		$gvar(mainCV).dominoStopWdg$type disable
		
		#Here I put the clean-dhs command
		switch -- $type {
			RAW {exec dhsSubscribeControl stop userRaw &}
			RED {exec dhsSubscribeControl stop userReduced &}
			default {exec cleanup-olas &}
		}
		
		#I used these commands to wait dhsSubscribe to die.
		set gvar(goFlag-$type) 0
		set gvar(countPid-$type) 0
		after 3000 "dominoDeathLoop 1000 \"checkDeath $type\" $type"
		vwait gvar(goFlag-$type)
    }
}

#dataSubscriber has been stopped, set all the flags and buttons.
proc stopState {type} {
    global gvar  env

    #At the beginning everything is disabled
    #If you want to start you have to check the preferences before.
    if {!$gvar(missingInfo)} {
		$gvar(mainCV).dominoStartWdg$type enable 
	} else {
		$gvar(mainCV).dominoStartWdgRAW disable
		$gvar(mainCV).dominoStartWdgRED disable
	}
	
    $gvar(mainCV).dominoStopWdg$type disable
    $gvar(mainCV).dominoNttWdg$type.frame.uifBitmap configure -background grey
    set gvar(startFlag-$type) 0
    set gvar(expected-$type)  0
    set gvar(fromToLabel$type) ""
    set gvar(alreadyRunning-$type) 0

    if {$gvar(alreadyRunning-RAW) == 0 && $gvar(alreadyRunning-RED) == 0} {
		$gvar(mainCV).dominoConfigWdg enable
		panEnableMenuEntry File "New Program ID"
    }

    #if {$gvar(alreadyRunning-RAW) == 0} {
	#$gvar(mainCV).dominoStartWdgRED disable }
    #Enable here Menu Bar
}

#Call the edit preferences panel.
proc dominoEditPrefs {type} {
    global gvar env 
    
    htDebug "Call preferences..." 3
    wm withdraw .
    dominoImportPanel dominoPrefs
    $gvar(mainCV).dominoConfigWdg enable
    panEnableMenuEntry File "New Program ID"
    
}

#Procedure not used.
#Empty the selected table and rename it <table>.tmpht
proc dominoCleanTable {} {
    global gvar

    set table    [open $gvar(selTable) r]
    set tmptable [open $gvar(selTable).tmpht w]

    while {[gets $table line] > 0} {
		set firstKey [string trimright [lindex [split $line ","] 0] " "]
		if {$firstKey != "HTRENAME"} {puts $tmptable $line}
    }
    close $table
    close $tmptable
    file copy -force $gvar(selTable).tmpht $gvar(selTable)
    file delete $gvar(selTable).tmpht
}

#Count the queued and processed files.
proc checkArrivals {type} {
    global gvar  env

    if {$gvar(startFlag-$type) == 0} { return }
    
    #counts the files queued
    if {[catch {set gvar(filesQueued$type) [llength [glob $env(DHS_LOG)/.*$type*.bulk]]}]} {set gvar(filesQueued$type) 0}
    htDebug "File queued - $type = $gvar(filesQueued$type)" 2
    
    #counts the files processed
    set count [open $env(DHS_LOG)/.counter-$gvar(ID-$type).tmp r]
    gets $count gvar(filesArrived$type)
    close $count
    exec chmod 660 $env(DHS_LOG)/.counter-$gvar(ID-$type).tmp

    htDebug "File processed = $gvar(filesArrived$type)" 2
	
    #update perc bar
    if {$gvar(dominoTo-$type) != ""} {
		if {[file exists $env(DHS_LOG)/.expected-$gvar(ID-$type).tmp]} {
			if {[catch {set expfile [open $env(DHS_LOG)/.expected-$gvar(ID-$type).tmp r]}]} {htInfo "Cannot open $env(DHS_LOG)/.expected-$gvar(ID).tmp" ; return }
			gets $expfile gvar(expected-$type)
			close $expfile
			htDebug "I expect $gvar(expected-$type) frames" 1
			
			if {$gvar(expected-$type) == "" } {
				htDebug "Expect file empty. Try again..." 1
				return 
			} else { 
				htDebug "Expected $env(DHS_LOG)/.expected-$gvar(ID-$type).tmp deleted" 3
				file delete $env(DHS_LOG)/.expected-$gvar(ID-$type).tmp }
			
			if {$gvar(expected-$type) == 0} { 
				set gvar(perc$type) 0
				htDebug "Nothing to retrieve for type $type" 1
				$gvar(mainCV).dataSubscriberBarchartWdg$type configure -label "Nothing to deliver."
				Stop $type
			} else {
				writeSchemaInfo $type
				
				# set infofile [open $env(DHS_LOG)/DhsSubscribeInfo-$gvar(ID-$type) w]
				# 		puts $infofile $gvar(dominoFrom-$type) 
				# 		puts $infofile $gvar(dominoTo-$type)
				# 		puts $infofile $gvar(expected-$type)
				# 		close $infofile
			}
			
			set gvar(cancelLoop-$type) 1
			if {!$gvar(alreadyRunning-$type)} {
				if {[catch {set countpar [open $env(DHS_LOG)/.counter-$gvar(ID-$type).tmp w]}]} {htInfo "Cannot open $env(DHS_LOG)/.counter-$gvar(ID-$type).tmp"}
				puts $countpar "0"
				close $countpar
				exec chmod 660 $env(DHS_LOG)/.counter-$gvar(ID-$type).tmp
			}
			set gvar(filesArrived$type) 0
			set gvar(perc$type) 0
			after 5000 "dominoLoop 10000 \"checkArrivals $type\" $type"
		} else { 
			if {$gvar(filesArrived$type) != "" && $gvar(expected-$type) != 0 } {
				htDebug "Files processed = $gvar(filesArrived$type)" 1
				htDebug "Files Expected =  $gvar(expected-$type)" 1
				
				if {[catch {set gvar(perc$type) [expr {($gvar(filesArrived$type) * 100)/$gvar(expected-$type)}]}]} {set gvar(perc$type) 0}
				htDebug "We received $gvar(perc$type) % -- $type " 1
				if {$gvar(filesArrived$type) == $gvar(expected-$type)} { 
					set gvar(perc$type) 0
					$gvar(mainCV).dataSubscriberBarchartWdg$type configure -label "$type files delivered."
					htDebug "Everything is arrived for $type " 1
					Stop $type }
			}
		}
    } 
    
    #Check if a new logfile has been created.
    if {[catch {set newlog [lindex [lsort -decreasing [glob $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(ID-$type).????-??-??] ] 0 ]}]} {set newlog ""}
    
    if {$newlog != $gvar(lastLog-$type)} {set gvar(lastLog-$type) $newlog
		htDebug  "*** The new log is $gvar(lastLog-$type) ***" 1
		set gvar(errorNum) 0}

    if {![catch {set newErrors [exec grep -c ERROR $gvar(lastLog-$type)]}]} { if {$newErrors > $gvar(errorNum-$type)} {set gvar(errorNum-$type) $newErrors
		Alarm $type}
    } else { return }
}

#Show the last 100 lines from the log.
proc showLog {type} {
    global gvar


    #set buf [exec tail -100 $gvar(lastLog-$type)]
    #htDebug "$buf" 1
    #panTerm "DHS Log-$type" $buf
    if {![info exists gvar(lastLog-$type)] || ![file readable $gvar(lastLog-$type)]} {htInfo "There is no log file." ; return }
    exec xterm  -title "$type LOG" -geometry 80X10 -fn fixed -e tail -f $gvar(lastLog-$type) &

}

#Automatically select the "youngest" log file. 
proc selectLog {type} {
    global gvar env

    set gvar(lastLog-$type) [lindex [lsort -decreasing [glob -nocomplain $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(ID-$type).????-??-??] ] 0 ]
    #$gvar(mainCV).dominoShowLogWdg$type enable
    htDebug "Considering log = $gvar(lastLog-$type)" 1
    
    if {[catch {set gvar(errorNum-$type) [exec grep -c ERROR $gvar(lastLog-$type)]}]} {
		set gvar(errorNum-$type) 0}
}

##########################################################################
#                            Utilities                                   #
##########################################################################

#Utility to execute a command in background. It exploits the blt bgexec command
proc dominoExCom {cmd} {
    set execStatus 0
    htDebug "Ex: $cmd" 1
    if {[catch {eval blt::bgexec execStatus -output execOutput \
					-error execErrors [lindex $cmd 0] [lrange $cmd 1 end]} msg]} {
		htInfo "Error envoking command:\n\
		\"$cmd\""
		return -1
    }
    set execStatus 0
}


# This procedure imports the panel into the parent panel,
# and waits on a gvar() variable called:
#
# gvar(<panel name>_exit)
#
# for the panel to signal that the imported panel has
# terminated
proc dominoImportPanel {panel {inputVar ""}} {
    global gvar env 

    set gvar(${panel}_exit) 0
    set oldMainCV $gvar(mainCV)
    panImportPanel $panel $inputVar
    vwait gvar(${panel}_exit)
    set gvar(mainCV) $oldMainCV
}

#Close the panel and auf wiedersehen
proc dominoClose {} {
    global gvar env popflag

    if {$gvar(alreadyRunning-RAW) == 1 || $gvar(alreadyRunning-RED) == 1} {
		set answer [tk_messageBox -message "dhsSubscribe is (are) still running !\n \
Do you want to stop it (them) before exiting ?" -type yesnocancel -icon question]
	switch -- $answer {
	    yes {Stop RAW
		Stop RED}
	    cancel { return }
	}
    }
    if {[info exists gvar(dbTable)] &&  $gvar(dbTable) != ""} {htPopUp "Your renaming schema is not in the database.\nYou can wait for the DB to come up\nor tell the operator to check the config file.\nDo you want to exit ?" 1 0 1
	if {$popflag == 0} { return }
    }
    
    #panClosePanel no
    exit
}


#Loop routine.
proc dominoLoop { time cmd type } {
	global gvar

    if {$gvar(cancelLoop-$type) == 1} {
		set gvar(cancelLoop-$type) 0
		after cancel $gvar(loopId-$type)
		htDebug  "$type Loop - $gvar(loopId-$type) - $cmd - killed " 3
    } else {
		eval $cmd
		set gvar(loopId-$type) [after $time dominoLoop $time \"$cmd\" $type ]
		htDebug "LoopID = $gvar(loopId-$type) -- cmd = $cmd" 3
    }
}

#Loop routine for dead processes.
proc dominoDeathLoop { time cmd type } {
	global gvar

    if {$gvar(cancelDeathLoop-$type) == 1} {
		set gvar(cancelDeathLoop-$type) 0
		after cancel $gvar(loopDeathId-$type)
		htDebug  "$type Loop - $gvar(loopDeathId-$type) - $cmd - killed " 3
    } else {
		eval $cmd
		set gvar(loopDeathId-$type) [after $time dominoDeathLoop $time \"$cmd\" $type ]
		htDebug "LoopID = $gvar(loopDeathId-$type) -- cmd = $cmd" 3
    }
}

#Loop routine for living processes.
proc dominoLifeLoop { cmd type } {
	global gvar

    if {$gvar(cancelLifeLoop-$type) == 1} {
		set gvar(cancelLifeLoop-$type) 0
		after cancel $gvar(loopLifeId-$type)
		htDebug  "$type Loop - $gvar(loopLifeId-$type) - $cmd - killed " 3
	} else {
		eval $cmd
		set gvar(loopLifeId-$type) [after $gvar(loopLifeTime-$type)  dominoLifeLoop \"$cmd\" $type ]
		htDebug "LoopID = $gvar(loopLifeId-$type) -- cmd = $cmd" 3
		
	}
}


#Turns the small icon green
proc setNormal {type} {
    global gvar 

    if {$gvar(startFlag-$type)} {
		$gvar(mainCV).dominoNttWdg$type configure -hotSpotColor green
		$gvar(mainCV).dominoNttWdg$type.frame.uifBitmap configure -background green
    }
}


proc dsLookUpView {} {
    global gvar env

    if {![file exists $env(DHS_LOG)/$gvar(programID)-lookuptable.txt]} {
		htInfo "The Filename table is not (yet) there."
		return 
    } else { panImportPanel dsLookup }
    

}


#Turns the small icon red
proc Alarm {type} {
    global gvar 

    $gvar(mainCV).dominoNttWdg$type configure -hotSpotColor red
    $gvar(mainCV).dominoNttWdg$type.frame.uifBitmap configure -background red
    htDebug "Alarm icon red !" 1
}


#Parse the arguments from the command line and set some options
proc setOptions {} {
    global gvar

    for { set i 0} {$i <[llength $gvar(args)]} {incr i} {
        switch -- [lindex $gvar(args) $i] {
			-info {
				#incr i
				explainAll
			} 
			-debug {
				incr i
				set level [lindex $gvar(args) $i]
				if {$level == "" || $level > 3 || $level < 1} {
					explain
				}
				set gvar(debugMode) $level
			} 
			-log {
				incr i
				set logFile [lindex $gvar(args) $i]
				if {[catch {set gvar(logFile) [open $logFile a]} var]} {
					puts "Cannot open $logFile"
					exit }
				if {![info exists gvar(debugMode)]} { set gvar(debugMode) 1 }
			} 
			-postcommandlog {
				#incr i
				set gvar(postCommandLog) 1
			} 
			default {
				explain
			}
		}
    }
}

#I won't explain explain =;-)
proc explain {} {
    
    puts "Usage: dataSubscriber -info -log <filename> -debug \[1-3\] -postcommandlog"
    exit
}


proc explainAll {} {
    puts "-info           : This message"
    puts "-log <filename> : Puts all the messages in the specified file"
    puts "                : If you don't specify -debug the verbose level"
    puts "                : will be set to 1"
    puts "-debug \[1-3\]  : Define the verbose level"
    puts "-postcommandlog : Enable loggin within postcommand"
    exit

}

#Procedure use to communicate with the database.
proc Sybsql { select } {
    global gvar sybmsg
    
    if {[catch {set sybHandle [sybconnect $gvar(sybaseUsername) $gvar(sybasePassword) $gvar(db_server)]} handle]} {htInfo "Cannot connect to server, reason: $sybmsg(dberrstr)"
		puts "Cannot connect to server, reason: $sybmsg(dberrstr)"
		sybclose $sybHandle
		return "error" }
    
    if {[catch {set resultQuery [sybsql $sybHandle $select]} handle]} { htInfo "Cannot query/update database, reason: $sybmsg(msgtext); dberrstr = $sybmsg(dberrstr); $sybmsg(oserrstr)" 
		htDebug "The query was: $select" 1
		sybclose $sybHandle
		return "error" }
    
    sybclose $sybHandle
    return $resultQuery
}

#procedure to get results from Sybase. Not used for the moment.
proc getResult {sybHandle} {
    global sybmsg
    
    set buffer ""
    set row [sybnext $sybHandle]
    if {$sybmsg(nextrow) == "NO_MORE_RESULTS"} {
		return "" }
    while {$sybmsg(nextrow) != "NO_MORE_ROWS"} {
		lappend buffer $row
		set row [sybnext $sybHandle]
    }
    return $buffer
}

proc dominoLoadFht {} {
	global gvar
    
    set myStatus 0
    if {$gvar(fhtProcNum) >= 2} {htInfo "There are already 2 FHTs running"
		return }
    incr gvar(fhtProcNum) +1
    blt::bgexec myStatus fht
    incr gvar(fhtProcNum) -1
}


#-----------------------------------------------------------------------------
# run the given tcl command while displaying the busy cursor in the main window
# 
# Bugs: if $cmd contains a "return", it will not actually return the
# first time Busy is called (something to do with autoloading). After
# the first call, it will work ok. Either avoid return in $cmd, or
# call "Busy {}" first.
#-----------------------------------------------------------------------------
set busy_count 0
proc Busy {window cmd} {
    set w $window
    global errorInfo busy_count
    if {[incr busy_count] == 1} {
        #       set focus [focus]
        #       focus none
        blt::busy hold $w -cursor watch
        update
        update idletasks
    }
    
    # save any errors and report them later
    if {[set code [catch [list uplevel $cmd] msg]]} {
        set info $errorInfo
    } 

    if {[incr busy_count -1] == 0} {
        blt::busy release $w
        #       catch {focus $focus}
    }

    if {$code} {
        return -code $code -errorinfo $info $msg
    }
}


#-----------------------------------------------------------------------------
# Run the tcl command $cmd while displaying the busy cursor in  window $w.
# Also works to block a listbox but allow the scrollbars to 
# still be used. ($W should probably not be '.', use Busy for that).
#
# Note: had problems in Tk3.6 here with watch cursor showing up after
# deiconfiying the window. Try again in Tk4.0 ?
#-----------------------------------------------------------------------------
proc BusyWin {w cmd} {
    global errorInfo busywin_count

    if {! [info exists busywin_count($w)]} {
        set busywin_count($w) 0
    }

    if {[incr busywin_count($w)] == 1} {
        #       set focus [focus]
        #       focus none
        eval blt::busy hold $w -cursor watch
        update idletasks
        update
    }
    
    # save any errors and report them later
    if {[set code [catch [list uplevel $cmd] msg]]} {
        set info $errorInfo
    } 

    if {[incr busywin_count($w) -1] == 0} {
        update idletasks
        blt::busy release $w
        #       catch {focus $focus}
    }

    if {$code} {
        return -code $code -errorinfo $info $msg
    }
}


proc windowOnTop {new {master .}} {
    global gvar

    # Handle the wm properties so that the window can't be overlayed
    wm gro $new $master
    wm tran $new $master
    wm withdraw $new
    wm deico $new
}



#
# ___oOo___
