/*+
************************************************************************
****  C A N A D I A N   A S T R O N O M Y   D A T A   C E N T R E  *****
*
* (c) 2000.				(c) 2000.
* National Research Council		Conseil national de recherches
* Ottawa, Canada, K1A 0R6 		Ottawa, Canada, K1A 0R6
* All rights reserved			Tous droits reserves
* 					
* NRC disclaims any warranties,		Le CNRC denie toute garantie
* expressed, implied, or statu-		enoncee, implicite ou legale,
* tory, of any kind with respect	de quelque nature que se soit,
* to the software, including		concernant le logiciel, y com-
* without limitation any war-		pris sans restriction toute
* ranty of merchantability or		garantie de valeur marchande
* fitness for a particular pur-		ou de pertinence pour un usage
* pose.  NRC shall not be liable	particulier.  Le CNRC ne
* in any event for any damages,		pourra en aucun cas etre tenu
* whether direct or indirect,		responsable de tout dommage,
* special or general, consequen-	direct ou indirect, particul-
* tial or incidental, arising		ier ou general, accessoire ou
* from the use of the software.		fortuit, resultant de l'utili-
* 					sation du logiciel.
*
************************************************************************
*
*   Name:		ad/sql/get_file_media.sql
*
*   Purpose:
*	Whatever
*
*   Database		: <database_name>
*
*   Date		: May 10, 2000
*
*   SCCS data		: @(#)
*	Module Name	: get_file_media.sql
*	Version Number	: 1.3
*	Release Number	: 1
*	Last Updated	: 08/15/01
*
*   Programmer		: Norm Hill
*
*   Modification History:
*
****  C A N A D I A N   A S T R O N O M Y   D A T A   C E N T R E  *****
************************************************************************
-*/

print "Using database asto"
use asto
go

if exists ( select name from sysobjects
        where name = 'get_file_media' and type = 'P' )
    drop procedure get_file_media
go

create procedure get_file_media
	@file_id varchar(45) = NULL,
	@asto char(6) = NULL
as
    if ( @file_id = NULL or @asto = NULL )
    begin
	print "usage: get_file_media <file_id>, <asto>"
    end
    else
    begin
	declare @error char(1)
	select @error = 'E'

	select type = media_type
	    from asto..mfs v, archive..mfsfiles f
	    where status != @error and v.crc = f.crc and file_id = @file_id and
		    v.asto = @archive

	select type
	    from asto..tps v, archive..tpfiles f
	    where status != @error and v.tapename = f.tapename and
		    file_id = @file_id and v.asto = @archive

	select type = 'MD'
	    from asto..mds v, archive..mdfiles f
	    where status != @error and v.diskname = f.diskname and
		    file_id = @file_id and v.asto = @archive
	
	select type = 'DB'
	    from asto..dbs v, archive..dbfiles f
	    where file_id = @file_id and v.volume = f.volume and
		    v.asto = @archive

	select type = 'CD'
	    from asto..cds v, archive..cdfiles f
	    where status != @error and v.diskname = f.diskname and
		    file_id = @file_id and v.asto = @archive

	select type = 'OD'
	    from asto..ods v, archive..odfiles f
	    where status != @error and v.diskname = f.diskname and
		    file_id = @file_id and v.asto = @archive
    end
go

grant execute on get_file_media to public
go
