#!/bin/bash 
#
# netperf: starts/stops NetPerf server
#
# chkconfig: 2345 97 03
#
# description: Starts and stops the netserver daemon
#
# processname: netserver
#
# location: /usr/bin/netperf
#
# $Id: netperf.sh,v 1.3 2007/09/11 13:11:16 cguirao Exp $

# Source function library.

OWNER=root

#
# Check the OWNER user exist 
#
id $OWNER > /dev/null
if [ $? -ne 0 ]; then  
  exit 1
fi

#export PATH=/opt/netperf:$PATH

# Source function library.
. /etc/rc.d/init.d/functions 

if  ! rpm -q netperf ; then
  echo "RPM netperf not installed"
  exit 1
fi


RETVAL=0

start() {
        echo -n $"Starting NetPerf netserver: "
	daemon --user $OWNER /usr/bin/netserver -p 12865
        RETVAL=$?
        echo
        [ $RETVAL -eq 0 ] && touch /var/lock/subsys/netserver
        return $RETVAL
}

stop() {
        echo -n $"Shutting down NetPerf netserver: "
        killproc netserver
        RETVAL=$?
        echo
	[ $RETVAL -eq 0 ] && rm -f /var/lock/subsys/netserver
        return $RETVAL
}


# See how we were called.
case "$1" in
  start)
	start
	;;
  stop)
	stop
	;;
  status)
	status netserver
	;;
  restart)
	stop
	start
	;;
  *)
	echo "Usage: $0 {start|stop|status|restart}"
	exit 1
esac

exit $RETVAL

