// -*-c++-*-

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// COPYRIGHT (c) European Southern Observatory
// LICENSE:   ESO internal use only
// 
// PROJECT:   VLT Data Flow System
// AUTHOR:    Jens Knudstrup - ESO/DMD/DFS
// SUBSYSTEM: DFS Archive System
//
// $Name: arcsys-1_2_8 $
// $Revision: 1.7 $
// $Log: ArcSysEx.h,v $
// Revision 1.7  2006/08/08 15:29:22  jknudstr
// -
//
//-----------------------------------------------------------------------------

#ifndef ARCSYSEX_H
#define ARCSYSEX_H


// C++ includes
#include <exception>

// STL includes
#include <string>
#include <vector>


using namespace std;


/// Exception class used within the context of the arcsys project.
class ArcSysEx: public exception 
{
  public:

    /// Constructor setting internal message.
    ArcSysEx(const string& msg) {msg_ = msg;};

    /// Destructor.
    ~ArcSysEx(void) throw() {};

    /// Return reference to internal message.
    string& what(void) {return msg_;};

  private:
    string msg_;
};


#endif // ARCSYSEX_H

// EOF

