//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//COPYRIGHT (c) 1996 European Southern Observatory
//LICENSE
//
//PROJECT:   VLT On-line Data Flow
//AUTHOR:    Michael Wiedmer - ESO/DMD/DPG
//SUBSYSTEM: System Core
//
//$Revision: 1.1 $
//$Log: CorPlexer.h,v $
//Revision 1.1  2004/09/06 14:35:21  cguirao
//*** empty log message ***
//
//Revision 1.1  2004/06/23 12:47:09  cguirao
//First check in
//
//Revision 1.2  1998/06/30 08:49:50  dataflow
//Removing $NAME
//
//Revision 1.1  1997/04/10 08:05:44  dfadmin
//Initial revision
//
//Revision 1.1  1996/11/25 09:35:42  mwiedmer
//first release
//
//-----------------------------------------------------------------------------

#ifndef COR_PLEXER_H
#define COR_PLEXER_H

// includes from this library
// includes from other ESO libraries
#include <CorBase.h>
// includes from other libraries
// system includes

// typedef, extern, enums
// variables: consts, statics, exported variables (declared extern elsewhere)
// local forward function declarations
class CorUnitTest;

/// A simple linked list class 
struct CorPlexer {
  /**
  {\footnotesize $Id: CorPlexer.h,v 1.1 2004/09/06 14:35:21 cguirao Exp $ } \\

  {\large SYNOPSIS} \\
  \begin{verbatim}
    #include <CorPlexer.h>
  
    CorPlexer myObject;
  \end{verbatim}

  {\large DESCRIPTION} \\
  This text serves as an example for the documentation of a class definition

  {\large CAUTIONS} \\
  <optional> \\

  {\large EXAMPLES} \\
  <optional> \\

  {\large SEE ALSO} \\
  <optional> \\
  \Ref{CorBase}\\
  */

  ///
  void* data();
  /** {\large Purpose} \\
  Query this instance's data.

  {\large Preconditions} \\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}

  {\large Returns}\\
  This function returns the data package of this instance.

  {\large Exceptions}\\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}
  */


  ///
  static CorPlexer* create(
    /** {\large Purpose} \\
    Create a new data package.

    {\large Preconditions} \\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Returns}\\
    This function returns a pointer to the newly allocated memory with the
    datapackage.

    {\large Exceptions}\\
    \begin{itemize}
    \item Itemize this section if necessary. Remove itemization otherwise.
    \end{itemize}

    {\large Arguments}\\
    */
    ///
    CorPlexer*& aHead,
    /** list header */
    ///
    unsigned int aMax,
    /** maxinum thingy */
    ///
    unsigned int anElement
    /** Another value */
  );


  ///
  void freeDataChain();
  /** {\large Purpose} \\
  Free this package and its links.

  {\large Preconditions} \\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}

  {\large Exceptions}\\
  \begin{itemize}
  \item Itemize this section if necessary. Remove itemization otherwise.
  \end{itemize}
  */




protected:


private:
  friend void utest_CorPlexer(CorUnitTest&);  // the unit test function

  CorPlexer*   mNext;  // next package
  unsigned int mMax;   // number of packages
  unsigned int mCur;   // current package

};

#endif // COR_PLEXER_H
