// -*-c++-*-

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// COPYRIGHT (c) European Southern Observatory
// LICENSE:   ESO internal use only
// 
// PROJECT:   VLT Data Flow System
// AUTHOR:    Stefano Zampieri - ESO/DMD/DFS
// SUBSYSTEM: n/a
//
// $Revision: 1.3 $
// $Log: DfsLog.h,v $
// Revision 1.3  2006/05/17 16:36:39  szampier
// added datetime + thread info to log msgs
//
// Revision 1.2  2006/05/05 16:06:36  szampier
// removed generated Makefile.in
//
// 
// 
// DFS Logging Macros
// 
//------------------------------------------------------------------------------

#ifndef DFS_LOG_H
#define DFS_LOG_H

#include "ace/Log_Msg.h"

#define DEBUG_PREFIX       "%D DEBUG [ %t ] "
#define INFO_PREFIX        "%D INFO  [ %t ] "
#define WARN_PREFIX        "%D WARN  [ %t ] "
#define ERROR_PREFIX       "%D ERROR [ %t ] "
#define FATAL_PREFIX       "%D FATAL [ %t ] "

#define NEWLINE            ACE_TEXT("\n")

#define DFS_TRACE(MSG) ACE_TRACE(MSG)

#define DFS_DEBUG(FMT, ARGS...)  \
        ACE_DEBUG(( LM_DEBUG,  \
                    DEBUG_PREFIX FMT NEWLINE,  \
                    ##ARGS ))

#define DFS_INFO(FMT, ARGS...)  \
        ACE_DEBUG(( LM_INFO,  \
                    INFO_PREFIX FMT NEWLINE,  \
                    ##ARGS ))

#define DFS_WARN(FMT, ARGS...)  \
        ACE_DEBUG(( LM_WARNING,  \
                    WARN_PREFIX FMT NEWLINE,  \
                    ##ARGS ))

#define DFS_ERROR(FMT, ARGS...)  \
        ACE_DEBUG(( LM_ERROR,  \
                    ERROR_PREFIX FMT NEWLINE,  \
                    ##ARGS ))

#define DFS_FATAL(FMT, ARGS...)  \
        ACE_DEBUG(( LM_CRITICAL,  \
                    FATAL_PREFIX FMT NEWLINE,  \
                    ##ARGS ))

#endif /* DFS_LOG_H */
