// -*-c++-*-

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// COPYRIGHT (c) European Southern Observatory
// LICENSE:   ESO internal use only
// 
// PROJECT:   VLT Data Flow System
// AUTHOR:    Christophe Moins- ESO/SDD/DFS
// SUBSYSTEM: arcsys 
//
// $Revision: 1.1 $
// $Log: KeywordRep.h,v $
// Revision 1.1  2007/12/14 16:40:22  cmoins
// first version
//
// Revision 1.2  2007/12/07 14:13:52  cmoins
// implementation of keyword records readout from data product id
// VS: ----------------------------------------------------------------------
//
// Revision 1.1  2007/12/07 12:57:20  cmoins
// first version of the header on the fly correction tool
//
//
//------------------------------------------------------------------------------

#ifndef KEYWORD_REP_H
#define KEYWORD_REP_H

#include <string>
#include <vector>

/// Implementation of  a record of the keyword repository table
namespace headerOnTheFly {

  struct KeywordRep
  { 

    // default container associated to KeywordRep instances
    typedef std::vector<KeywordRep> ResultSet;

    /// Default constructor
    KeywordRep()
    {}

    /// Constructor setting all the data member
    KeywordRep(std::string dpId,
	       std::string kwName,
	       std::string kwValue,
	       std::string kwType,
	       std::string kwComment,
	       int         extId,
	       int         kwInd):
      dpId_(dpId),
      kwName_(kwName),
      kwValue_(kwValue),
      kwType_(kwType),
      kwComment_(kwComment),
      extId_(extId),
      kwInd_(kwInd)
    {}

    /// data product id
    std::string dpId_;
    /// keyword name
    std::string kwName_;
    /// keyword values
    std::string kwValue_;
    /// keyword type
    std::string kwType_;
    /// keyword comment
    std::string kwComment_;
    /// extension id
    int extId_; 
    /// keyword index
    int kwInd_;

  };
}
#endif /* KEYWORD_REP_H */

