// -*-c++-*-

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// COPYRIGHT (c) European Southern Observatory
// LICENSE:   ESO internal use only
// 
// PROJECT:   VLT Data Flow System
// AUTHOR:    Jens Knudstrup - ESO/DMD/DFS
// SUBSYSTEM: DFS Archive System
//
// $Name: arcsys-1_2_8 $
// $Revision: 1.2 $
// $Log: NgasRestoreTask.h,v $
// Revision 1.2  2007/05/10 15:34:24  jknudstr
// Testing ArcRepSA2PA ...
//
// Revision 1.1  2007/05/03 15:32:07  jknudstr
// Intermediate check-in while developing the SA->PA Archive Replicator.
//
// Revision 1.1  2007/04/23 11:22:38  jknudstr
// Changed name of Tl2NgasRearchTask to NgasRearchTask.
//
// Revision 1.6  2006/08/08 15:29:22  jknudstr
// -
//
//-----------------------------------------------------------------------------

#ifndef NGASRESTORETASK_H
#define NGASRESTORETASK_H


// Local includes
#include <GenTask.h>


/// Class that implements the NGAS Restore Task.
class NgasRestoreTask: public GenTask
{
  public:
    /// Constructor registering common instance of the Replication Agent Class
    /// and the output message queue to use for this task.
    NgasRestoreTask(RepAgent&     repAgent,
		    MsgQueue&     msgOutputQueue);

    /// Destructor method.
    ~NgasRestoreTask();

    int svc();

    void initBusiness();

    void srvBusiness();

    void restore();

  private: 
    string        tlOutputDir_;
    NgamsClient   ngasClient_;
};


#endif // NGASRESTORETASK_H

// EOF

