// -*-c++-*-

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// COPYRIGHT (c) European Southern Observatory
// LICENSE:   ESO internal use only
// 
// PROJECT:   VLT Data Flow System
// AUTHOR:    Christophe Moins- ESO/DMD/DFS
// SUBSYSTEM: arcsys - Archive Systems
//
// $Revision: 1.2 $
// $Log: ObservationServiceSyb.h,v $
// Revision 1.2  2007/05/02 09:38:38  cmoins
// adding of a DAO class to objects representing files on magnetic disks
//
// Revision 1.1  2007/04/25 15:11:57  cmoins
// creation of sybase based Observation service layer
//
// 
//------------------------------------------------------------------------------

#ifndef OBSERVATION_SERVICE_SYB_H
#define OBSERVATION_SERVICE_SYB_H

#include "ObservationService.h"
#include "RawDataProductDAO.h"
#include "MagDiskFileDAO.h"
#include "ServiceConnectionSyb.h"

/**
 * Data access service layer to retrieve files  of an observation program or an 
 * observation block along with their locations.
 * It uses the Sybase api to connect to the database and sql based DAO classes
 */
typedef ObservationService<ServiceConnectionSyb,
                           RawDataProductDAO,
			   MagDiskFileDAO> 
ObservationServiceSyb;

#endif //OBSERVATION_SERVICE_SYB_H
