// -*-c++-*-

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// COPYRIGHT (c) European Southern Observatory
// LICENSE:   ESO internal use only
// 
// PROJECT:   VLT Data Flow System
// AUTHOR:    Jens Knudstrup - ESO/DMD/DFS
// SUBSYSTEM: DFS Archive System
//
// $Name: arcsys-1_2_8 $
// $Revision: 1.11 $
// $Log: RepQMonTask.h,v $
// Revision 1.11  2007/01/11 15:35:10  jknudstr
// -
//
// Revision 1.10  2006/08/08 15:29:22  jknudstr
// -
//
//-----------------------------------------------------------------------------

#ifndef REPQMONTASK_H
#define REPQMONTASK_H


// Local includes
#include <GenTask.h>


/// Class that implements the Replication Queue Monitoring Task.
/// Tasks of this type should only run in one instance.
class RepQMonTask: public GenTask
{
  public:
    /// Constructor registering common instance of the Replication Agent Class
    /// and the output message queue to use for this task.
    RepQMonTask(RepAgent&     repAgent,
		MsgQueue&     msgOutputQueue);

    /// Destructor method.
    ~RepQMonTask();

    /// ACE_Task Server method.
    int svc(void);

    ///  Method implementing the business logic of the initialization.
    void initBusiness(void);

    /// Method implementing the business logic of this server process.
    void srvBusiness(void);

    /// Restore the previous state from the DB information.
    void restore(void);
};


#endif // REPQMONTASK_H

// EOF
