//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//COPYRIGHT (c) 1996 European Southern Observatory
//LICENSE
//
//PROJECT:   VLT On-line Data Flow
//AUTHOR:    <Michael Wiedmer - ESO/DMD/DPG>
//SUBSYSTEM: <Core>
//
//$Revision: 1.1 $
//$Log: cor_debug.h,v $
//Revision 1.1  2004/09/06 14:35:21  cguirao
//*** empty log message ***
//
//Revision 1.1  2004/06/23 12:47:09  cguirao
//First check in
//
//Revision 1.3  1998/06/30 08:49:55  dataflow
//Removing $NAME
//
//Revision 1.2  1997/12/03 15:05:47  dfadmin
//update for NTT Jan 98
//
//Revision 1.10  1997/07/11 08:34:58  mwiedmer
//update conditional include macro name
//
//Revision 1.9  1997/05/16 08:11:08  mwiedmer
//mad corTRACE_ENV and corDEBUG_ENV always available
//
//Revision 1.8  1997/04/11 13:32:07  mwiedmer
//use RWStrings
//
//Revision 1.1  1997/04/10 08:05:44  dfadmin
//Initial revision
//
//Revision 1.7  1996/10/30 13:19:32  mwiedmer
//variables are not defined anymore,
//only declared
//
//Revision 1.6  1996/10/11 08:47:26  mwiedmer
//hide variables if no DEBUG needed
//
//Revision 1.5  1996/09/23 09:15:36  mwiedmer
//COR_TRACE() goes into its own header file
//
//Revision 1.4  1996/09/17 11:12:54  mwiedmer
//added COR_USE_ARGS
//
//Revision 1.3  1996/09/10 11:22:22  mwiedmer
//update debugging and debug printing
//mechanism
//
//Revision 1.2  1996/09/03 14:41:28  mwiedmer
//added RCS Name tag
//
//Revision 1.1  1996/09/02 11:04:06  dfadmin
//First release
//
//Revision 1.3  1996/09/02 09:45:37  mwiedmer
//first release
//
//Revision 1.2  1996/09/02 08:25:51  mwiedmer
//*** empty log message ***
//
//-----------------------------------------------------------------------------

#ifndef COR__DEBUG_H
#define COR__DEBUG_H

// includes from this library
// includes from other ESO libraries
// includes from other libraries
// system includes

// Development switching mechanism
#ifdef DEBUG

// Compile with option -DDEBUG to switch on assertions,
// debugging, tracing and printing.

#define COR_USE_ASSERT
#define COR_USE_DEBUG
#define COR_USE_TRACE
#define COR_USE_ARGS
#define COR_USE_PRINTS

#else

#undef COR_USE_ASSERT
#undef COR_USE_DEBUG
#undef COR_USE_TRACE
#undef COR_USE_ARGS
#undef COR_USE_PRINTS

#endif

extern const char* corDEBUG_ENV;
// If the above environment variable is set then the following debugging
// mechanisms will come into effect:
// - COR_DEBUG(FUNC) executes the function FUNC
// - COR_L1(FUNC)    executes the function FUNC if the variable is < 2
// - COR_L2(FUNC)    executes the function FUNC if the variable is < 3
// - COR_L3(FUNC)    executes the function FUNC if the variable is < 4

extern const char* corTRACE_ENV;
// If the above environment variable is set then the following debugging
// mechanisms will come into effect:
// - COR_TRACE(TEXT) prints TEXT indented to the level of the calling stack

// see cor_assert.h, cor_prints.h and cor_trace.h

#endif


