package org.eso.ohs.core.dbb.client;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

import org.eso.ohs.core.dbb.server.DbbQuery;
import org.eso.ohs.core.dbb.server.DbbQueryImpl;
import org.eso.ohs.core.utilities.ObjectIOException;

public class BasicPagination extends Paginator {

	String sql = null;

	public BasicPagination(SqlElements elements, String url, String userId, String password, String database) throws ObjectIOException, SQLException {
		super(elements, url, userId, password, database);
		sql = buildQuery();
		count = countItems();
	}
	

	private String buildQuery() {
		StringBuffer result= new StringBuffer();
		StringBuffer bufCount = new StringBuffer();
		
		result.append("SELECT ");
		bufCount.append("SELECT count(*) ");
		ArrayList<Object> select = elements.getSelect();
		for (int i = 0; i < select.size(); i++){
			result.append(select.get(i)).append(", ");
		}
		result.delete(result.length()-2, result.length()-1);
		
		result.append("FROM ");
		bufCount.append("FROM ");
		ArrayList<Object> from = elements.getFrom();
		for (int i = 0; i < from.size(); i++){
			result.append(from.get(i)).append(", ");
			bufCount.append(from.get(i)).append(", ");
		}
		result.delete(result.length()-2, result.length()-1);
		bufCount.delete(bufCount.length()-2, bufCount.length()-1);
		
		result.append("WHERE ");
		bufCount.append("WHERE ");
		
		ArrayList<Object> where = elements.getWhere();
		for (int i = 0; i < where.size(); i++){
			result.append(where.get(i)).append(", ");
			bufCount.append(where.get(i)).append(", ");
		}
		result.delete(result.length()-2, result.length()-1);
		bufCount.delete(bufCount.length()-2, bufCount.length()-1);
		sql = result.toString();
		sqlCount =  bufCount.toString();
		
		result.append("ORDER BY ");
		ArrayList<Object> orderBy = elements.getOrderBy();
		for (int i = 0; i < orderBy.size(); i++){
			result.append(orderBy.get(i)).append(", ");
		}
		result.delete(result.length()-2, result.length()-1);
		
		return result.toString();
	}

	public DbbQuery moveTo(int pageNumber, int pageSize) throws SQLException {
		DbbQuery result = null;
		int startRow = pageSize * (pageNumber - 1) + 1;
		int endRow = startRow + pageSize - 1;
	/*	Statement stmt = con.createStatement();
		String setRowCount = "set rowcount " + endRow;
		stdlog.debug(setRowCount);
		stmt.execute(setRowCount);
		stdlog.debug(sql);
		stmt = con.createStatement();*/
		ResultSet queryResult = session.execSql(sql, endRow);
		
		result = new DbbQueryImpl(queryResult, session, startRow);
		
		return result;
	}
}
