package org.eso.ohs.core.dbb.client;

// $Id: DbbRightAscension.java,v 1.4 2006/01/11 16:22:07 amchavan Exp $

import org.eso.ohs.core.utilities.Convert;

/**
 *  A transducer to convert set/get of String values into set/get
 *  on an int property.  The target property's name is given to the
 *  constructor. The renderer is applied to a RA obj
 *
 *  <p>
 *  For example, users will call it's
 *  setValue/getValue methods.  Those calls will be translated into
 *  calls to setX/getX on the object given to the constructor.
 *
 *  <p>
 */

public class DbbRightAscension extends Coordinate {

    private static int angleToHourFactor = 15;  
    //----------------------------------------
    // Public methods
    //----------------------------------------


    /**
     * Converts data to a String from the meta-level equivalent of the actual
     * property's type, i.e. from a java.lang.Long to a long int.
     * 
     * @param value value of the property.
     */
    // amchavan, 10-Jan-2006: refactored; fixed bug, was returning bad string
    public String fromDatabaseData( Object obj ) {

        int milliSeconds = 0;
        if( obj != null ) {
            milliSeconds = (((Integer) obj).intValue()) / angleToHourFactor;
        }
        
        String ret = Convert.millisecToHHMMSS( milliSeconds );
        return ret;
    }


    /**
     * Converts data from a String to a meta-level equivalent of the
     * actual property's type, i.e. to a java.lang.Integer
     * representing an int.
     *
     * @param value the new value of the property.
     */
    public Object toDatabaseData(String value) {
	int milliarcSec = 0; 
	if (value != null ) {
	    milliarcSec = Convert.HHMMSSToMillisec(  value ) ;
	}
    int millisecs = milliarcSec * angleToHourFactor;
	return new Integer(millisecs);
    }


}

