package org.eso.ohs.core.dbb.client;

import java.awt.event.ActionEvent;

import javax.swing.JFrame;

import org.eso.ohs.core.gui.baseaction.ActionSuperclass;


/**
 * Action class to dismiss (i.e.\ close) the current window.
 * 
 * <p>
 * $Id: DismissAction.java,v 1.1 2005/02/11 10:41:43 tcanavan Exp $
 * <br>
 * @author Bob Kemp
 */

public class DismissAction extends ActionSuperclass {

    /** window to be dismissed, ie closed */
    private JFrame window_;

    /**
     * Constructs a Dismiss action.
     */
    public DismissAction(JFrame wdw) {
    	super(wdw, "Close");  
    	window_ = wdw;
    }

    /**
     * Event handler for the Dismiss action.
     * 
     * @param ev       user-initiated ActionEvent to dismiss the window.
     */
    public void actionPerformedImpl(ActionEvent evt) {
        //window_.setVisible(false);
	    window_.dispose();
    }
}


