package org.eso.ohs.core.dbb.client;

import java.util.ArrayList;

import org.apache.commons.collections.CollectionUtils;
import org.eso.ohs.core.utilities.MsgManager;

public class SqlElements {

	private ArrayList<Object> select = new ArrayList<Object>();
	private ArrayList<Object> from = new ArrayList<Object>();
	private ArrayList<Object> where = new ArrayList<Object>();
	private ArrayList<Object> orderBy = new ArrayList<Object>();
	public SqlElements(String[] select, String[] from, String[] where, String[] orderBy){
		if (select == null && select.length < 1) 
			throw new IllegalArgumentException(MsgManager.errPrecondition("select is null or empty"));
		if (from == null && from.length < 1) 
			throw new IllegalArgumentException(MsgManager.errPrecondition("from is null or empty"));
		if (where == null) 
			throw new IllegalArgumentException(MsgManager.errPrecondition("where is null"));
		if (orderBy == null) 
			throw new IllegalArgumentException(MsgManager.errPrecondition("orderBy is null"));
		
		CollectionUtils.addAll(this.select, select);
		CollectionUtils.addAll(this.from, from);
		CollectionUtils.addAll(this.where, where);
		CollectionUtils.addAll(this.orderBy, orderBy);
	
	}
	public ArrayList<Object> getFrom() {
		return from;
	}
	public ArrayList<Object> getOrderBy() {
		return orderBy;
	}
	public ArrayList<Object> getSelect() {
		return select;
	}
	public ArrayList<Object> getWhere() {
		return where;
	}
	
}
