package org.eso.ohs.core.dbb.client;


import org.apache.log4j.Logger;
import org.eso.ohs.core.utilities.Convert;

/**
 * Utility class to process STARCAT dates.
 *
 * @version $Revision: 1.2 $
 * @author ddorigo, Mar 2, 2006
 */

// $Id: StarcatDate.java,v 1.2 2006/03/06 10:56:49 ddorigo Exp $

public class StarcatDate implements DbbDataType {

    private static Logger stdlog_ = Logger.getLogger( StarcatDate.class );
  
    private final static String DEFAULT_ = "------------------";


    public int getDataTypeLength() {
        return DEFAULT_.length();
    }

    public Class getDataType() {
        return String.class;
    }

    public Class getDatabaseType() {
        return Integer.class;
    }

    public String fromDatabaseData(Object value) {
		long date = 0;
    	
     	Integer val = (Integer)value;
		date = val.longValue();
    	
		
		String ret = Convert.starcatDateToString(date);  
	
		return ret;
    }

    public Object toDatabaseData(String value) {
		long val = Convert.stringToStarcatDate(value);	  	
	return(new Long(val));
    }

}
