package org.eso.ohs.core.dbb.htmlclient;

/**
 * TODO: Javadoc
 *
 * @version $Revision: 1.1 $
 * @author amchavan 
 */

// $Id: DbbHtmlSortPanel.java,v 1.1 2004/02/17 11:16:25 tcanavan Exp $

public class DbbHtmlSortPanel extends DbbHtmlPanel {

    public DbbHtmlSortPanel( String title, int cols ) {
        super(title, cols);
    }

    public DbbHtmlSortPanel( String title, int rows, int cols ) {
        super(title, rows, cols);
    }

    /**
     * Generate a fragment of HTML code rendering this panel. The fragment is
     * suitable to be included in the HTML rendering of a DbbHtmlView (an HTML
     * table).
     * 
     * @param indentLevel
     *            The level of indentation for the HTML fragment. Each level is
     *            indented by INDENTSPACES spaces.
     * 
     * @return An HTML fragment rendering this widget.
     * 
     * @see DbbHtmlWidget#INDENTSPACES
     */
    public String render( int indentLevel ) {
        String ind0 = DbbHtmlWidget.indentSpaces( indentLevel     );
        String ind1 = DbbHtmlWidget.indentSpaces( indentLevel + 1 );
        String ind2 = DbbHtmlWidget.indentSpaces( indentLevel + 2 );
        
        StringBuffer sb = new StringBuffer();
        
        
        sb.append( ind0 ).append( "<table>\n" );
        if( getTitle() != null ) {       
                sb.append( ind1 )
                  .append( "<caption>" )
                  .append( getTitle() )
                  .append( "</caption>\n" );
        }
        
        sb.append( ind1 ).append( "<tr>\n" );
        sb.append( ind2 ).append( "<th class='sort'>&nbsp;</th>" );        
        sb.append( ind2 ).append( "<th class='sort'>None</th>" );        
        sb.append( ind2 ).append( "<th class='sort'>Asc</th>" );        
        sb.append( ind2 ).append( "<th class='sort'>Desc</th>" );        
        sb.append( ind1 ).append( "</tr>\n" );
        for( int i = 0; i <= maxRow_; i++ ) {
            
            sb.append( ind1 ).append( "<tr>\n" );
            
            for (int j = 0; j < cols_; j++)
                if( grid[i][j] != null )
                    sb.append( grid[i][j].render( indentLevel + 2 ));
                else {
                    String msg = "Empty grid element ["
                                 + i
                                 + ","
                                 + j
                                 + "] in Sort Panel";
                
                    throw new RuntimeException( msg );
                }
            sb.append( ind1 ).append( "</tr>\n" );
        }
        sb.append( ind0 ).append( "</table>\n" );
        
        return sb.toString();
    }
}
