package org.eso.ohs.core.gui.utilities;

import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.net.URL;

import javax.swing.Icon;
import javax.swing.ImageIcon;

import org.apache.log4j.Logger;

public class ImageUtils {

    private static Logger stdlog_ = Logger.getLogger(ImageUtils.class);

    public static Icon getIcon(String name) {

        ImageIcon icon = null;
        ClassLoader loader = ImageUtils.class.getClassLoader();
        String resource = "org/eso/ohs/icons/" + name;
        URL urlImage = ClassLoader.getSystemResource(resource);
        if (urlImage != null) {
            icon = new ImageIcon(urlImage);
        } else {
            stdlog_.error(
                " sysResource from classloader \"" + resource + "\" not found");
        }
        return icon;
    }

    public static BufferedImage convertToBufferedImage(
        Image img,
        int wid,
        int ht,
        int type) {
        BufferedImage bi = new BufferedImage(wid, ht, type);
        Graphics2D g2d = bi.createGraphics();
        g2d.drawImage(img, 0, 0, wid, ht, null);
        return bi;
    }

}
