package org.eso.ohs.core.gui.utilities;


import java.awt.Font;
import java.util.Enumeration;
import java.util.Vector;

import javax.swing.UIDefaults;
import javax.swing.UIManager;
import javax.swing.plaf.FontUIResource;


public class SystemFonts {


    /**
     * Returns the default resource and fint pairs that are used by the UIManager.
     */



     public static FontResource [] getDefaultFonts() {
        UIDefaults defaults = UIManager.getDefaults();       
        Class<FontUIResource> findClass = FontUIResource.class;
        Vector<FontResource> fontResourceVector = new Vector<FontResource>();
        Enumeration e = defaults.keys();
        while (e.hasMoreElements()) {
            Object o = e.nextElement();
            Object v = defaults.get(o);			
            if (v != null) {
                if (findClass != null && findClass.isAssignableFrom(v.getClass())) {
                    FontResource fntRes = new FontResource((String)o,(Font)v);
                    fontResourceVector.addElement((FontResource)fntRes);
                } 
            }
        }
        FontResource [] fontResource = new FontResource[fontResourceVector.size()];
        fontResourceVector.copyInto(fontResource);
        return fontResource;
     }


    public static void increaseUIManagerFontSize(int sizeIncrease) {
        FontResource [] fontResource = getDefaultFonts();
        for(int i=0;i<fontResource.length;i++) {
            Font oldFont = fontResource[i].getFont();
            Font font =  new Font(oldFont.getName(),oldFont.getStyle(),oldFont.getSize()+sizeIncrease);           
            UIManager.put(fontResource[i].getResource(),font);
        }
    }

    public static  void decreaseUIManagerFontSize(int sizeDecrease) {
        FontResource [] fontResource = getDefaultFonts();
        for(int i=0;i<fontResource.length;i++) {
            Font oldFont =  fontResource[i].getFont();
            Font font =  new Font(oldFont.getName(),oldFont.getStyle(),oldFont.getSize()-sizeDecrease);           
            UIManager.put(fontResource[i].getResource(),font);
        }
    } 


    public static void setNameOfFont(String resource,String name) {
        FontResource [] fontResource = getDefaultFonts();
        for(int i=0;i<fontResource.length;i++) {
            if(resource.equals(fontResource[i].getResource())){
                Font oldFont =  fontResource[i].getFont();
                Font font =  new Font(name,oldFont.getStyle(),oldFont.getSize());
                UIManager.put(fontResource[i].getResource(),font);
            }
        }
    }
}
