package org.eso.ohs.core.gui.widgets;

import java.awt.Component;

import javax.swing.JFrame;
import javax.swing.JPasswordField;
import javax.swing.JTextField;

import org.eso.ohs.core.gui.models.UsernameInputModel;

/**
 * Excepts the user id and password and returns a flag to
 * the caller to determinew what action has taken place.
 * <p>
 * $Id: LoginDialog.java,v 1.3.4.5 2007/07/20 11:57:22 pnunes Exp $
 * <br>
 * @author Tim Canavan
 * <br>ChangeLog: Bob Kemp
 */

public class LoginDialog extends SimpleInputDialog {

    /**   
     * User name entry field
     */
    private JTextField usernameField_ = new JTextField(16);

    /** 
     * Password entry field
     */
    private JPasswordField passwordField_ = new JPasswordField(10);

    /**
     * Create a password dialog
     * @param frm Frame for dialog
     * @param title title of dialog
     */
    public LoginDialog(JFrame frm, String title) {
		this(frm, title, null);
		setName("Login Dialog");
	}
    
    /**
     * Create a password dialog
     * @param frm Frame for dialog
     * @param title title of dialog
     */
    public LoginDialog(JFrame frm, String title,String message,  Component extraComponent) {
        super(frm, title);
        initialise(message,
    		    new String[] { "User name ", "Password " },
    		    new Component[] { usernameField_, passwordField_,extraComponent }
        );

    	usernameField_.setDocument(new UsernameInputModel());
    	passwordField_.setEchoChar('-');	
    }

    /**
     * Create a password dialog
     * @param frm Frame for dialog
     * @param title title of dialog
     */
    public LoginDialog(JFrame frm, String title, String message) {
		super(frm, title);

		initialise(message, new String[] { "User name ", "Password " },
				new Component[] { usernameField_, passwordField_ });

		usernameField_.setDocument(new UsernameInputModel());
		passwordField_.setEchoChar('-');
	}

    protected void requestInitialFocus() {
		usernameField_.requestFocus();
	}

    /**
     * Get the username which is always an integer
     */
    public int getUserName() throws NumberFormatException {
    	
    	String userNameStr = usernameField_.getText();
    	int result = -1;
    	try {
    	result = new Integer(userNameStr).intValue();
    	} catch (Exception e) {
    		//TODO fix better
    		e.printStackTrace();
    	}
    	return result;
		

	}
    
    /*
     * 
     */
    
    public String getStringUserName()   {
    	String userNameStr = usernameField_.getText();
		return userNameStr;

	}

    /**
	 * Get the password the usser has entered
	 */
	public String getPassword() {
		return new String(passwordField_.getPassword());
	}
	
	
	
	/**
	 * Sets the username in the text field
	 * @param username
	 */
	public void setUsername(String username) {
		usernameField_.setText(username);		
	}
	
	/**
	 * Sets the password in the text field
	 * @param passwd
	 */
	public void setPasswd(String passwd) {
		passwordField_.setText(passwd);
	}

}
