package org.eso.ohs.core.gui.widgets;

import org.apache.log4j.Logger;
import org.eso.ohs.core.utilities.EventListenerList;


/**
 * @author pnunes 07.12.05
 *
 */
public class ProgressModelDefault implements ProgressModel {

	 /** List of listeners */
    protected EventListenerList listenerList = new EventListenerList();
	
    private static Logger stdlog_ =
        Logger.getLogger(ProgressModelDefault.class);
    
    
	private int min;
	private int max;
	private String msg;
	private int currentValue;
			
	
	public ProgressModelDefault(int min, int max, String msg) {
		this.max = max;
		this.min = min;
		this.msg = msg;
	}


	public int getMaximum() {		
		return max;
	}

	public int getMinimum() {
		return min;
	}

	public int getValue() {
		return currentValue;
	}
	

	public void setMaximum(int max) {
		this.max = max;
	}

	public void setMinimum(int min) {
		this.min = min;
	}

	public void setValue(int value) {
		this.currentValue = value;
		firePropertyChangeEvent(new ProgressModelEvent(this,value,getMinimum(),getMaximum()));
	}

	
	
	public String getMsg() {
		return msg;
	}

	public void setMsg(String msg) {
		this.msg = msg;
	}

	public void addChangeListener(ProgressModelListener l) {
		listenerList.add(ProgressModelListener.class,l);

	}

	public void removeChangeListener(ProgressModelListener l) {
		listenerList.remove(ProgressModelListener.class,l);

	}
	
	
	protected void firePropertyChangeEvent(ProgressModelEvent ev) {	       
		
		Object[] listeners = listenerList.getListenerList();
		for (int i = listeners.length - 2; i >= 0; i -= 2) {
			if (listeners[i] == ProgressModelListener.class) {
				((ProgressModelListener) listeners[i + 1])
				.modelChanged(ev);
			}
		}		
		
	} 
	

}
