package org.eso.ohs.core.gui.widgets;

import java.awt.Component;
import java.awt.event.MouseEvent;

import javax.swing.JComponent;
import javax.swing.JList;
import javax.swing.ListCellRenderer;


/**
 * There is not getToolTipText method in JList
 * This class provides it so tooltip text cab
 * be rendered for a JList.

 */


public class ToolTipJList extends JList {

    /**
     * Create a ToolTipJList
     */

    public ToolTipJList() {
        super();
    }

    /**
     * ToolTip text for an individual item in the JList
     * @param event Mouse Selection event on the item in the JList
     */
  
    public String getToolTipText(MouseEvent event) {
        int idx = locationToIndex(event.getPoint());

        if (idx == -1)
        return null;

        Object value = getModel().getElementAt(idx);
        ListCellRenderer cellRenderer = getCellRenderer();
        Component c = cellRenderer.getListCellRendererComponent(this,(String)value,idx,false,false);
        return ((JComponent)c).getToolTipText();
    }
      
}


