package org.eso.ohs.core.utilities;

import java.io.Serializable;

/** 
 * This class dcontains the basic unit of information that is parsed 
 * for all Paf files. A Paf file is made up of a list of these 
 * String pairs. 
 */

public class PafData implements Serializable {

    /** Version id for object serialization */
    static final long serialVersionUID = -4899424080046990623L;

   /**
    * Linenumber in the paf file
    */

    private int lineNumber_;
           
     
    /**
     * This is the label which enables one to identify the data item
     */
    
    private String identifier_;

    /**
     * This is the data which the identifier describes
     */
    private String value_;


    /**
     * The linnumber for a given identifier + value pair
     * @return lineNumber_ linenumber
     */
  
    public int getLineNumber() {
        return lineNumber_;
    }



    /**
     * Returns identfier
     * @return identifier
     * 
     */

    public String getIdentifier() {return identifier_;}

    /**
     * Returns the data for an identifier
     * @return value associated with an ID
     */
   
    public String getValue() {return value_;}      

    /**
     * Sets the value for a given identifier
     * @param value set value for a given id.
     */

    public void setValue(String value) {value_ = value;}

    /**
     * Sets the identifier
     * @param identifer id linked to value
     */

    public void  setIdentifier(String identifier) {identifier_ = identifier;}

   
    /**
     * Set the linenumber attribute
     * @param lineNumber Linenumber in paffile for a given id + value pair
     */

    public void setLineNumber(int lineNumber) {lineNumber_ = lineNumber;}


    /**
     * PafData has a valud or not
     * @return true if string value > 0 else false
     *
     */

    public boolean hasValue() {
        if(value_ != null && value_.length() > 0)
            return true;
        return false;
    }


}


