package org.eso.ohs.core.utilities;

/**
 * This class provides an interface to a Vector of Strings. It is used to
 * de-couple a specific storage class from the scripting interface.
 * @author Nick Kornweibel
 */

import java.util.Vector;

public class StringSet {

    private Vector<String> data_ = new Vector<String>();

    public StringSet(Vector<String> data) {
        if (data != null) {
            data_ = data;
        }
    }

    /**
     * get the number of elements
     * @return integer number of elements (>= 0)
     */

    public int getElementCount() {
        return data_.size();
    }

    /**
     * get the element at the specified index
     * @param index (>= 0)
     * @return return the string value of the element at the specified index.
     */

    public String getElementAt(int index) {
        String rc = "";
        if (index < data_.size()) {
            Object elem = data_.elementAt(index);
            rc = elem.toString();
        }
        return rc;
    }
}
