package org.eso.ohs.core.utilities.rmi;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.rmi.server.ServerNotActiveException;

/**
 * @version $Id: OHSServerControl.java,v 1.1 2004/02/17 14:34:33 tcanavan Exp $
 *
 * This class defines the control of a generic application server.
 * 
 * @author amchavan, 15-Oct-2001: Creation
 */
public interface OHSServerControl extends Remote {

    /** 
     * Terminate the server with an exit status
     *
     * @param xstat  The exit status for the server.
     */
    void exit( int xstat ) throws ServerNotActiveException, RemoteException;

    /**
     * This method can be used to 'ping' a server and check if it is running.
     */
    void ping() throws RemoteException, ServerNotActiveException;

}

