package org.eso.ohs.dfs;

import java.util.Vector;



/**
 * A MaskQueue class is used for manipulating a collection of ObservationBlock
 * objects and its assocciated execution sequences
 *
 * @author Giorgio Passera <ESO \ DMD> <gpassera@eso.org>
 */

public class MaskQueue extends Queue {



    private static final long serialVersionUID = 1L;
    private QueueItem [] execSequenceQueueItems_ = {};


    /**
     * Default constructor
     */

    public MaskQueue() {
        super();      
    }


    public static String getType() {
        return "M";
    }

 
    public void setExecutionSequence(QueueItem [] queueItems) {
        execSequenceQueueItems_ = queueItems;
        
        if (execSequenceQueueItems_ != null) {
            setSize(execSequenceQueueItems_.length);
        } else {
            setSize(0);
        }
        System.out.println("ID = " + getId());
        setUpdate(true);
        //PropertyChangeEvent ev =
        //new PropertyChangeEvent(this, Queue.ITEMLIST, null, null);
        //firePropertyChangeEvent(ev);   
    }

    public QueueItem [] getExecutionSequence() {
        return execSequenceQueueItems_;
    }


    public void appendToExecSequence(long [] obIds,String [] types) {
        setExecutionSequence(appendQueueItems(obIds,execSequenceQueueItems_,types));
    } 

    public void removeExecQueueItems(long [] obIds  ) {
        Vector<QueueItem> queueList = new Vector<QueueItem>();
        for(int i=0;i<execSequenceQueueItems_.length;i++) {
            boolean found = false;
            for(int j=0;j<obIds.length;j++) {
                if(execSequenceQueueItems_[i].getObId()
                   == obIds[j]) {
                    found = true;
                    break;
                }
            }
            if (!found) {
                queueList.addElement(execSequenceQueueItems_[i]);
            }
        }
        QueueItem [] queueItems = new QueueItem[queueList.size()];
        queueList.copyInto(queueItems);
        setExecutionSequence(queueItems);
    }
    
    public String toString() {      
         StringBuffer buf = new StringBuffer();
         for(int i=0;i<execSequenceQueueItems_.length;i++) { 
             buf.append(execSequenceQueueItems_[i].toString());
         }
         return buf.toString();
    }
 
}
