/*
 * Created on Sep 13, 2004
 */
package org.eso.ohs.dfs.phase1;

import java.util.Hashtable;

import org.apache.log4j.Logger;
import org.eso.ohs.core.utilities.Convert;
import org.eso.ohs.core.utilities.OHSConfig;
import org.eso.ohs.core.utilities.TextUtils;

/**
 * Class RunDataInfo
 *
 * TODO Javadoc
 *
 * @version $Revision: 1.6 $
 * @author ddorigo, Jan 23, 2006
 */

// $Id: RunDataInfo.java,v 1.6 2006/04/27 10:37:43 tcanavan Exp $

public class RunDataInfo {
    /**
     * Logger for this class
     */
    private static final Logger stdlog_ = Logger
            .getLogger(RunDataInfo.class);

    private static String[] modeList_ = null;

    static String[] rankCat_ = null;

    private static String[] seeingList_ = null;

    private static Hashtable<String,String> table_;
    private static final String[] RUN_DESC =
    { "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N",
            "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z" };

   
    /** Return Moon */
    public static String[] getMoon() {
        String[] moon =
        { "d", "g", "n" };
        return moon;
    }

    public static String[] getRankCatList() {
        OHSConfig config = OHSConfig.getInstance();
        if (rankCat_ == null) {
            String rank = config.getValue("phrs.viewschedule.rankcat.values");
            rankCat_ = TextUtils.stringToStringArray(rank, ",", true);
        }

        return rankCat_;
    }

    /** Return Moon */
    public static String[] getSeeingList() {
        OHSConfig config = OHSConfig.getInstance();
        if (seeingList_ == null) {
            String seeing = config.getValue("phrs.viewschedule.seeing.values");
            seeingList_ = TextUtils.stringToStringArray(seeing, ",", true);
        }

        return seeingList_;
    }


    /**
     * @return String[] month list in sched rep
     */
    public static String[] getMonthList() {
        String[] origMonthList = Convert.getLowerCaseMonths();
        String[] monthList = new String[origMonthList.length + 1];
        for (int i = 0; i < origMonthList.length; i++) {
            monthList[i] = origMonthList[i];
        }
        monthList[monthList.length - 1] = "any";
        return monthList;
    }

    public static String[] getRunDesc(){
        String[] runDesc = new String[RUN_DESC.length];
        for (int i = 0; i < RUN_DESC.length; i++) {
            runDesc[i] = RUN_DESC[i];
        }
    return runDesc;
    };
    
    
    /**
     * generates the run id from the prog type and the description
     * @param progId program id
     * @param runDescription UpperCase Letter
     * @return long the run id
     */
    public static long buildRunId(long progId, String runDescription) {
        long runId = 0;
        String runIdLastDigits = getRunDescMappingIntValue(runDescription);     
           runId = Integer.parseInt(runIdLastDigits) + progId * 10;      
        return runId;
    }

    /**
     * returns the last two digits of the run id for that run desc
  *  (e.g. A  00, B 01)
      * @param runDesc an UpperCase letter of the alphabet
     * @return String the two digits. null if no corrispondence.
     * @throws IllegalArgumentException 
     */
    public static String  getRunDescMappingIntValue(String runDesc) throws IllegalArgumentException {
        String runId = (String) getRunDescMapping().get(runDesc);
        if (runId == null) {
        throw new IllegalArgumentException(
                "run description invalid value must be [A-Z]: \""
                        + runDesc + "\"");
        }
        return runId;
    }
    /** Returns a Hashtable of run_descriptions */
    private static Hashtable getRunDescMapping() {
        if (table_ == null) {
            table_ = new Hashtable<String,String>();
            table_.put("A", "00");
            table_.put("B", "01");
            table_.put("C", "02");
            table_.put("D", "03");
            table_.put("E", "04");
            table_.put("F", "05");
            table_.put("G", "06");
            table_.put("H", "07");
            table_.put("I", "08");
            table_.put("J", "09");
            table_.put("K", "10");
            table_.put("L", "11");
            table_.put("M", "12");
            table_.put("N", "13");
            table_.put("O", "14");
            table_.put("P", "15");
            table_.put("Q", "16");
            table_.put("R", "17");
            table_.put("S", "18");
            table_.put("T", "19");
            table_.put("U", "20");
            table_.put("V", "21");
            table_.put("W", "22");
            table_.put("X", "23");
            table_.put("Y", "24");
            table_.put("Z", "25");
        }
        return table_;
    }

    public static String[] getModes() {
        String[] modes =
        { "s", "v"};
        return modes;
    }
}
