package org.eso.ohs.evm;

/**
 * This is a dummy implementation of the EVMImpl interface and is used as
 * an implementation object by the EVMExecutor when the scripting package
 * can not be loaded.
 *
 * See EVMImpl and EVMExecutor for a description of how they form the
 * Bridge pattern.
 *
 * The class does little...it is really just a "place holder".
 *
 * @author Nick Kornweibel
 */
import java.io.File;

import org.eso.ohs.dfs.CalibrationBlock;


public class DummyEVMImpl implements EVMImpl {

    /**
     * Do nothing.
     */

    public void initImpl(String[] scriptDrivers, EVMScriptFinder sf)
            throws EVMException { }

    /**
     * Throw an exception - verification not possible with dummy.
     */

    public void verifyImpl(CalibrationBlock[] obs) throws EVMException {
        throw new EVMException("DummyEVMImpl does not support verification");
    }

    /**
     * do nothing
     */

    public void setScriptTimeoutImpl(long millis) { }

    /**
     * dummy has no timeout - return 0L
     */

    public long getScriptTimeoutImpl() {
        return 0L;
    }

    /**
     * dummy supports no scripts - return empty array
     */

    public String[] getSupportedScriptExtensionsImpl() {
        return new String[0];
    }


    /**
     * Throw an exception - dummy can not execute scripts.
     */

    public void runScriptImpl(File filepath) throws EVMException {
        throw new EVMException("DummyEVMImpl can not execute scripts");
    }

    /**
     * Do nothing
     */

    public void addEVMMessageListenerImpl(EVMMessageListener m) {}

    /**
     * Do nothing
     */

    public void removeEVMMessageListenerImpl(EVMMessageListener m) {}
    
    /**
     * @see org.eso.ohs.evm.EVMImpl#calculateETCSImpl(org.eso.ohs.dfs.CalibrationBlock[])
     */
    public void calculateETCSImpl(CalibrationBlock[] obs) throws EVMException {
         throw new EVMException("DummyEVMImpl cannot execute execution scripts"); 
    }
}
