package org.eso.ohs.instruments;


/**
 * Instanciates a parameter class of type Boolean. Boolean values
 * are stored as True or False.
 * <p>
 * $Id: BooleanParameter.java,v 1.5 2003/03/07 12:14:52 nkornwei Exp $
 * @author Tim Canavan
 */



public class BooleanParameter extends Parameter {

    static final long serialVersionUID = -1353698877273331851L;

    /**
     * Boolean parameter constructor
     * @param name of parameter
     */
   
    public BooleanParameter(ParamMetaData pMeta) {
        super(pMeta);
    }

    /**
     * Tooltip text for boolean parameter
     * @return tooltip text
     */

    public String getToolTipText() {
        return "Set/Unset " + getParameterName();
    }

    public char getDBTypeCode() {
        return 'b';
    }


    /**
     * Verify a valid string  has been entered.
     * @param value String value to be verified
     * @return OK If value is a valid boolean else range True,False
     */

    public boolean  verifyValue(String value) {      
        if(value == null || value.length() <=0) {
	    return false;
	}      
        if(value.equals("T") || value.equals("F"))
            return true;
        return false;
    }    

}



