/*
 * Created on 14.11.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.eso.ohs.instruments;

/**
 * @author tcanavan
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ReadmeFloatAttribute extends ReadmeAttribute {

    private static final long serialVersionUID = -4378250031968166601L;

    public static final String DB_TYPE = "F";

    /**
     * @param readmeConfig
     */
    public ReadmeFloatAttribute(InstrumentConstraintConfig readmeConfig) {
        super(readmeConfig);
        // TODO Auto-generated constructor stub
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.eso.ohs.instruments.ReadmeAttribute#getRawValue()
     */
    public Object getRawValue() {
        // TODO Auto-generated method stub
        return new Float(getValue());
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.eso.ohs.instruments.ReadmeAttribute#isCompulsory()
     */
    public boolean isCompulsory() {
        // TODO Auto-generated method stub
        InstrumentConstraintConfig conf = getReadmeConfig();
        String value = getValue();
        if (conf.isCompulsory()) {
            if (!hasValue()) {
                return false;
            }
        }
        return true;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.eso.ohs.instruments.ReadmeAttribute#isComplete()
     */
    public String verify() {
        String value = getValue();
        if (!isCompulsory()) {
            return VERIFY_EMPTY;
        }
        try {
            float fValue = new Float(value).floatValue();
            InstrumentConstraintConfig conf = getReadmeConfig();
            InstrumentConstraintMetaData metaData = conf.getMetaData();
            float minValue = (float) metaData.getMinInclusive();
            float maxValue = (float) metaData.getMaxInclusive();
            if (fValue < minValue || fValue > maxValue) {
                return VERIFY_INVALID;
            }
        } catch (NumberFormatException e) {
            return VERIFY_INVALID;
        }
        return VERIFY_OK;
    }

    /* (non-Javadoc)
     * @see org.eso.ohs.instruments.ReadmeAttribute#getDBType()
     */
    public static String getDBType() {
        // TODO Auto-generated method stub
        return DB_TYPE;
    }

    /* (non-Javadoc)
     * @see org.eso.ohs.instruments.ReadmeAttribute#getToolTipText()
     */
    public String getToolTipText() {
        // TODO Auto-generated method stub
        InstrumentConstraintConfig conf = getReadmeConfig();
        InstrumentConstraintMetaData metaData = conf.getMetaData();
        float minValue = (float) metaData.getMinInclusive();
        float maxValue = (float) metaData.getMaxInclusive();
        String tooltip =
            "Enter value between " + minValue + " and " + maxValue;
        return tooltip;
    }

}