package org.eso.ohs.persistence;

import org.apache.log4j.Logger;
import org.eso.ohs.core.utilities.ObjectIOException;

/**
 * Default configuration information implementation.
 * 
 * <p>
 * $Id: DefaultPersistConfig.java,v 1.1.10.1 2007/10/11 08:28:29 pnunes Exp $
 */
public class DefaultPersistConfig extends Config {

	private static final String rcsid =
		"$Id: DefaultPersistConfig.java,v 1.1.10.1 2007/10/11 08:28:29 pnunes Exp $";

	private static Logger stdlog_ =
		Logger.getLogger(DefaultPersistConfig.class);

	public String getVersion() {
		//return AppConfig.getAppConfig().getVersion();
		return "Default Config";
	}

	public String[] folderColumnProperties(Class objType) {
		return new String[] {
		};
	}

	public String getDbUserName() {
		return AppConfig.getAppConfig().getDbUserName();
	}

	public String getDbPassword() {
		return AppConfig.getAppConfig().getDbPassword();
	}

	public String getUrl(String key) {
		stdlog_.debug(AppConfig.getAppConfig());
		return AppConfig.getAppConfig().getUrl(key);
	}

	public String getDbName(String key) {
		return AppConfig.getAppConfig().getDbName(key);
	}

//	public boolean isOperationsModeId(int uid) {
//		return AppConfig.getAppConfig().isOperationsModeId(uid);
//	}
//
//	public boolean isEngineeringModeId(int uid) {
//		return AppConfig.getAppConfig().isEngineeringModeId(uid);
//	}
//
//	public boolean isVisitorModeId(int uid) {
//		return AppConfig.getAppConfig().isVisitorModeId(uid);
//	}
//
//	public boolean isStandardModeId(int uid) {
//		return AppConfig.getAppConfig().isStandardModeId(uid);
//	}

	public boolean isCloneModeId() {
		return false;
	}


	/**
	   * What is the first period for which IP versioning info
	   * is expected in the data. 0 indicates no start period, no
	   * version info is expected.
	   */
	public int getStartPeriodForIPVersioning() {
		int rc = 0;
		
		if (AppConfig.getAppConfig()!= null && AppConfig.getAppConfig().isIPVersioningEnabled()) {
			rc = AppConfig.getAppConfig().getIPVersionStartPeriod();
		}
		return rc;
	}

	/**
	 * Ask for authentification before action can take place
	 * @param device Media referreed to DBASE,LOCAL_STORAGE
	 * @exception ObjectIOException Object I/O Excpetion
	 */
	public void askForAuthentication(Media device) throws ObjectIOException {
		throw new ObjectIOException("The Default Application doesn't authenticate");
	}



	public boolean isUserLevel(Class cls) {
		return cls != null && cls != DirectoryNode.class;
	}

	public void initPersistenceObjInfo() {
		stdlog_.error("The default persistence doesn't register BOs");

	}


}
