package org.eso.ohs.persistence;

/**
 * Defines the listener interface for detecting when 
 * storable objects are added and removed
 *
 * <p>
 * $Id: ObjectListener.java,v 1.4 2001/05/29 16:27:11 tcanavan Exp $
 * <br>
 * @author Bob Kemp
 */

public interface ObjectListener extends java.util.EventListener {

    /** 
     * "Object added" event handler.
     * 
     * @param ev    Event giving more specific details
     */
    public void objectAdded(ObjectEvent ev);

    /** 
     * "Object moved" event handler.
     * 
     * @param ev    Event giving more specific details
     */
    public void objectMoved(ObjectEvent ev);

    /**
     * "Object removed" event handler.
     *
     * @param ev    Event giving more specific details
     */
    public void objectRemoved(ObjectEvent ev);


    public void objectRemovedFromRegistry(ObjectEvent ev);
    

}

