package org.eso.ohs.persistence;
import org.eso.ohs.core.utilities.Encrypt;
import org.eso.ohs.core.utilities.OHSConfig;
import org.eso.ohs.core.utilities.ObjectIOException;
import org.eso.ohs.dfs.CommentCard;
import org.eso.ohs.dfs.Cycle;
import org.eso.ohs.dfs.EsoUser;
import org.eso.ohs.dfs.ObsProgramme;
import org.eso.ohs.dfs.ObsRun;
import org.eso.ohs.dfs.OpcPanel;
import org.eso.ohs.dfs.OpcReferee;
import org.eso.ohs.dfs.PanelObsRun;
import org.eso.ohs.dfs.Phase1Target;
import org.eso.ohs.dfs.ProposalSummaryDBFields;
import org.eso.ohs.dfs.ReportCard;
import org.eso.ohs.dfs.SchedRun;
/**
 * Clearing house for low-level configuration information.
 * 
 * <p>
 * $Id: PhrsPersistCfg.java,v 1.2 2005/06/02 13:17:20 ddorigo Exp $
 */
public class PhrsPersistCfg extends DefaultPersistConfig {
	private static final String rcsid =
		"$Id: PhrsPersistCfg.java,v 1.2 2005/06/02 13:17:20 ddorigo Exp $";
	public String getVersion() {
		//return AppConfig.getAppConfig().getVersion();
		return "PanelTool 2.0";
	}
	public String getDbUserName() {
		OHSConfig config = OHSConfig.getInstance();
		return config.getValue("phrs.database.userid");
		//return "opc";			
	}
	public String getDbPassword() {
		OHSConfig config = OHSConfig.getInstance();

		String pwd = Encrypt.deCrypt(
		config.getValue("phrs.database.password"));
		return pwd;
	}
	public String getUrl(String key) {
		OHSConfig config = OHSConfig.getInstance();
		String url =
			config.getValue("phrs.database.driver")
				+ ":"
				+ config.getValue("phrs.database.server")
				+ "/"
				+ config.getValue("phrs.phase1.database");
		return url;
	}
	public String getDbName(String key) {
		OHSConfig config = OHSConfig.getInstance();
		return config.getValue("phrs.phase1.database");
		//return "opc63";
	}
	public boolean isOperationsModeId(int uid) {
		return true;
	}
	public boolean isEngineeringModeId(int uid) {
		return false;
	}
	public boolean isVisitorModeId(int uid) {
		return false;
	}
	public boolean isCloneModeId() {
		return false;
	}
	public boolean isStandardModeId(int uid) {
		return false;
	}
	/**
	 * What is the first period for which IP versioning info
	 * is expected in the data. 0 indicates no start period, no
	 * version info is expected.
	 */
	public int getStartPeriodForIPVersioning() {
		return 0;
	}
	/**
	 * Ask for authentification before action can take place
	 * @param device Media referreed to DBASE,LOCAL_STORAGE
	 * @exception ObjectIOException Object I/O Excpetion
	 */
	public void askForAuthentication(Media device) throws ObjectIOException {
		throw new ObjectIOException("The PHRS doesn't authenticate");
	}
	public boolean isUserLevel(Class cls) {
		return cls != null && cls != DirectoryNode.class;
	}
	public void initPersistenceObjInfo() {
		ObjConfigPersistence ocp =
			new ObjConfigPersistence(ObsProgramme.class, new String[] {
		}, "", "", 1);
		objCfgPersistence.put(ocp.key, ocp);
		ocp = new ObjConfigPersistence(ObsRun.class, new String[] {
		}, "", "", 2);
		objCfgPersistence.put(ocp.key, ocp);
		ocp = new ObjConfigPersistence(OpcReferee.class, new String[] {
		}, "", "", 3);
		objCfgPersistence.put(ocp.key, ocp);
		ocp = new ObjConfigPersistence(EsoUser.class, new String[] {
		}, "", "", 4);
		objCfgPersistence.put(ocp.key, ocp);
		ocp = new ObjConfigPersistence(PanelObsRun.class, new String[] {
		}, "", "", 5);
		objCfgPersistence.put(ocp.key, ocp);
		ocp = new ObjConfigPersistence(Cycle.class, new String[] {
		}, "", "", 6);
		objCfgPersistence.put(ocp.key, ocp);
		ocp = new ObjConfigPersistence(SchedRun.class, new String[] {
		}, "", "", 7);
		objCfgPersistence.put(ocp.key, ocp);
		ocp = new ObjConfigPersistence(OpcPanel.class, new String[] {
		}, "", "", 8);
		objCfgPersistence.put(ocp.key, ocp);
		ocp = new ObjConfigPersistence(ReportCard.class, new String[] {
		}, "", "", 9);
		objCfgPersistence.put(ocp.key, ocp);
		ocp = new ObjConfigPersistence(CommentCard.class, new String[] {
		}, "", "", 10);
		objCfgPersistence.put(ocp.key, ocp);
		ocp = new ObjConfigPersistence(ProposalSummaryDBFields.class, new String[] {
		}, "", "", 11);	
		objCfgPersistence.put(ocp.key, ocp);
		ocp = new ObjConfigPersistence(Phase1Target.class, new String[] {
		}, "", "", 12);
		objCfgPersistence.put(ocp.key, ocp);
	}
}
