package org.eso.ohs.persistence.dao;

import java.util.HashMap;
import java.util.List;

import org.eso.ohs.dfs.phase1.CycleProperties;
import org.springframework.dao.DataAccessException;

/**
 * @author gdonino
 * This interface is the main interface to the cycle_properties table in the opc70 database
 *  
 */


public interface CyclePropertiesDAO {
	
	/**
	 * Find a ProposalGtoConflicts observation based upon
	 * the predefined attributes. Returns these attributes and the database id.
	 * @param proposalGtoConflict
	 * @return
	 * @throws DataAccessException
	 */
     
	public List getCycleList() throws DataAccessException;
	
	
	
	/**
	 * Retrieve all the properties name for a given cycle code
	 * @param a String representig a cycle code (ex: "7700", "7702")
	 * 
	 * @return
	 * @throws DataAccessException
	 */
     
	public List getCyclePropertiesName(String cycleCode) throws DataAccessException;
	public List getCyclePropertiesName(Integer cycleID) throws DataAccessException;
	
	public List<Integer> getNormalCyclesList() throws DataAccessException;
	
	public List<Integer> getDDTCyclesList() throws DataAccessException;
	
	public HashMap<String, String> getAttributesForCycle(Integer cycleID)throws DataAccessException;
	public HashMap<String, String> getAttributesForCycle(String cycleCode)throws DataAccessException;
	
	public void create(CycleProperties cycleProperties) throws DataAccessException;



	public Integer getNextIDForPeriod(String target);
	
	
	
	
	
}
