/**
 * 
 */
package org.eso.ohs.persistence.dao;

import java.util.List;

import org.eso.ohs.dfs.phase1.EsoUsersRoles;
import org.springframework.dao.DataAccessException;
import org.springframework.orm.hibernate3.HibernateTemplate;

/**
 * @author fsogni
 *
 */
public class EsoUsersRolesDAOHibernate implements EsoUsersRolesDAO {

	private HibernateTemplate hibernateTemplate;

	/**
	 * @return Returns the hibernateTemplate.
	 */
	public HibernateTemplate getHibernateTemplate() {
		return hibernateTemplate;
	}

	/**
	 * @param hibernateTemplate The hibernateTemplate to set.
	 */
	public void setHibernateTemplate(HibernateTemplate hibernateTemplate) {
		this.hibernateTemplate = hibernateTemplate;
	}
	
	
	/* (non-Javadoc)
	 * @see org.eso.ohs.persistence.dao.EsoUsersRolesDAO#find(org.eso.ohs.dfs.phase1.EsoUsersRoles)
	 */
	public EsoUsersRoles find(EsoUsersRoles esoUserRole) {
		Object [] paramArray = new Object[2];
		paramArray[0] = esoUserRole.getId().getLogin();
		paramArray[1] = esoUserRole.getId().getLettersRole();
		List l = hibernateTemplate.findByNamedQuery("findEsoUserRoleByProperties",paramArray);
		if(l.size() <=0) {
			throw new IllegalArgumentException("Not found");
		}
		EsoUsersRoles esoUserRoleFromDb = (EsoUsersRoles)l.get(0);	
		return esoUserRoleFromDb;
	}

	/* (non-Javadoc)
	 * @see org.eso.ohs.persistence.dao.EsoUsersRolesDAO#create(org.eso.ohs.dfs.phase1.EsoUsersRoles)
	 */
	public void create(EsoUsersRoles esoUserRole) throws DataAccessException {
		
		hibernateTemplate.save(esoUserRole);

	}

	/* (non-Javadoc)
	 * @see org.eso.ohs.persistence.dao.EsoUsersRolesDAO#update(org.eso.ohs.dfs.phase1.EsoUsersRoles)
	 */
	public void update(EsoUsersRoles esoUserRole) throws DataAccessException {
		
	

	}

	/* (non-Javadoc)
	 * @see org.eso.ohs.persistence.dao.EsoUsersRolesDAO#delete(org.eso.ohs.dfs.phase1.EsoUsersRoles)
	 */
	public void delete(EsoUsersRoles esoUserRole) throws DataAccessException {
		
		hibernateTemplate.delete(esoUserRole);
	}

}
