/**
 * 
 */
package org.eso.ohs.persistence.dao;

import java.util.List;

import org.eso.ohs.dfs.phase1.GtoConflicts;
import org.springframework.dao.DataAccessException;
import org.springframework.orm.hibernate3.HibernateTemplate;

/**
 * @author fsogni
 *
 */
public class GtoConflictsDAOHibernate implements GtoConflictsDAO {

	
	private HibernateTemplate hibernateTemplate;


	/**
	 * @return Returns the hibernateTemplate.
	 */
	public HibernateTemplate getHibernateTemplate() {
		return hibernateTemplate;
	}

	/**
	 * @param hibernateTemplate The hibernateTemplate to set.
	 */
	public void setHibernateTemplate(HibernateTemplate hibernateTemplate) {
		this.hibernateTemplate = hibernateTemplate;
	}

	
	public List find(GtoConflicts gtoConflict) throws DataAccessException {
		
		Object [] paramArray = new Object[5];
		paramArray[0] = gtoConflict.getId().getProgrammeId();
		paramArray[1] = gtoConflict.getId().getTargetId();
		paramArray[2] = gtoConflict.getId().getGtoId();
		paramArray[3] = gtoConflict.getTargetsDistance();
		paramArray[4] = gtoConflict.getExptimeRatio();
		
		List l = hibernateTemplate.findByNamedQuery("findGtoConflictsByProperties",paramArray);
		if(l.size() <=0) {
			throw new IllegalArgumentException("Not found");
		}
		return l;
		
	}
	
	
	/* (non-Javadoc)
	 * @see org.eso.ohs.persistence.dao.GtoObservationsDAO#find(org.eso.ohs.dfs.phase1.GtoObservations)
	 */
	public List findById(GtoConflicts gtoConflict)
			throws DataAccessException {
		
		
		Object [] paramArray = new Object[3];
		paramArray[0] = gtoConflict.getId().getProgrammeId();
		paramArray[1] = gtoConflict.getId().getTargetId();
		paramArray[2] = gtoConflict.getId().getGtoId();
		
		
		List l = hibernateTemplate.findByNamedQuery("findGtoConflictsById",paramArray);
		if(l.size() <=0) {
			throw new IllegalArgumentException("Not found");
		}
		return l;
		
	}

public List findByProgrammeId(Long programmeId) throws DataAccessException {
		
		Object [] paramArray = new Object[1];
		paramArray[0] = programmeId; 
		List l = hibernateTemplate.findByNamedQuery("findGtoConflictsByProgrammeId",paramArray);
		if(l.size() <=0) {
			throw new IllegalArgumentException("Not found");
		}
			
		return l;
	}
	


	/* (non-Javadoc)
	 * @see org.eso.ohs.persistence.dao.GtoObservationsDAO#create(org.eso.ohs.dfs.phase1.GtoObservations)
	 */
	public void create(GtoConflicts gtoConflict)
			throws DataAccessException {
		
		
		hibernateTemplate.saveOrUpdate(gtoConflict);
	

	}

	/* (non-Javadoc)
	 * @see org.eso.ohs.persistence.dao.GtoObservationsDAO#update(org.eso.ohs.dfs.phase1.GtoObservations)
	 */
	public void update(GtoConflicts gtoConflict)
			throws DataAccessException {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see org.eso.ohs.persistence.dao.GtoObservationsDAO#delete(org.eso.ohs.dfs.phase1.GtoObservations)
	 */
	public void delete(GtoConflicts gtoConflict)
			throws DataAccessException {
		
		hibernateTemplate.delete(gtoConflict);

	}

	

	

	

	

}
