/**
 * 
 */
package org.eso.ohs.persistence.dao;

import java.util.ArrayList;
import java.util.List;

import org.eso.ohs.dfs.phase1.GtoInstruments;
import org.eso.ohs.dfs.phase1.GtoManagers;
import org.springframework.dao.DataAccessException;
import org.springframework.orm.hibernate3.HibernateTemplate;

/**
 * @author fsogni
 *
 */
public class GtoInstrumentsDAOHibernate implements GtoInstrumentsDAO {

	private HibernateTemplate hibernateTemplate;


	/**
	 * @return Returns the hibernateTemplate.
	 */
	public HibernateTemplate getHibernateTemplate() {
		return hibernateTemplate;
	}

	/**
	 * @param hibernateTemplate The hibernateTemplate to set.
	 */
	public void setHibernateTemplate(HibernateTemplate hibernateTemplate) {
		this.hibernateTemplate = hibernateTemplate;
	}
	
	/* (non-Javadoc)
	 * @see org.eso.ohs.persistence.dao.GtoInstrumentsDAO#find(org.eso.ohs.dfs.phase1.InstrumentConfig)
	 */
	public List find(GtoManagers gtoManager)
			throws DataAccessException {
		List result = new ArrayList();
		
		Object [] paramArray = new Object[1];
		paramArray[0] = gtoManager.getId();		
		List l = hibernateTemplate.findByNamedQuery("findGtoInstrumentsByGtoManagerId",paramArray);
		if(l.size() >0) {
			result = l;
		}
		return result;
	}

	
	
	/* (non-Javadoc)
	 * @see org.eso.ohs.persistence.dao.GtoInstrumentsDAO#create(org.eso.ohs.dfs.phase1.InstrumentConfig)
	 */
	public void create(GtoInstruments gtoInstrument) throws DataAccessException {
		
		hibernateTemplate.save(gtoInstrument);

	}

	/* (non-Javadoc)
	 * @see org.eso.ohs.persistence.dao.GtoInstrumentsDAO#update(org.eso.ohs.dfs.phase1.InstrumentConfig)
	 */
	public void update(GtoInstruments gtoInstrument) throws DataAccessException {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see org.eso.ohs.persistence.dao.GtoInstrumentsDAO#delete(org.eso.ohs.dfs.phase1.InstrumentConfig)
	 */
	public void delete(GtoInstruments gtoInstrument) throws DataAccessException {
		
		hibernateTemplate.delete(gtoInstrument);

	}

}
