package org.eso.ohs.persistence.dao;

/**
 * This interface is the main interface to the title table in the user database
 * This table represents the db interface for the title business object.  
 */

import java.util.List;

import org.eso.ohs.dfs.account.Title;
import org.springframework.dao.DataAccessException;

public interface TitleDAO {
    
    /**
     * Get a list of title business objects. 
     * @return
     * @throws DataAccessException
     */
	public List getTitleList() throws DataAccessException;
    
    /**
     * Find  a title business object given a title name e.g. Dr. 
     * 
     * @param title
     * @return
     * @throws DataAccessException
     * @throws TitleNotFoundException
     */
    
    public Title find(String title) throws DataAccessException,TitleNotFoundException;
}
