package org.eso.ohs.persistence.service;

import org.eso.ohs.dfs.account.Account;
import org.eso.ohs.dfs.account.Profile;
import org.eso.ohs.persistence.dao.AccountDAO;
import org.eso.ohs.persistence.dao.AccountEmail;
import org.springframework.dao.DataAccessException;
import org.springframework.mail.MailException;

public class AccountServiceImpl implements AccountService {
	
	
	private AccountDAO accountDAO;
	
	private AccountEmail accountEmail;
	
	public AccountServiceImpl() {
	}

	public Account getAccount(Integer id) throws DataAccessException {
		return accountDAO.find(id);
	}

	public Account getAccount(String userName) throws DataAccessException {
		return accountDAO.find(userName);		
	}

	public Account getUserAndProfiles(String userName)
			throws DataAccessException {
		return accountDAO.findProfiles(userName);
	}

	public Profile findDefaultProfile(String userName)
			throws DataAccessException {
		return accountDAO.findDefaultProfile(userName);		
		
	}

	public void updateProfile(Profile accProfile)
			throws DataAccessException {
		accountDAO.updateProfile(accProfile);				
	}

	public void create(Account account) throws DataAccessException,MailException {		
	    accountDAO.create(account);
		accountEmail.sendAccountEmail(account);		
	}

	public void updateAccount(Account account) throws DataAccessException {
		accountDAO.updateAccount(account);
	}

	public void changePassword(Account account) throws DataAccessException {
		accountDAO.changePassword(account);
	}

	public void delete(Account account) throws DataAccessException {
		accountDAO.delete(account);
	}

	public boolean accountExists(String userName) throws DataAccessException {
		return accountDAO.accountExists(userName);
	}


	public Account getAccountRoles(String userName) throws DataAccessException {
		return accountDAO.getAccountRoles(userName);
	}

	public AccountDAO getAccountDAO() {
		return accountDAO;
	}

	public void setAccountDAO(AccountDAO accountDAO) {
		this.accountDAO = accountDAO;
	}

	public AccountEmail getAccountEmail() {
		return accountEmail;
	}

	public void setAccountEmail(AccountEmail accountEmail) {
		this.accountEmail = accountEmail;
	}

}
 