package org.eso.ohs.phase2.apps.p2ppAppServer;

import java.rmi.RemoteException;
import java.rmi.server.ServerNotActiveException;
import java.rmi.server.UnicastRemoteObject;
import java.sql.SQLException;

import org.eso.ohs.core.dbb.rmi.DbbRemoteEngine;
import org.eso.ohs.core.utilities.ObjectIOException;
import org.eso.ohs.persistence.Media;

/**
 * Returns a warning message for all getStorageManager() requests.
 * 
 * @version $Id: UpdateMsgAppServer.java,v 1.6 2004/02/17 14:31:56 tcanavan Exp $
 * <br>
 * @author Bob Kemp
 * 
 * @see AppServer
 */
public class UpdateMsgAppServer extends UnicastRemoteObject
					implements AppServerFactory {

    public UpdateMsgAppServer() throws RemoteException {
    }

		    // Obselete: Backwards compatibility only
    public RmiManagerInterface getStorageManager()
			    throws RemoteException,
				    ObjectIOException {
	return getStorageManager(null);
    }

    public RmiManagerInterface getStorageManager(Media device)
			    throws RemoteException,
				    ObjectIOException {
	try {
	    System.out.println("UpdateMsgAppServer: please update msg: "
				+ getClientHost());
	}
	catch (ServerNotActiveException e) {
	    e.printStackTrace();
	}

	throw new ObjectIOException(
	    "Your version of P2PP is no longer supported.\n"
	    + "Please upgrade to the most recent version.\n"
	    + "For further details, see http://www.eso.org/observing/p2pp/\n"
	);
    }

		    // Will be replaced by (eg) getDbbEngine(key)
    public DbbRemoteEngine getPhase1Engine()
			    throws SQLException, RemoteException {
	return null;
    }

		    // Will be replaced by (eg) getDbbEngine(key)
    public DbbRemoteEngine getPhase2Engine()
			    throws SQLException, RemoteException {
	return null;
    }


}

